package Example1Client;

import java.net.URL;


public class Example1Client {

    private CoreBroker.BrokerWrapper broker;
    private NDService.NDPortType nd;
    String SE;
        
    public void call(String wsami, String ndAddr, String paramVal) {       
        try {
            broker = CoreBroker.BrokerFactory.getClientInstance();
            nd = broker.getNDStub(ndAddr);
       
            NDService.GetServiceData[] services = nd.getService(wsami);
            if (services != null && services.length > 0) {
                for (int i=0; i<services.length; i++) {
                    String serviceEndPoint = services[i].getServiceEP();
                    String localCustEndPoint = services[i].getCustLocalEP();
                    String remoteCustEndPoint = services[i].getCustRemoteEP();
                    
                    System.out.println("Service found: "+ serviceEndPoint +" : "+
                            localCustEndPoint+" : "+remoteCustEndPoint);
                    
                    URL url = new URL(serviceEndPoint);
            
                    SE = serviceEndPoint;
            
                    Example1Service.Example1Interface service = 
                        new Example1Service.Example1SOAPBindingStub( url, null );

                    String ret = service.method1(paramVal);
            
                    System.out.println("\nReply is : "+ret);
                }
                
            } else
                System.out.println("\nNo service found.");
            
            return;
            
        } catch (Exception ex) {
            ex.printStackTrace();
            try {
                nd.invalidate(SE);
                call(wsami,ndAddr, paramVal);
            } catch (Exception ex2) {
                ex2.printStackTrace();
            }
        }
    }

    public static void main(String arg[])
    {
        Example1Client client = new Example1Client();
        String wsami = "http://localhost:8080/wsami/Example1Abstract.wsami";
        String ndAddr = "http://localhost:8080/services/ND";
        String param = "default";
        
        if (arg.length >= 1)
            param = arg[0];
        
        client.call(wsami,ndAddr, param);
    }

}

