package Example2Client;

import java.net.URL;


public class Example2Client {

   private CoreBroker.BrokerWrapper broker;
	
   public void call(String wsami, String ndAddr, String paramVal) {
        try {
            broker=CoreBroker.BrokerFactory.getClientInstance();
            NDService.NDPortType nd=broker.getNDStub(ndAddr);
			            
            NDService.GetServiceData[] services = nd.getService(wsami);
            if (services != null && services.length > 0) {
                for (int index=0; index<services.length; index++) {
                    String serviceEndPoint = services[index].getServiceEP();
                    String localCustEndPoint = services[index].getCustLocalEP();
                    String remoteCustEndPoint = services[index].getCustRemoteEP();
                    
                    System.out.println("Service found: "+ serviceEndPoint +" : "+
                            localCustEndPoint+" : "+remoteCustEndPoint);                        
	                    
                    URL url = new URL(serviceEndPoint);            
            
                    Example2Service.Example2Interface service = 
                        new Example2Service.Example2SOAPBindingStub( url, null );

                    //method invocation

                    //invocation of the getArrayOfString method
                    String[] arrayStr=service.getArrayOfString();
                    System.out.println("Invocation of the getArrayOfString method...");

                    for (int k=0;k<arrayStr.length;k++) {

                            System.out.println("The value of the item "+k+" is"+arrayStr[k]);
                    }   			


                    //invocation of the setArrayOfString method

                    System.out.println("Invocation of the getArrayOfString method...");

                    String[] arrayInput=new String[3];        	

                    arrayInput[0]=new String("String1");
                    arrayInput[1]=new String("String2");
                    arrayInput[2]=new String("String3");

                    service.setArrayOfString(arrayInput);


                    //invocation of the getTwoStrings method

                    System.out.println("Invocation of getTwoStrings method...");
                    javax.xml.rpc.holders.StringHolder strHolder1=new javax.xml.rpc.holders.StringHolder();
                    javax.xml.rpc.holders.StringHolder strHolder2=new javax.xml.rpc.holders.StringHolder();
                    service.getTwoStrings(strHolder1,strHolder2);

                    System.out.println("The first holder contains the following string: "+strHolder1.value);			
                    System.out.println("The second holder contains the following string: "+strHolder2.value);	


                    //invocation of the getTwoArraysOfString method		

                    System.out.println("Invocation of the getTwoArraysOfString method...");
                    Example2Service.holders.ArrayOfStringHolder arrayOfStringHolder1=new Example2Service.holders.ArrayOfStringHolder();
                    Example2Service.holders.ArrayOfStringHolder arrayOfStringHolder2=new Example2Service.holders.ArrayOfStringHolder();
                    service.getTwoArraysOfString(arrayOfStringHolder1,arrayOfStringHolder2);

                    System.out.println("The first arrayHolder contains an array that contains the following values:");

                    String[] arr1=arrayOfStringHolder1.value;
                    String[] arr2=arrayOfStringHolder2.value;

                    for (int i=0;i<arr1.length;i++) {
                            System.out.println(arr1[i]);
                    }

                    System.out.println("The second arrayHolder contains an array that contains the following values:");
                    for (int i=0;i<arr2.length;i++) {
                            System.out.println(arr2[i]);
                    }


                    //invocation of the setUserDefinedComplexType method
                    System.out.println("Invocation of the getUserDefinedComplexType method...");
                    Example2Service.UserDefinedComplexType uct1=service.getUserDefinedComplexType();

                    String firstPar=uct1.getFirstPar();
                    String[] secondPar=uct1.getSecondPar();
                    System.out.println("First parameter value is "+firstPar);

                    System.out.println("Second parameter is an array. It contains the following values:");

                    for (int k=0;k<secondPar.length;k++) {
                            System.out.println(secondPar[k]);
                    }	


                    //invocation of the setUserDefinedComplexType method

                    System.out.println("Invocation of the setUserDefinedComplexType method...");

                    Example2Service.UserDefinedComplexType udct2=new Example2Service.UserDefinedComplexType();
                    udct2.setFirstPar("String1");
                    String[] arrStr3=new String[3];
                    arrStr3[0]="string1";
                    arrStr3[1]="string2";
                    arrStr3[2]="string3";
                    udct2.setSecondPar(arrStr3);
                    service.setUserDefinedComplexType(udct2);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
   }

   public static void main (String arg[]) {
		
		Example2Client client=new Example2Client();
		String wsami="http://localhost:8080/wsami/Example2Abstract.wsami";
		String ndAddr="http://localhost:8080/services/ND";
		String param="default";
		
		if (arg.length>=1)
			 param=arg[0];
		client.call(wsami,ndAddr,param);	
	}

}//end class
	
	
			
			
			
			
			
			
			
			
