/**
 * CustRemoteImpl.java
 *
 * Receives the call and redirects it to the Movie web service
 */

package CustRemoteService;

import java.io.*;

public class CustRemoteImpl extends CoreBroker.BasicCustomizer implements CustRemoteService.CustRemoteInterface{

    boolean used = false;
    File videoFile = null;
    int id=-1; // id of movie used by this instance 
    FileInputStream fis = null;
    int cpt=0;
    public native void customize(String infile,String duration, String size, String outFile);
    
    public void getMovies(java.lang.String title, java.lang.String actor, java.lang.String director, int flag, MovieService.holders.ArrayOfIntHolder movieID, MovieService.holders.ArrayOfStringHolder movieList) throws java.rmi.RemoteException {   
	System.out.println("**********************CustRemote************************");
	String ws = getWS();
	try{
	    MovieService.MovieInterface service = new MovieService.MovieSOAPBindingStub(new java.net.URL(ws),null);   
	    System.out.println("RC calling getMovies...");
	    service.getMovies(title,actor,director,flag,movieID,movieList);
System.out.println("**********************End CustRemote************************");
	    return;
	}
	catch (Exception ex) {
	    ex.printStackTrace();
	    return;
	}

    }

    public String getMovieTrailer(int movieID, java.lang.String duration, java.lang.String size, java.lang.String outExtension) throws java.rmi.RemoteException {
	System.out.println("**********************CustRemote getMovieTrailer************************");
	try 
	    {
		
		System.out.println("Call received from LC.");
		String ws=getWS();
		System.out.println("getting WS instance.");
		MovieService.MovieInterface service = new MovieService.MovieSOAPBindingStub(new java.net.URL(ws),null);
		System.out.println("RC calling getMovieTrailer.....");
		String trailerURL = service.getMovieTrailer(movieID);
		if (trailerURL!=null) System.out.println(" File returned is ="+trailerURL);
		System.out.println("Video customization start.");
	        String trailerName = trailerURL.substring(trailerURL.lastIndexOf("/")+1);

                CoreBroker.BrokerWrapper broker = CoreBroker.BrokerFactory.getServerInstance();
                String wsamiBinDir = broker.getWSAMIBinDir();
                String trailersDir = System.getProperty("catalina.home")+"/webapps/ROOT/trailers/";               
                String trailerLocation = trailersDir+trailerName;
		String smallTrailerLocation = trailersDir+"small"+trailerName;
                
                
		Process p = java.lang.Runtime.getRuntime().exec(wsamiBinDir+"../../../services/CustRemote/ffmpeg  -i "+trailerLocation+" -t  100  -s  "+size+"  -y "+smallTrailerLocation); 
		InputStreamReader flux_entree = new InputStreamReader(p.getInputStream());
		BufferedReader entree = new BufferedReader(flux_entree);
		String ligne="";
		while ((ligne = entree.readLine()) != null) {
		    System.out.println(ligne);
		}
		//while (p.exitValue() !=0) {}
	       //Thread.sleep(10000);

		System.out.println("Video customization done.");
		
		
		System.out.println("File available in "+smallTrailerLocation);
                trailerURL = trailerURL.substring(0,trailerURL.lastIndexOf("/"));                
		trailerURL = trailerURL+"/small"+trailerName;
		System.out.println("**********************End CustRemote getMovieTrailer************************");
		return trailerURL;
		
	    }
	catch (Exception ex)
	    {
		ex.printStackTrace();
	    }
	return null;
    }
    
  
     public String getAudioCriticisms(int movieID) throws java.rmi.RemoteException {
	try
	    {
		String ws = getWS();
		MovieService.MovieInterface service = new MovieService.MovieSOAPBindingStub(new java.net.URL(ws),null);      
		return service.getAudioCriticisms(movieID);
	    }
	catch(Exception ex) {
	    ex.printStackTrace();
	}
	return null;
    }
    
public String getTextCriticisms(int movieID) throws java.rmi.RemoteException {
    try
	{
	    String ws = getWS();
	    MovieService.MovieInterface service = new MovieService.MovieSOAPBindingStub(new java.net.URL(ws),null);      
	    return service.getTextCriticisms(movieID);
	}
    catch(Exception ex) {
	    ex.printStackTrace();
    }
    return null;
}
 
    
    public int bookTicket(java.lang.String firstName, java.lang.String lastName, int scheduleID, int numSeats) throws java.rmi.RemoteException {
	
	String ws=getWS();
	int ret=0;
	try 
	    {
		MovieService.MovieInterface service = new MovieService.MovieSOAPBindingStub(new java.net.URL(ws),null);      
		System.out.println("RC calling bookTicket.......");
		ret=service.bookTicket(firstName,lastName,scheduleID,numSeats);
		return ret;
	    }
	catch (Exception ex) {
	    ex.printStackTrace();
	    return 0;
	}
    }
    
    
    public void getMovieInfo(int movieID, java.util.Calendar fromDate, java.util.Calendar fromTime, java.util.Calendar toDate, java.util.Calendar toTime, MovieService.holders.ArrayOfIntHolder scheduleIDList, MovieService.holders.ArrayOfStringHolder cityList, MovieService.holders.ArrayOfStringHolder addressList, MovieService.holders.ArrayOfIntHolder roomList, MovieService.holders.ArrayOfDateTimeHolder dateList, MovieService.holders.ArrayOfDateTimeHolder timeList) throws java.rmi.RemoteException {

	String ws=getWS();
	try 
	    {
		MovieService.MovieInterface service = new MovieService.MovieSOAPBindingStub(new java.net.URL(ws),null);      
		System.out.println("RC calling getMovieInfo.....");
		service.getMovieInfo(movieID,fromDate,fromTime,toDate,toTime,scheduleIDList,cityList,addressList,roomList,dateList,timeList);
		return;
	    }
	catch (Exception ex) {
	    ex.printStackTrace();
	    return;
	}
    }

    public void  addTo(byte[] source, byte[] dest, int len)
    {
	byte[] tmp = new byte[dest.length];
	int i;
	for (i=0;i<dest.length;i++) tmp[i] = dest[i];
	dest = new byte[tmp.length+len];
	for (i=0;i<tmp.length;i++) dest[i] = tmp[i];
	for (i=0;i<len;i++) dest[i+tmp.length] = source[i];
	System.out.println("dest.length="+dest.length);
    } 

}
