package OzoneMessengerService;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import java.util.Iterator;
import java.util.Calendar;
import java.util.Date;

public class OzoneMessengerFrame extends Frame 
{
    // Ozone Messenger Application
    OzoneMessengerImpl messenger = null;
    Panel pane              = new Panel();
    Panel paneFriends       = new Panel();
    TextField fieldMessage  = new TextField("");
    Button buttonSend       = new Button("    Send    ");
    Button buttonFriendsList= new Button("Friends List");
    Label labelNickname     = new Label("");
    Label labelFriends      = new Label("Online");
    //List lstMessages        = new List(6,false);
    MessageArea lstMessages        = new MessageArea("",6,18,TextArea.SCROLLBARS_VERTICAL_ONLY);
    // MessageArea lstMessages        = new MessageArea();
    OzoneMessengerList lstFriends         = new OzoneMessengerList(this,4,true);

    // information frame
    Dialog information          = new Dialog(this, "information");
    Button iok             = new Button("Ok ");
    Label imess1             = new Label("");
    Label imess2             = new Label("");
  
    // autorization frame
    Dialog autoriz          = new Dialog(this, "Autorization");
    Button byes             = new Button("Yes ");
    Button bno              = new Button(" No ");
    Label mess1             = new Label("");
    Label mess2             = new Label("");

    // newUser frame
   
    Dialog newUser                = new Dialog(this, "Add user");
    Label labelUserServiceURL     = new Label("Service URL");
    TextField fieldUserServiceURL = new TextField("");
    Label labelUserName           = new Label("Name ");
    TextField fieldUserName       = new TextField("");
    Label labelUserNickname       = new Label("Nickname");
    TextField fieldUserNickname   = new TextField("");
    Button bok                    = new Button("  Ok  ");
    Button bcancel                = new Button("Cancel");

    // Friends List
    Dialog friends                = new Dialog(this, "Friends List");
    List flist                    = new List(6,false);
    Button fok                    = new Button("  Ok  ");
    Button fcancel                = new Button("Cancel");
    Button fadd                   = new Button(" Add  ");
    Button fdelete                = new Button("Delete");
    Button fmodify                = new Button("Modify");
    Vector serviceURLs = new Vector();
    Vector nicknames = new Vector();

    // new Friend
    Dialog newFriend                = new Dialog(this, "Add new friend");
    Label labelFriendServiceURL     = new Label("Service URL");
    TextField fieldFriendServiceURL = new TextField("");
    Label labelFriendNickname       = new Label("Nickname");
    TextField fieldFriendNickname   = new TextField("");
    Button nfok                     = new Button("  Ok  ");
    Button nfcancel                 = new Button("Cancel");

    boolean autorization = false;    
    boolean addNewUser = false;
    boolean modifFriend = true;
    int  lastItemIndex = -1;
    String nickname="";

    // end graphical interface 

    public OzoneMessengerFrame(OzoneMessengerImpl Messenger) 
    {
	messenger = Messenger;
	// init graphical panel

	paneFriends.setSize(new Dimension(40,120));
	GridBagLayout gbl1 = new GridBagLayout();
	paneFriends.setLayout(gbl1);

	GridBagConstraints gbc1 = new GridBagConstraints();
	gbc1.fill = GridBagConstraints.NONE;
	gbc1.gridwidth = GridBagConstraints.REMAINDER;
	gbc1.gridheight = 1;
	//gbc1.anchor = GridBagConstraints.NORTHWEST;
	gbc1.anchor = GridBagConstraints.CENTER;
	gbc1.weightx = 1.0;
	gbc1.weighty = 1.0;
	gbc1.insets = new Insets(4,5,2,2);

	gbl1.setConstraints(labelFriends,gbc1);
	paneFriends.add(labelFriends);

	lstFriends.setSize(30,100);
	GridBagConstraints gbc2 = new GridBagConstraints();
	gbc2.fill = GridBagConstraints.VERTICAL;
	gbc2.gridwidth = 1;
	gbc2.gridheight = 1;
	//gbc2.anchor = GridBagConstraints.NORTHWEST;
	gbc2.anchor = GridBagConstraints.CENTER;
	gbc2.weightx = 1.0;
	gbc2.weighty = 1.0;
	gbc2.insets = new Insets(2,2,5,2);

	//lstFriends .setBackground(Color.yellow);
	gbl1.setConstraints(lstFriends,gbc2);
	paneFriends.add(lstFriends);

	// globle pan

	Font font = labelNickname.getFont();
	if (font != null)
	    {
		Font font2 = new Font(font.getName(), Font.BOLD, font.getSize());
		labelNickname.setFont(font2);
	    }
	labelNickname.setBackground( new Color(0,155,140));
	labelNickname.setForeground(Color.black);
	GridBagLayout gbl2 = new GridBagLayout();
	pane.setLayout(gbl2);

	GridBagConstraints gbc3 = new GridBagConstraints();
	gbc3.fill = GridBagConstraints.NONE;
	gbc3.gridwidth = GridBagConstraints.REMAINDER;
	gbc3.gridheight =1 ;
	gbc3.anchor = GridBagConstraints.SOUTHWEST;
	gbc3.weightx = 1.0;
	gbc3.weighty = 1.0;
    	gbc3.insets = new Insets(5,5,2,2);
	
	gbl2.setConstraints(labelNickname,gbc3);
	pane.add(labelNickname);

	GridBagConstraints gbc4 = new GridBagConstraints();
	gbc4.fill = GridBagConstraints.BOTH;
	gbc4.gridwidth  = 8;
	gbc4.gridheight = 4 ;
	gbc4.anchor = GridBagConstraints.CENTER;
	gbc4.weightx = 1.0;
	gbc4.weighty = 1.0;
	gbc4.insets = new Insets(1,5,5,1);

	//lstMessages.setBackground(Color.red);
	lstMessages.setForeground(new Color(0,0,110));
	gbl2.setConstraints(lstMessages,gbc4);
	pane.add(lstMessages);

	GridBagConstraints gbc5 = new GridBagConstraints();
	gbc5.fill = GridBagConstraints.NONE;
	gbc5.gridwidth = GridBagConstraints.REMAINDER;
	gbc5.gridheight = 4 ;
	gbc5.anchor = GridBagConstraints.NORTH;
	gbc5.weightx = 1.0;
	gbc5.weighty = 1.0;
	gbc5.insets = new Insets(2,5,2,2);
	gbl2.setConstraints(paneFriends,gbc5);
	pane.add(paneFriends);
	
	GridBagConstraints gbc6 = new GridBagConstraints();
	gbc6.fill = GridBagConstraints.BOTH;
	gbc6.gridwidth = 8;
	gbc6.gridheight =2 ;
	gbc6.anchor = GridBagConstraints.CENTER;
	gbc6.weightx = 1.0;
	gbc6.weighty = 1.0;
	gbc6.insets = new Insets(2,5,3,1);

	fieldMessage.setForeground(new Color(0, 0, 110));
	gbl2.setConstraints(fieldMessage,gbc6);
	pane.add(fieldMessage);

	GridBagConstraints gbc7 = new GridBagConstraints();
	gbc7.fill = GridBagConstraints.VERTICAL;
	gbc7.gridwidth =  GridBagConstraints.REMAINDER;
	gbc7.gridheight = 2 ;
	gbc7.anchor = GridBagConstraints.CENTER;
	gbc7.weightx = 1.0;
	gbc7.weighty = 1.0;
	gbc7.insets = new Insets(2,6,3,5);
    
	gbl2.setConstraints(buttonSend,gbc7);
	buttonSend.setBackground(Color.green);
	pane.add(buttonSend);

	GridBagConstraints gbc11 = new GridBagConstraints();
	gbc11.fill = GridBagConstraints.BOTH;
	gbc11.gridwidth =  GridBagConstraints.REMAINDER;
	gbc11.gridheight = GridBagConstraints.REMAINDER ;
	gbc11.anchor = GridBagConstraints.NORTHWEST;
	gbc11.weightx = 1.0;
	gbc11.weighty = 1.0;
	gbc11.insets = new Insets(3,5,5,5);

	gbl2.setConstraints(buttonFriendsList,gbc11);
	pane.add(buttonFriendsList);

	this.setTitle("Ozone Messenger");
	this.setSize(480,458);
	//this.setLocation(3,18);
	this.add(pane);

	// information
	information.setSize(450,200);
	information.setLocation(20,30);


	Panel ipanb = new Panel();

	GridBagLayout igbl7 = new GridBagLayout();
	ipanb.setLayout(igbl7);

	GridBagConstraints igbc24 = new GridBagConstraints();
	igbc24.fill = GridBagConstraints.BOTH;
	igbc24.gridwidth  = GridBagConstraints.REMAINDER ;
	igbc24.gridheight = GridBagConstraints.REMAINDER;
	igbc24.anchor = GridBagConstraints.CENTER;
	igbc24.weightx = 1.0;
	igbc24.weighty = 1.0;
    	igbc24.insets = new Insets(4,15,5,15);
	
	iok.setBackground(Color.green);
	igbl7.setConstraints(iok,igbc24);
	ipanb.add(iok);

	Panel ipan = new Panel();
	GridBagLayout igbl8 = new GridBagLayout();
        ipan.setLayout(igbl8);

	GridBagConstraints igbc26 = new GridBagConstraints();
	igbc26.fill = GridBagConstraints.BOTH;
	igbc26.gridwidth = GridBagConstraints.REMAINDER;
	igbc26.gridheight =1;
	igbc26.anchor = GridBagConstraints.CENTER;
	igbc26.weightx = 1.0;
	igbc26.weighty = 1.0;
    	igbc26.insets = new Insets(5,5,1,5);

	igbl8.setConstraints(imess1,igbc26);
	ipan.add(imess1);

	GridBagConstraints igbc27 = new GridBagConstraints();
	igbc27.fill = GridBagConstraints.BOTH;
	igbc27.gridwidth = GridBagConstraints.REMAINDER;
	igbc27.gridheight =1;
	igbc27.anchor = GridBagConstraints.CENTER;
	igbc27.weightx = 1.0;
	igbc27.weighty = 1.0;
    	igbc27.insets = new Insets(1,5,5,5);

	igbl8.setConstraints(imess2,igbc27);
	ipan.add(imess2);


	GridBagConstraints igbc29 = new GridBagConstraints();
	igbc29.fill = GridBagConstraints.BOTH;
	igbc29.gridwidth = GridBagConstraints.REMAINDER;
	igbc29.gridheight =1;
	igbc29.anchor = GridBagConstraints.CENTER;
	igbc29.weightx = 1.0;
	igbc29.weighty = 1.0;
    	igbc29.insets = new Insets(5,5,5,5);

	igbl8.setConstraints(ipanb,igbc29);
	ipan.add(ipanb);
	
	information.add(ipan);
	information.setModal(true);


	// autoriz	
	autoriz.setSize(450,200);
	autoriz.setLocation(20,30);


	Panel panb = new Panel();

	GridBagLayout gbl7 = new GridBagLayout();
	panb.setLayout(gbl7);

	GridBagConstraints gbc24 = new GridBagConstraints();
	gbc24.fill = GridBagConstraints.BOTH;
	gbc24.gridwidth = 1;
	gbc24.gridheight =GridBagConstraints.REMAINDER;
	gbc24.anchor = GridBagConstraints.CENTER;
	gbc24.weightx = 1.0;
	gbc24.weighty = 1.0;
    	gbc24.insets = new Insets(3,5,5,5);
	
	byes.setBackground(Color.green);
	gbl7.setConstraints(byes,gbc24);
	panb.add(byes);

	GridBagConstraints gbc25 = new GridBagConstraints();
	gbc25.fill = GridBagConstraints.BOTH;
	gbc25.gridwidth = 1;
	gbc25.gridheight =GridBagConstraints.REMAINDER;
	gbc25.anchor = GridBagConstraints.CENTER;
	gbc25.weightx = 1.0;
	gbc25.weighty = 1.0;
    	gbc25.insets = new Insets(3,5,5,5);

	bno.setBackground(Color.green);
	gbl7.setConstraints(bno,gbc25);
	panb.add(bno);
 
	//Panel panl = new Panel();
	//panl.add(mess);


	Panel pan = new Panel();
	GridBagLayout gbl8 = new GridBagLayout();
        pan.setLayout(gbl8);

	GridBagConstraints gbc26 = new GridBagConstraints();
	gbc26.fill = GridBagConstraints.BOTH;
	gbc26.gridwidth = GridBagConstraints.REMAINDER;
	gbc26.gridheight =1;
	gbc26.anchor = GridBagConstraints.CENTER;
	gbc26.weightx = 1.0;
	gbc26.weighty = 1.0;
    	gbc26.insets = new Insets(5,5,1,5);

	gbl8.setConstraints(mess1,gbc26);
	pan.add(mess1);

	GridBagConstraints gbc27 = new GridBagConstraints();
	gbc27.fill = GridBagConstraints.BOTH;
	gbc27.gridwidth = GridBagConstraints.REMAINDER;
	gbc27.gridheight =1;
	gbc27.anchor = GridBagConstraints.CENTER;
	gbc27.weightx = 1.0;
	gbc27.weighty = 1.0;
    	gbc27.insets = new Insets(1,5,5,5);

	gbl8.setConstraints(mess2,gbc27);
	pan.add(mess2);


	GridBagConstraints gbc29 = new GridBagConstraints();
	gbc29.fill = GridBagConstraints.BOTH;
	gbc29.gridwidth = GridBagConstraints.REMAINDER;
	gbc29.gridheight =1;
	gbc29.anchor = GridBagConstraints.CENTER;
	gbc29.weightx = 1.0;
	gbc29.weighty = 1.0;
    	gbc29.insets = new Insets(5,5,5,5);

	gbl8.setConstraints(panb,gbc29);
	pan.add(panb);

	autoriz.add(pan);
	autoriz.setModal(true);


	newUser.setSize(450,250);
	newUser.setLocation(20,30);


	GridBagLayout gbl11 = new GridBagLayout();
	Panel panNewUserButton = new Panel();
	panNewUserButton.setLayout(gbl11);

	GridBagConstraints gbc38 = new GridBagConstraints();
	gbc38.fill = GridBagConstraints.BOTH;
	gbc38.gridwidth  = 1;
	gbc38.gridheight = GridBagConstraints.REMAINDER;
	gbc38.anchor     = GridBagConstraints.CENTER;
	gbc38.weightx    = 1.0;
	gbc38.weighty    = 1.0;
	gbc38.insets = new Insets(4,10,4,5);

	bok.setBackground(Color.green);
	gbl11.setConstraints(bok,gbc38);
	panNewUserButton.add(bok);

	GridBagConstraints gbc39 = new GridBagConstraints();
	gbc39.fill = GridBagConstraints.BOTH;
	gbc39.gridwidth  = 1;
	gbc39.gridheight = GridBagConstraints.REMAINDER;
	gbc39.anchor     = GridBagConstraints.CENTER;
	gbc39.weightx    = 1.0;
	gbc39.weighty    = 1.0;
	gbc39.insets = new Insets(4,5,4,10);

	bcancel.setBackground(Color.green);
	gbl11.setConstraints(bcancel,gbc39);
	panNewUserButton.add(bcancel);

	Panel panNewUser = new Panel();
	GridBagLayout gbl10 = new GridBagLayout();
	panNewUser.setLayout(gbl10);

	GridBagConstraints gbc30 = new GridBagConstraints();
	gbc30.fill = GridBagConstraints.BOTH;
	gbc30.gridwidth  = 1;
	gbc30.gridheight = 1;
	gbc30.anchor     = GridBagConstraints.CENTER;
	gbc30.weightx    = 1.0;
	gbc30.weighty    = 1.0;
	gbc30.insets = new Insets(5,5,2,2);

	gbl10.setConstraints(labelUserServiceURL, gbc30);
	panNewUser.add(labelUserServiceURL);

	GridBagConstraints gbc31 = new GridBagConstraints();
	gbc31.fill = GridBagConstraints.BOTH;
	gbc31.gridwidth  = GridBagConstraints.REMAINDER;
	gbc31.gridheight = 1;
	gbc31.anchor     = GridBagConstraints.CENTER;
	gbc31.weightx    = 1.0;
	gbc31.weighty    = 1.0;
	gbc31.insets = new Insets(5,2,2,5);

	gbl10.setConstraints(fieldUserServiceURL, gbc31);
	panNewUser.add(fieldUserServiceURL);

	GridBagConstraints gbc32 = new GridBagConstraints();
	gbc32.fill = GridBagConstraints.BOTH;
	gbc32.gridwidth  = 1;
	gbc32.gridheight = 1;
	gbc32.anchor     = GridBagConstraints.CENTER;
	gbc32.weightx    = 1.0;
	gbc32.weighty    = 1.0;
	gbc32.insets = new Insets(2,5,2,2);

	gbl10.setConstraints(labelUserName, gbc32);
	panNewUser.add(labelUserName);

	GridBagConstraints gbc33 = new GridBagConstraints();
	gbc33.fill = GridBagConstraints.BOTH;
	gbc33.gridwidth  = GridBagConstraints.REMAINDER;
	gbc33.gridheight = 1;
	gbc33.anchor     = GridBagConstraints.CENTER;
	gbc33.weightx    = 1.0;
	gbc33.weighty    = 1.0;
	gbc33.insets = new Insets(2,2,2,5);

	gbl10.setConstraints(fieldUserName, gbc33);
	panNewUser.add(fieldUserName);

	GridBagConstraints gbc34 = new GridBagConstraints();
	gbc34.fill = GridBagConstraints.BOTH;
	gbc34.gridwidth  = 1;
	gbc34.gridheight = 1;
	gbc34.anchor     = GridBagConstraints.CENTER;
	gbc34.weightx    = 1.0;
	gbc34.weighty    = 1.0;
	gbc34.insets = new Insets(2,5,2,2);

	gbl10.setConstraints(labelUserNickname, gbc34);
	panNewUser.add(labelUserNickname);

	GridBagConstraints gbc35 = new GridBagConstraints();
	gbc35.fill = GridBagConstraints.BOTH;
	gbc35.gridwidth  = GridBagConstraints.REMAINDER;
	gbc35.gridheight = 1;
	gbc35.anchor     = GridBagConstraints.CENTER;
	gbc35.weightx    = 1.0;
	gbc35.weighty    = 1.0;
	gbc35.insets = new Insets(2,2,2,5);

	gbl10.setConstraints(fieldUserNickname, gbc35);
	panNewUser.add(fieldUserNickname);

	GridBagConstraints gbc36 = new GridBagConstraints();
	gbc36.fill = GridBagConstraints.BOTH;
	gbc36.gridwidth  = GridBagConstraints.REMAINDER;
	gbc36.gridheight = 1;
	gbc36.anchor     = GridBagConstraints.CENTER;
	gbc36.weightx    = 1.0;
	gbc36.weighty    = 1.0;
	gbc36.insets = new Insets(5,5,2,5);

	gbl10.setConstraints(panNewUserButton, gbc36);
	panNewUser.add(panNewUserButton);
	/*
	GridBagConstraints gbc37 = new GridBagConstraints();
	gbc37.fill = GridBagConstraints.BOTH;
	gbc37.gridwidth  = 1;
	gbc37.gridheight = 1;
	gbc37.anchor     = GridBagConstraints.CENTER;
	gbc37.weightx    = 1.0;
	gbc37.weighty    = 1.0;
	gbc37.insets = new Insets(2,2,2,5);

	gbl10.setConstraints(bcancel, gbc37);
	panNewUser.add(bcancel);
	*/
	newUser.add(panNewUser);
	newUser.setModal(true);


	friends.setSize(450,300);
	friends.setLocation(20,30);

	//Panel panListButton = new Panel();
	//panListButton.setLayout(new GridLayout(3,1,10,10));
	//panListButton.add(fadd);
	//panListButton.add(fdelete);
	//panListButton.add(fmodify);

	GridBagLayout gbl5 = new GridBagLayout();
	Panel panListButton = new Panel();
	panListButton.setLayout(gbl5);

	GridBagConstraints gbc14 = new GridBagConstraints();
	gbc14.fill = GridBagConstraints.BOTH;
	gbc14.gridwidth  = GridBagConstraints.REMAINDER;
	gbc14.gridheight = 1;
	gbc14.anchor     = GridBagConstraints.CENTER;
	gbc14.weightx    = 1.0;
	gbc14.weighty    = 1.0;
	gbc14.insets = new Insets(5,5,2,5);

	fadd.setBackground(Color.lightGray);
	gbl5.setConstraints(fadd,gbc14);
	panListButton.add(fadd);

	GridBagConstraints gbc15 = new GridBagConstraints();
	gbc15.fill = GridBagConstraints.BOTH;
	gbc15.gridwidth  = GridBagConstraints.REMAINDER;
	gbc15.gridheight = 1;
	gbc15.anchor     = GridBagConstraints.CENTER;
	gbc15.weightx    = 1.0;
	gbc15.weighty    = 1.0;
	gbc15.insets = new Insets(2,5,2,5);

	fdelete.setBackground(Color.lightGray);
	gbl5.setConstraints(fdelete,gbc15);
	panListButton.add(fdelete);

	GridBagConstraints gbc16 = new GridBagConstraints();
	gbc16.fill = GridBagConstraints.BOTH;
	gbc16.gridwidth  = GridBagConstraints.REMAINDER;
	gbc16.gridheight = 1;
	gbc16.anchor     = GridBagConstraints.CENTER;
	gbc16.weightx    = 1.0;
	gbc16.weighty    = 1.0;
	gbc16.insets = new Insets(2,5,5,5);

	fmodify.setBackground(Color.lightGray);
	gbl5.setConstraints(fmodify,gbc16);
	panListButton.add(fmodify);

	//Panel panFriendsButton = new Panel();
	//panFriendsButton.setLayout(new GridLayout(1,2,10,10));
	//panFriendsButton.add(fok);
	//panFriendsButton.add(fcancel);

	GridBagLayout gbl4 = new GridBagLayout();
	Panel panFriendsButton = new Panel();
	panFriendsButton.setLayout(gbl4);

	GridBagConstraints gbc12 = new GridBagConstraints();
	gbc12.fill = GridBagConstraints.BOTH;
	gbc12.gridwidth  = 1;
	gbc12.gridheight = GridBagConstraints.REMAINDER;
	gbc12.anchor     = GridBagConstraints.CENTER;
	gbc12.weightx    = 1.0;
	gbc12.weighty    = 1.0;
	gbc12.insets = new Insets(5,5,5,5);

	fok.setBackground(Color.green);
	gbl4.setConstraints(fok,gbc12);
	panFriendsButton.add(fok);

	GridBagConstraints gbc13 = new GridBagConstraints();
	gbc13.fill = GridBagConstraints.BOTH;
	gbc13.gridwidth  = 1;
	gbc13.gridheight = GridBagConstraints.REMAINDER;
	gbc13.anchor     = GridBagConstraints.CENTER;
	gbc13.weightx    = 1.0;
	gbc13.weighty    = 1.0;
	gbc13.insets = new Insets(5,5,5,5);

	fcancel.setBackground(Color.green);
	gbl4.setConstraints(fcancel,gbc13);
	panFriendsButton.add(fcancel);

	

	Panel panFriendsList = new Panel();
	GridBagLayout gbl3 = new GridBagLayout();
	
	panFriendsList.setLayout(gbl3);

	GridBagConstraints gbc8 = new GridBagConstraints();
	gbc8.fill = GridBagConstraints.BOTH;
	gbc8.gridwidth  = 3;
	gbc8.gridheight = 6;
	gbc8.anchor     = GridBagConstraints.NORTHWEST;
	gbc8.weightx    = 1.0;
	gbc8.weighty    = 1.0;
	gbc8.insets = new Insets(5,5,5,5);

	gbl3.setConstraints(flist,gbc8);
	panFriendsList.add(flist);

	GridBagConstraints gbc9 = new GridBagConstraints();
	gbc9.fill = GridBagConstraints.BOTH;
	gbc9.gridwidth  = GridBagConstraints.REMAINDER ;
	gbc9.gridheight = 6;
	gbc9.anchor     = GridBagConstraints.NORTHWEST;
	gbc9.weightx    = 1.0;
	gbc9.weighty    = 1.0;
	gbc9.insets = new Insets(5,5,5,5);

	gbl3.setConstraints(panListButton,gbc9);
	panFriendsList.add(panListButton);

	GridBagConstraints gbc10 = new GridBagConstraints();
	gbc10.fill = GridBagConstraints.BOTH;
	gbc10.gridwidth  = GridBagConstraints.REMAINDER ;
	gbc10.gridheight = GridBagConstraints.REMAINDER;
	gbc10.anchor     = GridBagConstraints.NORTHWEST;
	gbc10.weightx    = 1.0;
	gbc10.weighty    = 1.0;
	gbc10.insets = new Insets(5,5,15,5);

	gbl3.setConstraints(panFriendsButton,gbc10);
	panFriendsList.add(panFriendsButton);

	friends.add(panFriendsList);
	friends.setModal(true);

	newFriend.setSize(450,200);
	newFriend.setLocation(20,30);


	Panel panNewFriendButton = new Panel();
	GridBagLayout gbl9 = new GridBagLayout();
	panNewFriendButton.setLayout(gbl9);

	GridBagConstraints gbc21 = new GridBagConstraints();
	gbc21.fill = GridBagConstraints.BOTH;
	gbc21.gridwidth  = 1;
	gbc21.gridheight = 1;
	gbc21.anchor     = GridBagConstraints.NORTHWEST;
	gbc21.weightx    = 1.0;
	gbc21.weighty    = 1.0;
	gbc21.insets = new Insets(2,5,2,2);

	nfok.setBackground(Color.green);
	gbl9.setConstraints(nfok,gbc21);
	panNewFriendButton.add(nfok);

	GridBagConstraints gbc22 = new GridBagConstraints();
	gbc22.fill = GridBagConstraints.BOTH;
	gbc22.gridwidth  = GridBagConstraints.REMAINDER;
	gbc22.gridheight = 1;
	gbc22.anchor     = GridBagConstraints.NORTHWEST;
	gbc22.weightx    = 1.0;
	gbc22.weighty    = 1.0;
	gbc22.insets = new Insets(2,2,2,5);

	nfcancel.setBackground(Color.green);
	gbl9.setConstraints(nfcancel,gbc22);
	panNewFriendButton.add(nfcancel);




	Panel panNewFriend = new Panel();
	GridBagLayout gbl6 = new GridBagLayout();
	panNewFriend.setLayout(gbl6);

	GridBagConstraints gbc17 = new GridBagConstraints();
	gbc17.fill = GridBagConstraints.BOTH;
	gbc17.gridwidth  = 1;
	gbc17.gridheight = 1;
	gbc17.anchor     = GridBagConstraints.NORTHWEST;
	gbc17.weightx    = 1.0;
	gbc17.weighty    = 1.0;
	gbc17.insets = new Insets(5,5,2,1);

	gbl6.setConstraints(labelFriendServiceURL,gbc17);
	panNewFriend.add(labelFriendServiceURL);
	
	GridBagConstraints gbc18 = new GridBagConstraints();
	gbc18.fill = GridBagConstraints.BOTH;
	gbc18.gridwidth  = GridBagConstraints.REMAINDER;
	gbc18.gridheight = 1;
	gbc18.anchor     = GridBagConstraints.NORTHWEST;
	gbc18.weightx    = 2.0;
	gbc18.weighty    = 1.0;
	gbc18.insets = new Insets(5,1,2,2);

	gbl6.setConstraints(fieldFriendServiceURL,gbc18);
	panNewFriend.add(fieldFriendServiceURL);

	GridBagConstraints gbc19 = new GridBagConstraints();
	gbc19.fill = GridBagConstraints.BOTH;
	gbc19.gridwidth  = 1;
	gbc19.gridheight = 1;
	gbc19.anchor     = GridBagConstraints.NORTHWEST;
	gbc19.weightx    = 1.0;
	gbc19.weighty    = 1.0;
	gbc19.insets = new Insets(2,5,2,1);

	gbl6.setConstraints(labelFriendNickname,gbc19);
	panNewFriend.add(labelFriendNickname);

	GridBagConstraints gbc20 = new GridBagConstraints();
	gbc20.fill = GridBagConstraints.BOTH;
	gbc20.gridwidth  = GridBagConstraints.REMAINDER;
	gbc20.gridheight = 1;
	gbc20.anchor     = GridBagConstraints.NORTHWEST;
	gbc20.weightx    = 2.0;
	gbc20.weighty    = 1.0;
	gbc20.insets = new Insets(2,1,2,2);

	gbl6.setConstraints(fieldFriendNickname,gbc20);
	panNewFriend.add(fieldFriendNickname);

	GridBagConstraints gbc23 = new GridBagConstraints();
	gbc23.fill = GridBagConstraints.BOTH;
	gbc23.gridwidth  = GridBagConstraints.REMAINDER;
	gbc23.gridheight = GridBagConstraints.REMAINDER;
	gbc23.anchor     = GridBagConstraints.NORTHWEST;
	gbc23.weightx    = 1.0;
	gbc23.weighty    = 1.0;
	gbc23.insets = new Insets(5,5,5,5);

	gbl6.setConstraints(panNewFriendButton,gbc23);
	panNewFriend.add(panNewFriendButton);
 
	newFriend.add(panNewFriend);
	newFriend.setModal(true);

	bok.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    addUser();
		}
	    });

	bcancel.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    noAddUser();
		}
	    });

	byes.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    autorizYes();
		}
	    });

	bno.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    autorizNo();
		}
	    });

	iok.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    informationOk();
		}
	    });

	buttonSend.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    sendFunction();
		}
	    });

	buttonFriendsList.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    showFriendsList();
		}
	    });
	
	lstFriends.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    sendFile();
		}
	    });
	/*
	lstFriends.addItemListener(new ItemListener() {
		public void itemStateChanged(ItemEvent e) {
		    saveLastItem();
		}    
	    }); 
	
	lstFriends.processKeyEvent(KeyEvent e)
	    {
		lstFriendsFunction(e);
	    }

	// to send file
	


	lstFriends.addKeyListener(new java.awt.event.KeyListener() {
		public void keyTyped(KeyEvent e) {}
		public void keyPressed(KeyEvent e) {}
		public void keyReleased(KeyEvent e) {
		    lstFriendsFunction(e);
		}

	    });
	*/
	fok.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    fokFunction();
		}
	    });
	
	fcancel.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    fcancelFunction();
		}
	    });
	
	fadd.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		faddFunction();
		}
	    });
	
	fdelete.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    fdeleteFunction();
		}
	    });
	
	fmodify.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    fmodifyFunction();
		}
	    });

 	nfok.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    nfokFunction();
		}
	    });
	
	nfcancel.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    nfcancelFunction();
		}
	    });


	this.addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent evt) {
		    messenger.closeWindow();
		}
            });


	setNickname(messenger.getNickname());
	showFriends();
	repaint();
	fieldMessage.requestFocus();
    } 

    public void setNickname(String nickname)
    {
	// set Nickname Label
	this.nickname = nickname;
	labelNickname.setText("  "+nickname);
    }

    public void showFriends()
    {
	// show all users
	lstFriends.removeAll();         
	Iterator nicknames = messenger.getConnectedNicknames();
	while (nicknames.hasNext())
	lstFriends.add((String)nicknames.next());
	fieldMessage.requestFocus();
    }

    private void sendFunction()
    {
	if (!fieldMessage.getText().equals(""))
	    {
		//for all selected item send message 
		Calendar currentDate = Calendar.getInstance();
		currentDate.setTime(new Date(System.currentTimeMillis()));
		String[] items = lstFriends.getSelectedItems();
		String messageToSend =  fieldMessage.getText();
		fieldMessage.setText("");
		showMessage(nickname, messageToSend, currentDate);
		if (items !=null && items.length>0)
		    for (int i=0; i<items.length;i++)
			messenger.send(messageToSend,currentDate, items[i]);
		else messenger.sendMessage(messageToSend,currentDate);
	    }
	repaint();
	fieldMessage.requestFocus();
	//fieldMessage.setCursor();
    }   

    private boolean sendFile()
    {
	int itemIndex=-1;
	System.out.println("sendFile()");
	if (lstFriends.getSelectedIndex() == -1)
	    if (lastItemIndex==-1) return false;
	    else itemIndex = lastItemIndex;
	else itemIndex = lstFriends.getSelectedIndex();
	//Frame frameTmp = new Frame();
	//frameTmp.setSize(new Dimension(235,270));
	//frameTmp.setLocation(0,0);
	//frameTmp.show();
	FileDialog selectFile = new FileDialog(this, "File Selection");
	//selectFile.setBounds(2,17,235,250);
	selectFile.setSize(new Dimension(450,400));
	selectFile.setLocation(20,30);
	selectFile.setMode(FileDialog.LOAD);
	//selectFile.setSize(new Dimension(225,185));
	//selectFile.setLocation(6,25);
	selectFile.show();
	selectFile.hide();
	System.out.println("Selected file is : " +selectFile.getDirectory()+selectFile.getFile());
	//return messenger.sendFile(selectFile.getDirectory()+selectFile.getFile(),lstFriends.getSelectedItem());
	repaint();
	fieldMessage.requestFocus();
	if (selectFile.getFile()!=null && !selectFile.getFile().equals(""))
	return messenger.sendFile(selectFile.getFile(),lstFriends.getItem(itemIndex)); 
	else return false;
    }
    
    public String getFilePath(String fileName)
    {
	System.out.println("receiveFile()");
	FileDialog selectFile = new FileDialog(this, "File Selection");
	selectFile.setMode(FileDialog.SAVE);
	selectFile.setFile(fileName);
	selectFile.show();
	selectFile.hide();
	System.out.println("Selected file is : " +selectFile.getDirectory()+selectFile.getFile());
	repaint();
	fieldMessage.requestFocus();
	return selectFile.getDirectory()+selectFile.getFile();
    }
    
    public boolean autorization(String message)
    {
	return autorization(message,"");
    }

    public boolean autorization(String message1, String message2)
    {
	mess1.setText(message1);
	mess2.setText(message2);
	autorization = false;
	autoriz.setModal(true);
	autoriz.setLocation(20,30);
	autoriz.show();
	autoriz.hide();
	return autorization;
    }
    
    public void showInformation(String message)
    {
	showInformation(message,"");
    }
    public void showInformation(String message1, String message2)
    {
	imess1.setText(message1);
	imess2.setText(message2);
	information.setModal(true);
	information.setLocation(20,30);
	information.show();
	information.hide();
    }

    public void showNewUserDialog(String serviceURL)
    {
	fieldUserServiceURL.setText(serviceURL);
        newUser.setLocation(20,30);
        newUser.setModal(true);
        newUser.show();
        newUser.hide();
	repaint();
	fieldMessage.requestFocus();
    }

    public void showFriendsList()
    {
	flist.removeAll();
	Vector serviceURLsTmp = messenger.getServiceURLs();
	Vector nicknamesTmp = messenger.getNicknames();
	serviceURLs = new Vector();
	nicknames = new Vector();
	for (int i=0;i<serviceURLsTmp.size();i++)
	    {
		serviceURLs.add((String)serviceURLsTmp.elementAt(i));
		nicknames.add((String)nicknamesTmp.elementAt(i));
		flist.add((String)nicknames.elementAt(i)+"   "+(String)serviceURLs.elementAt(i));
	    }
	friends.setLocation(20,30);
	friends.show();
	repaint();
	fieldMessage.requestFocus();
   }

    public void autorizYes()
    {
	autorization = true;
	autoriz.hide();
	repaint();
	//autoriz.dispose();
	fieldMessage.requestFocus();
    }
    
    public void autorizNo()
    {
	autorization = false;
	autoriz.hide();
	repaint();
	//autoriz.dispose();
	fieldMessage.requestFocus();
    }

   public void informationOk()
    {
      information.hide();
      fieldMessage.requestFocus();
    }

    public void addUser()
    {
	addNewUser= true;
	// active friends list
	newUser.dispose();
    }

    public void noAddUser()
    {
	addNewUser=false;
	newUser.dispose();
    }


    public void fokFunction()
    {
	// save
	messenger.setFriends(serviceURLs, nicknames);
	repaint();
	friends.dispose(); 
    }
    
    public void fcancelFunction()
    {
	friends.dispose(); 
	repaint();
	fieldMessage.requestFocus();
    }
    
    public void faddFunction()
    {
	// show add frame
	fieldFriendServiceURL.setText("");
	fieldFriendNickname.setText("");
	modifFriend = false;
	newFriend.setLocation(20,30);
	newFriend.show();
	repaint();
    }
   
    public void fdeleteFunction()
    {
	// delete friends
	if (flist.getSelectedIndex() !=-1)
	    {
		serviceURLs.removeElementAt(flist.getSelectedIndex());
		nicknames.removeElementAt(flist.getSelectedIndex());
		flist.remove(flist.getSelectedIndex());
	    }
    }
        
    public void fmodifyFunction()
    {
	//show add frame
	if (flist.getSelectedIndex() !=-1)
	    {
		String chaine = flist.getSelectedItem();
		fieldFriendNickname.setText(chaine.substring(0,chaine.indexOf(" ")));
		fieldFriendServiceURL.setText(chaine.substring(chaine.indexOf(" ")+3));
		newFriend.setTitle("Modify friend information.");
		modifFriend = true;
		newFriend.setLocation(20,30);
		newFriend.show();
		newFriend.setTitle("Add new friend.");
	    }
	//newFriend.show();
    }
    
    public void nfokFunction()
    {
	// save
	if (!fieldFriendServiceURL.getText().equals("") && !fieldFriendNickname.getText().equals(""))
	    { 
		flist.add(fieldFriendNickname.getText()+"   "+fieldFriendServiceURL.getText());
		if (modifFriend)
		    {
			serviceURLs.removeElementAt(flist.getSelectedIndex());
			nicknames.removeElementAt(flist.getSelectedIndex());
			flist.remove(flist.getSelectedIndex());
		    }
		serviceURLs.add(fieldFriendServiceURL.getText());
		nicknames.add(fieldFriendNickname.getText());
	    }

	newFriend.dispose(); 
    }
    
    public void nfcancelFunction()
    {
	newFriend.dispose(); 
    }

    public void lstFriendsFunction(KeyEvent e)
    {
	if (e.getKeyCode()==KeyEvent.VK_S)
	    sendFile();
	else System.out.println("*********** not S key pressed");
    }
 
    public void saveLastItem()
    {
	lastItemIndex = lstFriends.getSelectedIndex();
    }

    public boolean getAddNewUserStat()
    {
	return addNewUser;
    }

    public String getNewUserServiceURL()
    {
	if (addNewUser) return fieldUserServiceURL.getText();
	else return "";
    }

    public String getNewUserName()
    {
	if (addNewUser) return fieldUserName.getText();
	else return "";
    }

    public String getNewUserNickname()
    {
	if (addNewUser) return fieldUserNickname.getText();
	else return "";
    }

    public Vector getNewUserFriends()
    {
	return null;
    }

    public void showMessage(String nickname, String message, Calendar date)
    {
	lstMessages.addMessage(nickname,message);
	repaint();
    }

    protected void processWindowEvent(WindowEvent e) {
	//super.processWindowEvent(e);
	if (e.getID() == WindowEvent.WINDOW_CLOSING) {
	    System.out.println("Closing event");
	    messenger.closeWindow();
	}
	if (e.getID() == WindowEvent.WINDOW_CLOSED) {
	    System.out.println("Closed event");
	    messenger.closeWindow();
	}
    }

    /*  protected void processKeyEvent(KeyEvent e)
    {
	//super.processKeyEvent(e);
	lstFriendsFunction(e);
    }
    */
    
}


 
