package OzoneMessengerService;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import java.util.Iterator;
import java.util.Calendar;
import java.util.Date;

public class OzoneMessengerFrame extends Frame 
{
    // Ozone Messenger Application
    OzoneMessengerImpl messenger = null;
    Panel pane              = new Panel();
    Panel paneFriends       = new Panel();
    TextField fieldMessage  = new TextField("");
    Button buttonSend       = new Button("    Send    ");
    Button buttonFriendsList= new Button("Friends List");
    Label labelNickname     = new Label("");
    Label labelFriends      = new Label("Connected friends");
    List lstMessages        = new List(6,false);
    List lstFriends         = new List(6,true);

    // autorization frame
    Dialog autoriz          = new Dialog(this, "Autorization to receive file");
    Button byes             = new Button("Yes");
    Button bno              = new Button("No");
    Label mess              = new Label("");

    // newUser frame
   
    Dialog newUser     = new Dialog(this, "Add a new user of Ozone Messenger");
    Label labelUserServiceURL     = new Label("Service URL");
    TextField fieldUserServiceURL = new TextField("");
    Label labelUserName           = new Label("Name ");
    TextField fieldUserName       = new TextField("");
    Label labelUserNickname       = new Label("Nickname");
    TextField fieldUserNickname   = new TextField("");
    Button bok                    = new Button("Ok");
    Button bcancel                = new Button("Cancel");

    // Friends List
    Dialog friends                = new Dialog(this, "Friends List");
    List flist                    = new List(6,false);
    Button fok                    = new Button("Ok");
    Button fcancel                = new Button("Cancel");
    Button fadd                   = new Button("Add");
    Button fdelete                = new Button("Delete");
    Button fmodify                = new Button("Modify");
    Vector serviceURLs = new Vector();
    Vector nicknames = new Vector();

    // new Friend
    Dialog newFriend                = new Dialog(this, "Add new friend");
    Label labelFriendServiceURL     = new Label("Service URL");
    TextField fieldFriendServiceURL = new TextField("");
    Label labelFriendNickname       = new Label("Nickname");
    TextField fieldFriendNickname   = new TextField("");
    Button nfok                    = new Button("Ok");
    Button nfcancel                = new Button("Cancel");

    boolean autorization = false;    
    boolean addNewUser = false;
    boolean modifFriend = true;

    // end graphical interface 

    public OzoneMessengerFrame(OzoneMessengerImpl Messenger) 
    {
	messenger = Messenger;
	// init graphical panel

	GridBagLayout gbl1 = new GridBagLayout();
	paneFriends.setLayout(gbl1);

	GridBagConstraints gbc1 = new GridBagConstraints();
	gbc1.fill = GridBagConstraints.NONE;
	gbc1.gridwidth = GridBagConstraints.REMAINDER;
	gbc1.gridheight = 1;
	gbc1.anchor = GridBagConstraints.NORTHWEST;
	gbc1.weightx = 1.0;
	gbc1.weighty = 1.0;

	gbl1.setConstraints(labelFriends,gbc1);
	paneFriends.add(labelFriends);

	GridBagConstraints gbc2 = new GridBagConstraints();
	gbc2.fill = GridBagConstraints.VERTICAL;
	gbc2.gridwidth = 1;
	gbc2.gridheight = 1;
	gbc2.anchor = GridBagConstraints.NORTHWEST;
	gbc2.weightx = 1.0;
	gbc2.weighty = 1.0;
    
	gbl1.setConstraints(lstFriends,gbc2);
	paneFriends.add(lstFriends);

	// globle pan

	GridBagLayout gbl2 = new GridBagLayout();
	pane.setLayout(gbl2);

	GridBagConstraints gbc3 = new GridBagConstraints();
	gbc3.fill = GridBagConstraints.NONE;
	gbc3.gridwidth = GridBagConstraints.REMAINDER;
	gbc3.gridheight =1 ;
	gbc3.anchor = GridBagConstraints.SOUTHWEST;
	gbc3.weightx = 1.0;
	gbc3.weighty = 1.0;
    
	gbl2.setConstraints(labelNickname,gbc3);
	pane.add(labelNickname);

	GridBagConstraints gbc4 = new GridBagConstraints();
	gbc4.fill = GridBagConstraints.BOTH;
	gbc4.gridwidth  = 8;
	gbc4.gridheight = 4 ;
	gbc4.anchor = GridBagConstraints.CENTER;
	gbc4.weightx = 1.0;
	gbc4.weighty = 1.0;
    
	gbl2.setConstraints(lstMessages,gbc4);
	pane.add(lstMessages);

	GridBagConstraints gbc5 = new GridBagConstraints();
	gbc5.fill = GridBagConstraints.NONE;
	gbc5.gridwidth = GridBagConstraints.REMAINDER;
	gbc5.gridheight = 4 ;
	gbc5.anchor = GridBagConstraints.NORTH;
	gbc5.weightx = 1.0;
	gbc5.weighty = 3.0;
    
	gbl2.setConstraints(paneFriends,gbc5);
	pane.add(paneFriends);
	
	GridBagConstraints gbc6 = new GridBagConstraints();
	gbc6.fill = GridBagConstraints.BOTH;
	gbc6.gridwidth = 8;
	gbc6.gridheight =2 ;
	gbc6.anchor = GridBagConstraints.CENTER;
	gbc6.weightx = 1.0;
	gbc6.weighty = 1.0;
    
	gbl2.setConstraints(fieldMessage,gbc6);
	pane.add(fieldMessage);

	GridBagConstraints gbc7 = new GridBagConstraints();
	gbc7.fill = GridBagConstraints.VERTICAL;
	gbc7.gridwidth =  GridBagConstraints.REMAINDER;
	gbc7.gridheight =2 ;
	gbc7.anchor = GridBagConstraints.NORTHWEST;
	gbc7.weightx = 2.0;
	gbc7.weighty = 2.0;
    
	gbl2.setConstraints(buttonSend,gbc7);
	pane.add(buttonSend);

	GridBagConstraints gbc11 = new GridBagConstraints();
	gbc11.fill = GridBagConstraints.BOTH;
	gbc11.gridwidth =  GridBagConstraints.REMAINDER;
	gbc11.gridheight = GridBagConstraints.REMAINDER ;
	gbc11.anchor = GridBagConstraints.NORTHWEST;
	gbc11.weightx = 2.0;
	gbc11.weighty = 2.0;
    
	gbl2.setConstraints(buttonFriendsList,gbc11);
	pane.add(buttonFriendsList);

	this.setTitle("Ozone Messenger");
	this.setSize(new Dimension(350, 350));
	this.add(pane);
	
	autoriz.setSize(350,200);
	Panel panb = new Panel();

	panb.setLayout(new GridLayout(1,2,30,30));
	panb.add(byes);
	panb.add(bno);
 
	Panel panl = new Panel();
	panl.add(mess);

	Panel pan = new Panel();
        pan.setLayout(new GridLayout(2,1));
	pan.add(panl);
	pan.add(panb);

	autoriz.add(pan);

	autoriz.setModal(true);

	newUser.setSize(350,300);

	Panel panNewUser = new Panel();
	panNewUser.setLayout(new GridLayout(4,2,30,30));

	panNewUser.add(labelUserServiceURL);
	panNewUser.add(fieldUserServiceURL);
	panNewUser.add(labelUserName);
	panNewUser.add(fieldUserName);
	panNewUser.add(labelUserNickname);
	panNewUser.add(fieldUserNickname);
	panNewUser.add(bok);
	panNewUser.add(bcancel);
 
	newUser.add(panNewUser);
	newUser.setModal(true);


	friends.setSize(350,300);


	Panel panListButton = new Panel();
	panListButton.setLayout(new GridLayout(3,1,20,20));
	panListButton.add(fadd);
	panListButton.add(fdelete);
	panListButton.add(fmodify);

	Panel panFriendsButton = new Panel();
	panFriendsButton.setLayout(new GridLayout(1,2,20,20));
	panFriendsButton.add(fok);
	panFriendsButton.add(fcancel);
	
	Panel panFriendsList = new Panel();
	GridBagLayout gbl3 = new GridBagLayout();
	
	panFriendsList.setLayout(gbl3);

	GridBagConstraints gbc8 = new GridBagConstraints();
	gbc8.fill = GridBagConstraints.BOTH;
	gbc8.gridwidth  = 3;
	gbc8.gridheight = 6;
	gbc8.anchor     = GridBagConstraints.NORTHWEST;
	gbc8.weightx    = 1.0;
	gbc8.weighty    = 1.0;

	gbl3.setConstraints(flist,gbc8);
	panFriendsList.add(flist);

	GridBagConstraints gbc9 = new GridBagConstraints();
	gbc9.fill = GridBagConstraints.BOTH;
	gbc9.gridwidth  = GridBagConstraints.REMAINDER ;
	gbc9.gridheight = 6;
	gbc9.anchor     = GridBagConstraints.NORTHWEST;
	gbc9.weightx    = 1.0;
	gbc9.weighty    = 1.0;

	gbl3.setConstraints(panListButton,gbc9);
	panFriendsList.add(panListButton);

	GridBagConstraints gbc10 = new GridBagConstraints();
	gbc10.fill = GridBagConstraints.BOTH;
	gbc10.gridwidth  = GridBagConstraints.REMAINDER ;
	gbc10.gridheight = GridBagConstraints.REMAINDER;
	gbc10.anchor     = GridBagConstraints.NORTHWEST;
	gbc10.weightx    = 1.0;
	gbc10.weighty    = 1.0;

	gbl3.setConstraints(panFriendsButton,gbc10);
	panFriendsList.add(panFriendsButton);

	friends.add(panFriendsList);
	friends.setModal(true);

	newFriend .setSize(350,300);

	Panel panNewFriend = new Panel();
	panNewFriend.setLayout(new GridLayout(3,2,30,30));

	panNewFriend.add(labelFriendServiceURL);
	panNewFriend.add(fieldFriendServiceURL);
	panNewFriend.add(labelFriendNickname);
	panNewFriend.add(fieldFriendNickname);
	panNewFriend.add(nfok);
	panNewFriend.add(nfcancel);
 
	newFriend.add(panNewFriend);
	newFriend.setModal(true);

	bok.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    addUser();
		}
	    });

	bcancel.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    noAddUser();
		}
	    });

	byes.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    autorizYes();
		}
	    });

	bno.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    autorizNo();
		}
	    });

	buttonSend.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    sendFunction();
		}
	    });

	buttonFriendsList.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		     showFriendsList();
		}
	    });

	lstFriends.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    sendFile();
		}
	    });

	lstFriends.addKeyListener(new java.awt.event.KeyListener() {
		public void keyTyped(KeyEvent e) {
		    // lstFriendsFunction(e);
		}
		public void keyPressed(KeyEvent e) {
		    //lstFriendsFunction(e);
		}
		public void keyReleased(KeyEvent e) {
		    lstFriendsFunction(e);
		}

	    });
	
	fok.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    fokFunction();
		}
	    });
	
	fcancel.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    fcancelFunction();
		}
	    });
	
	fadd.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		faddFunction();
		}
	    });
	
	fdelete.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    fdeleteFunction();
		}
	    });
	
	fmodify.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    fmodifyFunction();
		}
	    });

 	nfok.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    nfokFunction();
		}
	    });
	
	nfcancel.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    nfcancelFunction();
		}
	    });

	this.addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent evt) {
		    messenger.closeWindow();
		}
            });


	setNickname(messenger.getNickname());
	showFriends();
    } 

    public void setNickname(String nickname)
    {
	// set Nickname Label
      labelNickname.setText(nickname);
    }

    public void showFriends()
    {
	// show all users
	lstFriends.removeAll();         
	Iterator nicknames = messenger.getConnectedNicknames();
	while (nicknames.hasNext())
	lstFriends.add((String)nicknames.next());
    }

    private void sendFunction()
    {
	if (!fieldMessage.getText().equals(""))
	    {
		//for all selected item send message 
		Calendar currentDate = Calendar.getInstance();
		currentDate.setTime(new Date(System.currentTimeMillis()));
		String[] items = lstFriends.getSelectedItems();
		if (items !=null && items.length>0)
		    for (int i=0; i<items.length;i++)
			messenger.send(fieldMessage.getText(),currentDate, items[i]);
		else messenger.sendMessage(fieldMessage.getText(),currentDate);
		fieldMessage.setText("");
	    }
    }   

    private boolean sendFile()
    {
	System.out.println("sendFile()");
	if (lstFriends.getSelectedIndex() == -1) return false;
	FileDialog selectFile = new FileDialog(this, "File Selection");
	selectFile.setMode(FileDialog.LOAD);
	selectFile.show();
	selectFile.hide();
	System.out.println("Selected file is : " +selectFile.getDirectory()+selectFile.getFile());
	//return messenger.sendFile(selectFile.getDirectory()+selectFile.getFile(),lstFriends.getSelectedItem());
	if (selectFile.getFile()!=null && !selectFile.getFile().equals(""))
	return messenger.sendFile(selectFile.getFile(),lstFriends.getSelectedItem()); 
	else return false;
    }
    
    public String getFilePath(String fileName)
    {
	System.out.println("receiveFile()");
	FileDialog selectFile = new FileDialog(this, "File Selection");
	selectFile.setMode(FileDialog.SAVE);
	selectFile.setFile(fileName);
	selectFile.show();
	selectFile.hide();
	System.out.println("Selected file is : " +selectFile.getDirectory()+selectFile.getFile());
	return selectFile.getDirectory()+selectFile.getFile();
    }
    
    public boolean autorization(String message)
    {
	//mess.setText("Do you want to receive "+fileName+" file from "+nickName +"?");
	mess.setText(message);
	autorization = false;
	autoriz.setModal(true);
	autoriz.show();
	autoriz.hide();
	//System.out.println("I will retrun : "+autorization+" for autorization");
	return autorization;
    }

    public void showNewUserDialog(String serviceURL)
    {
	fieldUserServiceURL.setText(serviceURL);
	newUser.show();
    }

    public void showFriendsList()
    {
	flist.removeAll();
	Vector serviceURLsTmp = messenger.getServiceURLs();
	Vector nicknamesTmp = messenger.getNicknames();
	serviceURLs = new Vector();
	nicknames = new Vector();
	for (int i=0;i<serviceURLsTmp.size();i++)
	    {
		serviceURLs.add((String)serviceURLsTmp.elementAt(i));
		nicknames.add((String)nicknamesTmp.elementAt(i));
		flist.add((String)serviceURLs.elementAt(i)+"   "+(String)nicknames.elementAt(i));
	    }

	friends.show();
   }

    public void autorizYes()
    {
	autorization = true;
	autoriz.dispose();
    }
    
    public void autorizNo()
    {
	autorization = false;
	autoriz.dispose();
    }

    public void addUser()
    {
	addNewUser= true;
	// active friends list
	newUser.dispose();
    }

    public void noAddUser()
    {
	addNewUser=false;
	newUser.dispose();
    }


    public void fokFunction()
    {
	// save
	messenger.setFriends(serviceURLs, nicknames);
	friends.dispose(); 
    }
    
    public void fcancelFunction()
    {
	friends.dispose(); 
    }
    
    public void faddFunction()
    {
	// show add frame
	fieldFriendServiceURL.setText("");
	fieldFriendNickname.setText("");
	modifFriend = false;
	newFriend.show();
    }
   
    public void fdeleteFunction()
    {
	// delete friends
	if (flist.getSelectedIndex() !=-1)
	    {
		serviceURLs.removeElementAt(flist.getSelectedIndex());
		nicknames.removeElementAt(flist.getSelectedIndex());
		flist.remove(flist.getSelectedIndex());
	    }
    }
        
    public void fmodifyFunction()
    {
	//show add frame
	if (flist.getSelectedIndex() !=-1)
	    {
		String chaine = flist.getSelectedItem();
		fieldFriendServiceURL.setText(chaine.substring(0,chaine.indexOf(" ")));
		fieldFriendNickname.setText(chaine.substring(chaine.indexOf(" ")+3));
		modifFriend = true;
		newFriend.show();
	    }
	//newFriend.show();
    }
    
    public void nfokFunction()
    {
	// save
	if (!fieldFriendServiceURL.getText().equals("") && !fieldFriendNickname.getText().equals(""))
	    { 
		flist.add(fieldFriendServiceURL.getText()+"   "+fieldFriendNickname.getText());
		if (modifFriend)
		    {
			serviceURLs.removeElementAt(flist.getSelectedIndex());
			nicknames.removeElementAt(flist.getSelectedIndex());
			flist.remove(flist.getSelectedIndex());
		    }
		serviceURLs.add(fieldFriendServiceURL.getText());
		nicknames.add(fieldFriendNickname.getText());
	    }

	newFriend.dispose(); 
    }
    
    public void nfcancelFunction()
    {
	newFriend.dispose(); 
    }

    public void lstFriendsFunction(KeyEvent e)
    {
	if (e.getKeyCode()==KeyEvent.VK_S)
	    {
		System.out.println("S tayped");
		sendFile();
	    }
	else System.out.println("*********** not S key pressed");
    }

    public boolean getAddNewUserStat()
    {
	return addNewUser;
    }

    public String getNewUserServiceURL()
    {
	if (addNewUser) return fieldUserServiceURL.getText();
	else return "";
    }

    public String getNewUserName()
    {
	if (addNewUser) return fieldUserName.getText();
	else return "";
    }

    public String getNewUserNickname()
    {
	if (addNewUser) return fieldUserNickname.getText();
	else return "";
    }

    public Vector getNewUserFriends()
    {
	return null;
    }

    public void showMessage(String nickname, String message, Calendar date)
    {
	lstMessages.add(nickname+": "+message);
    }

    protected void processWindowEvent(WindowEvent e) {
	//super.processWindowEvent(e);
	if (e.getID() == WindowEvent.WINDOW_CLOSING) {
	    System.out.println("Closing event");
	    messenger.closeWindow();
	}
	if (e.getID() == WindowEvent.WINDOW_CLOSED) {
	    System.out.println("Closed event");
	    messenger.closeWindow();
	}
    }
    
}


 
