package OzoneMessengerService;

import java.util.*;
import org.xml.sax.InputSource;
import org.apache.xerces.parsers.SAXParser;
import org.xml.sax.XMLReader;
import java.io.*;

public class Users 
{
    Vector users = new Vector();
    XMLReader xr ;
    SAXHandler sh;
    String filePath="";

    public Users(String filePath)
    {
	this.filePath = filePath;
	try
	    {
		xr = new SAXParser();
		sh = new SAXHandler();
		xr.setContentHandler(sh);
		xr.setErrorHandler(sh);
		FileInputStream usersFile = new FileInputStream(filePath);
		xr.parse(new InputSource(usersFile));
		users = sh.getUsers();
	    }
	catch (Exception ex)
	    {
		System.out.println("Error at parsing users.xml file");
		ex.printStackTrace();
	    }
    }

    public User getUser(String serviceURL)
    {
	int i=0;
	User user = null;
	while (i<users.size())
	    {
		user = (User)users.elementAt(i);
		if (user.getServiceURL().equals(serviceURL)) return user; 
		i++;
	    }
	return null;
    }

    public Vector getAllUsers()
    {
	return users;
    }

    public boolean addUser(User user)
    { 
	int i=0;
	while (i<users.size())
	    {
		User existedUser = (User)users.elementAt(i);
		if (user.getServiceURL().equals(existedUser.getServiceURL())) return false; 
		i++;
	    }
	users.addElement(user);
	return saveChange();
    }
    public boolean setUser(User user, String serviceURL)
    {
	int i=0;
	while (i<users.size())
	    {
		User existedUser = (User)users.elementAt(i);
		if (serviceURL.equals(existedUser.getServiceURL()))
		    {
			users.set(i, user);
			return saveChange();
		    } 
		i++;
	    }
	return saveChange();
    }

    public boolean saveChange()
    {
	try
	    {
		FileWriter usersFile = new FileWriter(filePath);
		usersFile.write("<messenger>");
		for (int i=0;i<users.size();i++)
		    {
			User user = (User)users.elementAt(i);
			usersFile.write("\n\t<user instance="+'"'+user.getServiceURL()+'"'+">");
			
			usersFile.write("\n\t\t<name>"+user.getName()+"</name>");
			usersFile.write("\n\t\t<nickname>"+user.getNickname()+"</nickname>");
			Vector friendServiceURLs = user.getFriendServiceURLs();
			Vector friendNicknames  = user.getFriendNicknames();
			if (friendServiceURLs != null && friendServiceURLs.size()>0)
			    {
				usersFile.write("\n\t\t<friends>");
				for (int j=0;j<friendServiceURLs.size();j++)
				    {
					usersFile.write("\n\t\t\t<serviceURL>"+friendServiceURLs.elementAt(j)+"</serviceURL>");
					usersFile.write("\n\t\t\t<nickname>"+friendNicknames.elementAt(j)+"</nickname>");
				    }
				usersFile.write("\n\t\t</friends>");
			    }
			
			usersFile.write("\n\t</user>");
		    }
		usersFile.write("\n</messenger>");
		usersFile.close();
	    }
	catch (Exception ex)
	    {
		System.out.println("Error at writing user.xml file");
		return false;
	    }
	return true;
    }
}
