package YellowPagesService.database;

import YellowPagesService.*;

import java.math.*;
import java.io.*;

// used to instanciate a specific DB-access class choosen at runtime

public class YellowPagesDBFactory{

    public static YellowPagesDB getYellowPagesDB() throws DatabaseException{

	String database = "YellowPagesService.database.MySQLYellowPagesDB";
	String databasePath="payia.inria.fr";
	String user="root";
	String dbUrl = "";
	
	try{
	    
	    ClassLoader cl = Thread.currentThread().getContextClassLoader();
	    java.net.URL resource = cl.getResource("database.conf");
	    if (resource !=null)
		{
		    FileReader fr = new FileReader(resource.getPath()); 
			BufferedReader br = new BufferedReader(fr); 
			if (br.ready())
			    { 
				String readPath = br.readLine();
				if(readPath!=null && !readPath.equals("")) databasePath=readPath;
			    }
			if (br.ready()) 
			    {
				String readUser = br.readLine();
				if (readUser!=null && !readUser.equals("")) user=readUser;
			    }
		}

	    dbUrl = "jdbc:mysql://"+databasePath+"/yellowpages?user="+user;
	} catch(Exception ex){ // FileNotFoundException or IOException
	    throw new DatabaseException(new BigInteger("1"),"databaseName.txt not found");
	}
	
	System.out.println("database detected: "+database);
	System.out.println("dbUrl detected: "+dbUrl);

	YellowPagesDB yellowPagesDB = null;

	try{
	    System.out.println("setting dbUrl...");
	    Globals.dbUrl = dbUrl;
	    Class myClass = Class.forName(database);
	    System.out.println("Class.forName OK");
	    yellowPagesDB = (YellowPagesDB) myClass.newInstance();
	    System.out.println("new Instance OK");
	} catch(ClassNotFoundException ex){
	    System.out.println("unknown exception");
	    ex.printStackTrace();
	    throw new DatabaseException(new BigInteger("1"),"ClassNotFoundException");
	} catch(InstantiationException ex)
	    {
	    System.out.println("unknown exception");
	    ex.printStackTrace();
	    throw new DatabaseException(new BigInteger("1"),"InstantiationExcpetion");
	} catch(IllegalAccessException ex){
	    System.out.println("unknown exception");
	    ex.printStackTrace();
	    throw new DatabaseException(new BigInteger("1"),"IllegalAccessException");
	} catch(Exception ex){
	    System.out.println("unknown exception");
	    ex.printStackTrace();
	}
      

	return  yellowPagesDB;
    }

}
