package CoreBroker.Axis;

import org.apache.axis.wsdl.WSDL2Java;
import CoreBroker.BrokerWrapper;
import CoreBroker.DeployedService;
import CoreBroker.CBException;

import WSAMI.*;
import java.util.*; 

import org.w3c.dom.*;
import javax.xml.parsers.*; 

import CoreBroker.Utils;

public class AxisBrokerWrapper extends CoreBroker.BrokerWrapper {
   
    private AxisBrokerWrapper(String side) {
        super();         
        if (side.equals(BROKERWRAPPER_SERVERSIDE)) {        
            ClassLoader c = Thread.currentThread().getContextClassLoader();
            java.net.URL u = c.getResource("server-config.wsdd");
            org.apache.xerces.parsers.DOMParser parserDOM = new org.apache.xerces.parsers.DOMParser();
            try {
                parserDOM.parse(u.toString());
            } catch (org.xml.sax.SAXException ex) {
               //throw new CBException("broker01","error reading server-config.wsdd");
                /*
                 *
                 *  initialize with the standard default wsdd 
                 *
                 */
            } catch (java.io.IOException ex) {
               //throw new CBException("broker01","server-config.wsdd not found");            
                /*
                 *
                 *  initialize with the standard default wsdd 
                 *
                 */            
            }
            setServerConfig((Document)parserDOM.getDocument());                    
        } 
        
        /*
        brokerSide = side;
         */
    }
   
    public static BrokerWrapper makeServerInstance() {
        
        if (_selfServerSide == null) {
            _selfServerSide = new AxisBrokerWrapper(BROKERWRAPPER_SERVERSIDE);          
        }
        return _selfServerSide;
    }   

    public static BrokerWrapper makeClientInstance() {
        
        if (_selfClientSide == null) {
            _selfClientSide = new AxisBrokerWrapper(BROKERWRAPPER_CLIENTSIDE);          
        }
        return _selfClientSide;
    }      
   
    public void deployService(Node service, String path, String context) 
            throws CBException {

        org.apache.xerces.parsers.DOMParser parserDOM = new org.apache.xerces.parsers.DOMParser();                
        Document specificBrokerServiceInfo = null;

        CoreBroker.IFUtils ifUtils = new CoreBroker.IFUtils();
        
        /*
         *  retrieve service name from wsami deploy xml
         */
        String serviceName = null;
        try{
            serviceName = service.getAttributes().getNamedItem("name").getNodeValue();
        } catch (Exception ex) {
            throw new CBException("deployverify01","Invalid service name ");            
        } 

        /*
         *  retrieve instance URL of the service instance
         *  from XML deploy file
         */
        String instanceURL = getTagValue(service, "instance_URL");
        
        /*
         *  retrieve WSAMI abstract, service and customizer document names
         *  from XML deploy file
         */
        String WSAMIAbstractFileName = getTagValue(service, "wad");
        if (WSAMIAbstractFileName != null)
            WSAMIAbstractFileName = path.concat(WSAMIAbstractFileName);
        /*
        else
            throw new CBException("deployverify00","WSAMI Abstract document not defined in XML deployment file");
         */

        String WSAMIServiceFileName = getTagValue(service, "wsd"); 
        if (WSAMIServiceFileName != null)
            WSAMIServiceFileName = path.concat(WSAMIServiceFileName);
        /*
        else
            throw new CBException("deployverify00","WSAMI Service document not defined in XML deployment file");
         */
       
        String WSAMICustomizerFileName = getTagValue(service, "wcd");
        if (WSAMICustomizerFileName != null)
            WSAMICustomizerFileName = path.concat(WSAMICustomizerFileName);       
       
 
        /*
         *  retrieve WSDL concrete file name from XML deploy file
         */  
        String WSDLFileName = null;
        try {
            WSAMIServiceDocument wsd = new WSAMIServiceDocument(path, WSAMIServiceFileName);                       
            java.net.URL urlWSDLConcrete = new java.net.URL(wsd.getConcrete());
            
            if (ifUtils.isLocalAddress(urlWSDLConcrete.getHost()))
                WSDLFileName = ifUtils.localURI2localfile(urlWSDLConcrete,path,context);
                     
            /*
             * if the WSDL concrete document is on local machine : 
             *     trasform the http address retrieved in WSAMI Service Document
             *      into absolute path on local filesystem 
             * else keep the http address
             */
            
            /*
            if (CoreBroker.Utils.isLocalAddress(urlWSDLConcrete.getHost())) {
                WSDLFileName = Utils.localURI2localfile(urlWSDLConcrete,path,context);
                
                java.io.FileInputStream is = new java.io.FileInputStream(new java.io.File(WSDLFileName));
                int rb = is.read();
                if (rb == -1)
                    throw new java.io.IOException();
            } else {
                java.io.InputStream is = urlWSDLConcrete.openStream();
                int rb = is.read();
                if (rb == -1)
                    throw new java.io.IOException();
            } 
             */
            /*
        } catch (java.io.FileNotFoundException ex) {
            throw new CBException("deployverify01","WSDL concrete file "+WSDLFileName+" not found.");
             */
        } catch(java.net.MalformedURLException ex) {
            throw new CBException("deployverify01","Invalid address "+WSDLFileName+" for WSDL concrete.");            
        }
       
     
       /*
        *   retrieve from XML deploy file if
        *   the service is a local/remote 
        *   customizer or if it is not:
        *       - null = is not a customizer
        *       - "local" or "remote" = is a local / remote customizer
        */
       String customizerType = null; 
       NamedNodeMap svcAttrs = service.getAttributes();
       if ((svcAttrs.getNamedItem("customizer") != null))
            customizerType = svcAttrs.getNamedItem("customizer").getNodeValue();
       
       /*
        *   retrieve from XML deploy file 
        *   the deployment scope for the service:
        *   Application (default), Session, Request
        */
       String scope = getTagValue(service, "scope");
       if (scope == null)
           scope = "Application";
       
       /*
        *   retrieve implementation type
        *   (currently only java class is supported
        *   EJB is not supported)
        */
       String typeImpl = null;
       String className = null;
       String packageName = null;
       /*
        *   Useful for EJB support:
        *
        *   String jndiName = null;
        *   String homeClass = null;
        */
       Node implNode = null;
       NodeList svcChildren = service.getChildNodes();
       for (int i=0; i<svcChildren.getLength(); i++) {
            Node n = svcChildren.item(i);
            if (n.getNodeName() == "implementation") {                    
                implNode = n;
                break;
            }
       }           
       if (implNode != null){
           typeImpl = getTagValue(implNode, "type");

           if (typeImpl.equals("javaclass")) {
               className = getTagValue(implNode, "class");                 
                packageName = getTagValue(implNode, "package");                      
           } 
           /*
            *   currently no EJB support 
            *
           else if (typeImpl.equals("ejb")) {                 
               jndiName = getTagValue(implNode, "jndi");                
               homeClass = getTagValue(implNode, "home");
               packageName = getTagValue(implNode, "package");   
               scope = "Session";
           } 
            */                  
       }

       
       /*
        *   retrieve endpoint from WSDL concrete file
        */    
        String endPoint = null;
        try {    
           parserDOM.parse(WSDLFileName);                      
           Document wsdlDoc = parserDOM.getDocument();           
           NodeList list = wsdlDoc.getElementsByTagNameNS("*","address");
           NamedNodeMap attr = list.item(0).getAttributes();
           endPoint = attr.getNamedItem("location").getNodeValue();
        } catch (org.xml.sax.SAXException ex) {
            throw new CBException("deployverify01","Invalid address "+WSDLFileName+" for WSDL concrete.");            
        } catch (java.io.IOException ex) {
            throw new CBException("deployverify01","Invalid address "+WSDLFileName+" for WSDL concrete.");            
        }
           
        /*
         *  generate wsdd from wsdl and use wsdd to deploy on  axis
         */
        if (scope != null && packageName != null && WSDLFileName != null) {
            
            // use axis functionality to build wsdd from a wsdl file
            String[] args = {"-s","-d",scope,"-o",path+"tmp","-p",packageName,WSDLFileName};
            WSDL2wsdd w = new WSDL2wsdd();
            w.process(args);

            //  try to parse the generated wsdd file
            try{           
               parserDOM.parse(path+"tmp"+fileSeparator + packageName + fileSeparator+"deploy.wsdd");               
            } catch (org.xml.sax.SAXException ex) {
                throw new CBException("deploy10","Error in deployment operation");
            } catch (java.io.IOException ex) {
                throw new CBException("deploy10","Error in deployment operation");
            }
            
            //  store the content of wsdd file in specificBrokerServiceInfo
            //  that will be used to store information about the service
            //  related to the deployed on the specific SOAP implementation, 
            //  in this case Axis
            specificBrokerServiceInfo = (Document)parserDOM.getDocument().cloneNode(true);

            //  modify the specificBrokerServiceInfo if relation
            //  to information retrieve in XML deployment file
            if (typeImpl.equals("javaclass")) {
                Modify_className_and_scope(specificBrokerServiceInfo, className, scope);
            } 
            /*
             *  currently no support for EJB
             *
             else if (typeImpl.equals("ejb")) {
                Modify_EJB(specificBrokerServiceInfo, jndiName, homeClass, scope);
            }
             */ 
            if (customizerType != null)
               Modify_RPCProvider(specificBrokerServiceInfo, customizerType);

            // finally deploy the service on the Core Broker
            deploy(serviceName, endPoint, path, WSAMIAbstractFileName, WSAMIServiceFileName ,WSAMICustomizerFileName, specificBrokerServiceInfo, instanceURL );              
            
        } else
            throw new CBException("deploy10","Error in deployment operation");
   }

   private void Modify_className_and_scope(Document specificBrokerServiceInfo, String className, String scope) {   
       
        NodeList paramList = specificBrokerServiceInfo.getElementsByTagName("parameter");
        for (int i=0; i<paramList.getLength(); i++) {               
            NamedNodeMap attrs = paramList.item(i).getAttributes();
            
            if ((attrs.getNamedItem("name").getNodeValue()).equals("className")) {
                if (className != null && className != "")
                    attrs.getNamedItem("value").setNodeValue(className);
            
            } else if ((attrs.getNamedItem("name").getNodeValue()).equals("scope"))
                attrs.getNamedItem("value").setNodeValue(scope);
        }                   
   }

   /*
    *   Currently EJB not supported
    *
   private void Modify_EJB(Document specificBrokerServiceInfo, String jndiName, String homeClass, String scope) {                  
        Element service = (Element)specificBrokerServiceInfo.getElementsByTagName("service").item(0);
        service.setAttribute("provider","java:EJB");
        
        // remove all children "<parameter name= value=>" from service
        NodeList childrenList = service.getChildNodes();
        for (int i=0; i<childrenList.getLength(); i++)
            service.removeChild(childrenList.item(i));
        
        // add all children "<parameter name= value=>" required by EJB
        Element classnameEl = specificBrokerServiceInfo.createElementNS("http://xml.apache.org/axis/wsdd/","parameter");
        classnameEl.setAttribute("name","beanJndiName");
        classnameEl.setAttribute("value",jndiName);
        service.appendChild(classnameEl);

        Element homeEl = specificBrokerServiceInfo.createElementNS("http://xml.apache.org/axis/wsdd/","parameter");
        homeEl.setAttribute("name","homeInterfaceName");
        homeEl.setAttribute("value",homeClass);
        service.appendChild(homeEl);
          
        Element scopeEl = specificBrokerServiceInfo.createElementNS("http://xml.apache.org/axis/wsdd/","parameter");
        scopeEl.setAttribute("name","scope");
        scopeEl.setAttribute("value", scope);
        service.appendChild(scopeEl);
   }
    */
   
   private void Modify_RPCProvider(Document deploymentDoc, String customizerType) {

       Node svcDef = deploymentDoc.getElementsByTagName("service").item(0);
       NamedNodeMap attr = svcDef.getAttributes();
       
       // modify service definition in deploy.wsdd:
       //   from:   <service name="XYZ" provider="java:RPC" ...
       //   to:     <service name="XYZ" provider="Handler" ...
       if ((attr.getNamedItem("provider").getNodeValue()).equals("java:RPC")) {
           attr.getNamedItem("provider").setNodeValue("Handler");
       }
       
       //   the handler definition is then added to the service definition node:
       //   <parameter name="handlerClass" value="CoreBroker.Axis.CustomizerProvider" />
       Element handlerChild = deploymentDoc.createElementNS("http://xml.apache.org/axis/wsdd/","parameter");
       handlerChild.setAttribute("name","handlerClass");
       handlerChild.setAttribute("value","CoreBroker.Axis.CustomizerProvider");
       svcDef.appendChild(handlerChild);
   }
 
    protected void refreshDeploymentConfiguration() {
        
        // obtain the server configuration (it's the XML configuration from server-config.wsdd
        deploymentConfiguration = this.getServerConfig();
        
        //  obtain the list of services definition (the information
        //  we are interested in is the XML definition of the service 
        //  used to deploy services on Axis
        DeployedService[] deployedList = getDeployedServices();      
        for (int i=0; i<deployedList.length; i++) {
            Document doc = deployedList[i].getServiceInfo();
            if (doc!=null) {
                Node service = doc.getElementsByTagName("service").item(0);
                Node serviceDef = deploymentConfiguration.importNode(service, true);
                if (serviceDef != null) {
                    deploymentConfiguration.getDocumentElement().appendChild(serviceDef);
                }
            }
        }
    } 
    
    public NDService.NDPortType getNDStub(String ndAddress) 
            throws CBException {
                
        try {     
            java.net.URL ndAddressURL = new java.net.URL(ndAddress);            
            NDService.NDPortType nd = new NDService.NDBindingStub(ndAddressURL,null);
            return nd; 
        } catch (java.rmi.RemoteException ex) {
            throw new CBException("deploy02","The address of the ND service is not correct"); 
        } catch (java.net.MalformedURLException ex) {
            throw new CBException("deploy02","The address of the ND service is not correct"); 
        }        
    }
    
}
