package CoreBroker.Axis;

import org.apache.axis.AxisFault; //to mofify this exception into a WSAMI Exception
 
import org.apache.axis.MessageContext;
import java.util.Vector;
import CoreBroker.Syslog;
import javax.xml.soap.*;


public class WSAMIHandlerClientReq extends org.apache.axis.handlers.BasicHandler
{
    private Vector svcList;  
    
    public void init() {
        try {        
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    public void invoke(MessageContext msgContext) throws AxisFault
    {
        try {
            Syslog.debug(this,"WSAMI handler client request invoke");

            /*
             * need to set the factory for the BrokerFactory because
             * this class is used at client side and when it is invoked
             * the factory hasn't been set yet.
             */
            CoreBroker.BrokerFactory.setFactory("CoreBroker.Axis.AxisBrokerWrapper");
            CoreBroker.BrokerWrapper broker = CoreBroker.BrokerFactory.getServerInstance();
            
            String customizerSessionID = null;
            String url = (String)msgContext.getProperty("transport.url");
            Syslog.debug(this,"url="+url);
            int index = url.lastIndexOf("?");
            if (index > 0)
            {
                customizerSessionID = url.substring(index+1);
                Syslog.debug(this,"customizerSessionID="+index+","+customizerSessionID);

                /* client:  customizerSessionID and the related customizer chain
                 *          has been set in the local 
                 *         Core Broker instance by the client code with the 
                 *         broker's method "String setCustomizerChain(LC, RC, WS)"
                 * LC:      customizerSessionID and the related customizer chain
                 *         has been set in the local 
                 *         Core Broker instance by the CustomizerProvider with the 
                 *         broker's method setCustID_and_Chain_FromHeader(msgSOAP, obj);
                 * RC:      customizerSessionID and the related customizer chain
                 *         has been set in the local 
                 *         Core Broker instance by the CustomizerProvider with the 
                 *         broker's method setCustID_and_Chain_FromHeader(msgSOAP, obj);
                 */
                if (broker.isCustomizer(customizerSessionID))
                    broker.addCustID_and_ChainToHeader(msgContext.getMessage(), customizerSessionID);
            }

            //javax.xml.soap.SOAPMessage msg = msgContext.getMessage();
            //msg.writeTo(System.out);
                
	} catch (Exception e) {
            throw AxisFault.makeFault(e);
        }
    }
    
}
