/*
 * CustomizerProvider.java
 *
 * Created on Janv 19, 2004, 3:45 PM
 */

package CoreBroker.CSoap;

import javax.xml.rpc.handler.soap.SOAPMessageContext;
import java.lang.reflect.Method;
import CoreBroker.BasicCustomizer;
import CoreBroker.Syslog;

/**
 *
 * @author  root
 */
public class CustomizerProvider extends csoap.server.RPCProvider implements csoap.server.ServiceProvider {
    
    /** Creates a new instance of CustomizerProvider */
    public CustomizerProvider() {
    }
    
        public Object invokeMethod(SOAPMessageContext msgContext,
                                  Method method, Object obj,
                                  Object[] argValues)
    {   
	try
	    {
		CoreBroker.BrokerWrapper broker = CoreBroker.BrokerFactory.getServerInstance();
		
		// if the SOAP message header contains RC and/or WS and SessionID
		// extract these values and set the chain value in the local
		// instance of the broker to handle customization
		// and set the customizerID in the obj 
		// if the obj is the LC: header contains RC, WS, SID
		// if the obj is the RC:  header contains WS, SID
		broker.setCustID_and_Chain_FromHeader(msgContext.getMessage(),obj);
	    }
	catch(Exception ex)
	    {
		Syslog.error(this,"Error in broker");
	    }
        return super.invokeMethod(msgContext, method, obj, argValues);
    }
    
}
