package CoreBroker;

import WSAMI.*;
import org.w3c.dom.*;

public class DeployedService
{
    private String serviceName;
    private WSAMIAbstractDocument WAD;
    private WSAMIServiceDocument WSD;
    private WSAMICustomizerDocument WCD;
    private Document serviceInfo;
    private String endPoint;
    private String[] files;
    private String instance_URL;

    public DeployedService(String serviceName,
            String _endPoint, 
            WSAMIAbstractDocument _WAD,
            WSAMIServiceDocument _WSD,
            WSAMICustomizerDocument _WCD,
            Document _serviceInfo,
            String instance_URL)    {
                
        this.serviceName = serviceName;
        this.endPoint = _endPoint;
        this.WAD = _WAD;
        this.WSD = _WSD;
        this.WCD = _WCD;
        this.serviceInfo = _serviceInfo;
        this.files = null;     
        this.instance_URL = instance_URL;
    }

    public String getServiceName() {
        return serviceName;
    }
    
    public WSAMIAbstractDocument getWSAMIAbstractDocument() {
        return WAD;
    }

    public WSAMIServiceDocument getWSAMIServiceDocument() {
        return WSD;
    }

    public WSAMICustomizerDocument getWSAMICustomizerDocument() {
        return WCD;
    }

    public Document getServiceInfo() {
        return serviceInfo;
    }

    public String getEndPoint() {
        return endPoint;
    }
    
    public String getInstanceURL() {
        return instance_URL;
    }
    
    public void setFiles(String[] files) {
        this.files = new String[files.length];
        for (int i=0; i<files.length; i++)
            this.files[i] = files[i];
    }
    
    public String[] getFiles() {
        return files;
    }
}