package CoreBroker;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileNotFoundException;

public class SLPMgr 
{
    
    private CoreBroker.IFUtils CBIFUtils = new CoreBroker.IFUtils();
   
    private NetworkIFDescr[] _networkIFs = null;

    public void writeSLPConfFile() {
        _networkIFs = CBIFUtils.getNetworkInfo();
        
        System.out.print("net.slp.interfaces=");
        
        if (_networkIFs != null && _networkIFs.length >0) {
            for (int i=0; i<_networkIFs.length-1; i++)
                System.out.print(_networkIFs[i].ipAddr+",");
        
            System.out.println(_networkIFs[_networkIFs.length-1].ipAddr);
                
        }        
    }

    public static void writeSLPConfFile(String filename, NetworkIFDescr[] _networkIFs) {
        
        try {
            FileOutputStream fos = new FileOutputStream(filename);

            fos.write(new String("net.slp.interfaces=").getBytes());

            if (_networkIFs != null && _networkIFs.length >0) {
                for (int i=0; i<_networkIFs.length; i++) {
                    fos.write(_networkIFs[i].ipAddr.getBytes());
                    if (i < _networkIFs.length-1) 
                        fos.write(new String(",").getBytes());
                }
            }     
            fos.close();
        } catch (FileNotFoundException ex) {
            String configSLPEVENTFILE = null;          
            if (System.getProperty("catalina.home") != null) 
                configSLPEVENTFILE = System.getProperty("catalina.home")+"/webapps/wsami/WEB-INF/web.xml";
            else if (System.getProperty("jetty.home") != null) 
                configSLPEVENTFILE = System.getProperty("jetty.home")+"/wsami/WEB-INF/web.xml";
            
            Syslog.error(SLPMgr.class,"File "+filename+" not found: please set the right value in "+configSLPEVENTFILE);
        } catch (IOException ex) {
            String configSLPEVENTFILE = null;          
            if (System.getProperty("catalina.home") != null) 
                configSLPEVENTFILE = System.getProperty("catalina.home")+"/webapps/wsami/WEB-INF/web.xml";
            else if (System.getProperty("jetty.home") != null) 
                configSLPEVENTFILE = System.getProperty("jetty.home")+"/wsami/WEB-INF/web.xml";
            
            Syslog.error(SLPMgr.class,"File "+filename+" not found: please set the right value in "+configSLPEVENTFILE);
        }
            
    }    
    
    public static void writeSLPConfFile(String filename, String[] ips) {
        
        try {
            FileOutputStream fos = new FileOutputStream(filename);

            fos.write(new String("net.slp.interfaces=").getBytes());

            if (ips != null && ips.length >0) {
                for (int i=0; i<ips.length; i++) {
                    fos.write(ips[i].getBytes());
                    if (i < ips.length-1) 
                        fos.write(new String(",").getBytes());
                }
            }     
            fos.close();
        } catch (FileNotFoundException ex) {
            String configSLPEVENTFILE = null;          
            if (System.getProperty("catalina.home") != null) 
                configSLPEVENTFILE = System.getProperty("catalina.home")+"/webapps/wsami/WEB-INF/web.xml";
            else if (System.getProperty("jetty.home") != null) 
                configSLPEVENTFILE = System.getProperty("jetty.home")+"/wsami/WEB-INF/web.xml";
            
            Syslog.error(SLPMgr.class,"File "+filename+" not found: please set the right value in "+configSLPEVENTFILE);
        } catch (IOException ex) {
            String configSLPEVENTFILE = null;          
            if (System.getProperty("catalina.home") != null) 
                configSLPEVENTFILE = System.getProperty("catalina.home")+"/webapps/wsami/WEB-INF/web.xml";
            else if (System.getProperty("jetty.home") != null) 
                configSLPEVENTFILE = System.getProperty("jetty.home")+"/wsami/WEB-INF/web.xml";
            
            Syslog.error(SLPMgr.class,"File "+filename+" not found: please set the right value in "+configSLPEVENTFILE);
        }
            
    }
    
    
    public static void main(String[] args) {
        SLPMgr mgr = new SLPMgr();
        mgr.writeSLPConfFile();
    }
}