package CoreBroker;

import java.net.*;
import java.io.OutputStream;

import org.w3c.dom.*;
import java.util.*;

import java.util.jar.JarEntry;
import java.util.jar.JarFile;
import java.util.jar.JarInputStream;

import java.io.IOException;
import java.io.InputStream;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;




public class Utils {

    
    public static void printDoc(Document doc)
    {
        Element root = doc.getDocumentElement();       
        Vector allNodes = new Vector();
        int index = 0;
        Node nodeRef = null;
        allNodes.add(root);

        while (index < allNodes.size())
        {
            nodeRef = (Node)allNodes.get(index);
            
            if (!nodeRef.getNodeName().equals("#text"))
            {
                System.out.print("<"+nodeRef.getNodeName()+" ");

                // print attributes
                NamedNodeMap attrs = nodeRef.getAttributes();
                if (attrs != null)
                    for (int i=0; i<attrs.getLength(); i++)
                        System.out.print(" "+attrs.item(i).getNodeName()+"="+attrs.item(i).getNodeValue());            

                // add its children nodes
                NodeList list = nodeRef.getChildNodes();
                if (list != null)
                    for (int i = 0; i<list.getLength(); i++)
                        allNodes.add(index+1+i, list.item(i));

                System.out.println(">");
            }
            index++;            
        }        
        System.out.println("\n");        
    }   

    
    
    public static void printDocToStream(Document doc, OutputStream os) {
        try {    
            org.apache.xml.serialize.OutputFormat format = 
                    new org.apache.xml.serialize.OutputFormat(doc);
            format.setIndent(3);
            format.setLineWidth(60);
            //java.io.OutputStream os = new java.io.FileOutputStream("tmp/wsdd.conf");
            org.apache.xml.serialize.XMLSerializer serial = 
            new org.apache.xml.serialize.XMLSerializer(os, format);
            serial.asDOMSerializer();
            serial.serialize(doc.getDocumentElement());
            //java.io.FileInputStream is = new java.io.FileInputStream("tmp/wsdd.conf");
            //csoap.GlobalManaging.receiveWsdd(is);
        } catch (Exception ex) {
           ex.printStackTrace();
        } 
    }
    
    
    public static JarFile readJarFile(String fileName){
	try {
		JarFile jarFile=new JarFile(fileName);
		return jarFile;
	}
	catch (java.io.IOException e) {
		Syslog.warning(Utils.class,"Error during jar file read operation...");
		e.printStackTrace();
		return null;
	}
	
    }//end readJarFile


    public static String[] getJarClassList(String fileName) {

            JarFile jarFile=readJarFile(fileName);

            Enumeration enum=jarFile.entries();
            int count=0;
            //counting the files...
            while (enum.hasMoreElements()) {
                    JarEntry jarEntry=(JarEntry)enum.nextElement();
                    count++;
            }

            //initializing the array of strings...
            String[] tempArr=new String[count];
            enum=jarFile.entries();
            count=0;
            Vector classesVector=new Vector();

            while (enum.hasMoreElements()) {
                    JarEntry jarEntry=(JarEntry)enum.nextElement();
                    tempArr[count]=jarEntry.getName();
                    int index=tempArr[count].indexOf('.');

                    //if an extension exists...
                    if (index!=-1) {
                            String extension=tempArr[count].substring(index+1);
                            //...test if it is a class
                            if (extension.equals("class")) {
                                    String temp=tempArr[count].replace('/','.');
                                    int index2=temp.lastIndexOf('.');
                                    String temp2=temp.substring(0,index2);
                                    classesVector.add(temp2);
                                    Syslog.debug(Utils.class,temp2);
                            }
                    }
                    count++;
            }
            Object[] retObjArr=classesVector.toArray();
            String[] retArr=new String[retObjArr.length];
            //cast to String
            for (int i=0;i<retArr.length;i++) {
                    retArr[i]=(String)retObjArr[i];
            }

            return retArr;
    }//end getClassList

    
    public static String[] extractJarFile(String jarFileName, String destDir) {
	
        Vector classesVector=new Vector();
	JarFile jarFile=readJarFile(jarFileName);
        java.util.Properties props = System.getProperties();
        String fileSeparator = props.getProperty("file.separator");         
	
	try {
		InputStream in=new BufferedInputStream(new FileInputStream(jarFileName));
		JarInputStream jarIn=new JarInputStream(in);
		JarEntry e;
	
		while ((e=(JarEntry)jarIn.getNextEntry())!=null) {
		
			String correctFileName = e.getName().replace('/',fileSeparator.charAt(0));
                        String extractingFileName = destDir+correctFileName;
			File file=new File(extractingFileName);
			
			int ind=extractingFileName.lastIndexOf(fileSeparator);
			String dirPathString=extractingFileName.substring(0,ind);

			File dirPath=new File(dirPathString); 

			dirPath.mkdirs();
			if (!file.isDirectory()) {
                                file.createNewFile();
				FileOutputStream out=new FileOutputStream(extractingFileName);
				byte[] b=new byte[512];
				int len=0;
				while ((len=jarIn.read(b))!=-1) {
					out.write(b,0,len);
				}
				out.close();
                                classesVector.add(extractingFileName);
			}
		}//end while ((e=jarIn.getNextEntry())!=null)
	
		in.close();
		jarIn.close();
        } catch (IOException e2) {
		Syslog.warning(Utils.class,"Error during deploy");
		e2.printStackTrace();
	}

        String[] classesArray = new String[classesVector.size()];
        classesVector.copyInto(classesArray);
        return classesArray;	
	
    }//end class deploy


    public static String getLocalHostRandomString()
    {
        // generate CustomizerSessionID with random + IP address
        String s = null;
        try {
	    int[] addr = {0,0,0,0};
	    
	    String[] hostAddresses = (new IFUtils()).getLocalHostAddresses();
	    if (hostAddresses != null && hostAddresses.length>0) {
		int index = 0;
		for (int i=0; i<4; i++) {
		    int indexDot = hostAddresses[0].indexOf(".",index);
		    String number = "0";
		    if (indexDot != -1 )
			number = hostAddresses[0].substring(index,indexDot);
		    else
			number = hostAddresses[0].substring(index);

		    addr[i] = (new Integer(number)).intValue();
		    index = indexDot+1;
		}
	    } /*else 
		addr = java.net.InetAddress.getLocalHost().getAddress();*/
	    
	    for (int i=0; i<4; i++)
		Syslog.debug(Utils.class,"addrbyte["+i+"]="+addr[i]);

            long nl = addr[0]+addr[1]*256+addr[2]*256*256+addr[3]*256*256*256;
            Random rand = new Random(new Date().getTime());
            int n = rand.nextInt(Integer.MAX_VALUE);
            nl += n*(long)256*256*256*256;
            s = String.valueOf(nl);
        }catch (Exception e){
            e.printStackTrace();
        }
	return s;
    }
    
    
}
