package NDService;

import java.util.*;
import org.xml.sax.InputSource;
import org.apache.xerces.parsers.SAXParser;
import org.xml.sax.XMLReader;
import java.io.*;

import CoreBroker.Syslog;

public class Favorites 
{
    Vector favorites = new Vector();
    XMLReader xr ;
    SAXHandler sh;
    String filePath="";

    public Favorites(String filePath)
    {
	this.filePath = filePath;
	try
	    {
		
		xr = new SAXParser();
		sh = new SAXHandler();
		xr.setContentHandler(sh);
		xr.setErrorHandler(sh);

		FileInputStream favoritesFile = new FileInputStream(filePath);
		xr.parse(new InputSource(favoritesFile));
		favorites = sh.getFavorites();

	    }
	catch (Exception ex)
	    {
		Syslog.error(this,"Error at parsing favorites.xml file");
		ex.printStackTrace();
	    }
    }

    public Iterator getFavorite(String WAU)
    {
	Vector toReturn = new Vector();
	for(int i=0;i<favorites.size();i++)
	    {
		Favorite favorite = (Favorite)favorites.elementAt(i);
		if (favorite.getWAU().equals(WAU)) toReturn.add(favorite); 
	    }
	return toReturn.iterator();
    }

    public Iterator getAllFavorites()
    {
	return favorites.iterator();
    }

    public boolean addFavorite(Favorite favorite)
    { 
	favorites.addElement(favorite);
	return saveChange();
    }
    public void validateFavorite(String WAU, String EP)
    {
	for (int i=0;i<favorites.size();i++)
	    {
		Favorite favorite = (Favorite)favorites.elementAt(i);
		if (favorite.getWAU().equals(WAU) && favorite.getAddress().equals(EP)) favorite.setValidate(true);
	    }
	saveChange();
    }

    public void invalidateFavorite(String EP)
    {
	for (int i=0;i<favorites.size();i++)
	    {
		Favorite favorite = (Favorite)favorites.elementAt(i);
		if (favorite.getAddress().equals(EP)) favorite.setValidate(false);
	    }
	saveChange();
    }

    public boolean removeFavorite(String WAU, String EP)
    {
	int i=0;
	while (i<favorites.size())
	    {
		Favorite favorite = (Favorite)favorites.elementAt(i);
		if (favorite.getWAU().equals(WAU) && favorite.getAddress().equals(EP)) favorites.removeElementAt(i);
		else i++; 
	    }
	return saveChange();
    }

    public boolean saveChange()
    {
	try
	    {
		FileWriter favoritesFile = new FileWriter(filePath);
		favoritesFile.write("<favorites>");
		for (int i=0;i<favorites.size();i++)
		    {
			Favorite favorite = (Favorite)favorites.elementAt(i);
			favoritesFile.write("\n\t<favorite>");
			
			favoritesFile.write("\n\t\t<wau>"+favorite.getWAU()+"</wau>");
			favoritesFile.write("\n\t\t<ep>"+favorite.getAddress()+"</ep>");
			favoritesFile.write("\n\t\t<instanceURL>"+favorite.getInstanceURL()+"</instanceURL>");
			favoritesFile.write("\n\t\t<LCwau>"+favorite.getLCwau()+"</LCwau>");
			favoritesFile.write("\n\t\t<RCwau>"+favorite.getRCwau()+"</RCwau>");
			if (favorite.isColocation())
				       favoritesFile.write("\n\t\t<colocation>true</colocation>");
			else  favoritesFile.write("\n\t\t<colocation>false</colocation>");
			if (favorite.getValidate())
			    favoritesFile.write("\n\t\t<validate>yes</validate>");
			else favoritesFile.write("\n\t\t<validate>no</validate>");
			favoritesFile.write("\n\t</favorite>");
		    }
		favoritesFile.write("\n</favorites>");
		favoritesFile.close();
	    }
	catch (Exception ex)
	    {
		Syslog.error(this,"Error at writing favorite.xml file");
		return false;
	    }
	return true;
    }
}
