package NDService;

import java.util.Vector;
import com.solers.slp.*;
import CoreBroker.Syslog;

public class SLPFindServices {
        
	private native ServiceURL[] findServices(ServiceType type, Vector scopes, String searchFilter);
        //private native void findServices(ServiceType type, Vector scopes, String searchFilter);
        
	static  {
	    java.util.Properties props = System.getProperties();
	    String osname = props.getProperty("os.name");

	    if (osname.indexOf("Windows") != -1) {
	            //String sharedLibPath = "c:\\java\\jakarta-tomcat-4.1.27\\shared\\lib";            
            	String sharedLibPath = System.getProperty("catalina.home")+"/shared/lib";                            
	            String libSlpPath = sharedLibPath+"\\slp.dll"; 
	            System.load(libSlpPath);
	            String libNDslpPath = sharedLibPath+"\\NDslp.dll"; 
	            System.load(libNDslpPath);
	    } else if (osname.indexOf("Linux") != -1) {
            	String sharedLibPath = System.getProperty("catalina.home")+"/shared/lib";            
	        //    String sharedLibPath = "/opt/jakarta-tomcat-4.1.27/shared/lib";            
                String libSlpPath = sharedLibPath+"/libslp.so"; 
                System.load(libSlpPath);
                String libNDslpPath = sharedLibPath+"/libNDslp.so"; 
                System.load(libNDslpPath);
	    }

	}
       
        public static ServiceURL[] find(ServiceType servType, Vector scopes, String filter) {
            SLPFindServices finder = new SLPFindServices();

            //Syslog.debug(this, "FIND with : "+filter);
            /*
            java.util.Calendar calend = new java.util.GregorianCalendar();
            Syslog.debug(this,calend.getTime().toString());
            Syslog.debug(this,"\tfree(before call)="+java.lang.Runtime.getRuntime().freeMemory());
            Syslog.debug(this,"\ttotal(before call)="+java.lang.Runtime.getRuntime().totalMemory());            
            */
            
            try {
                ServiceURL[] srvs = finder.findServices(servType, scopes, filter);
                int srvsCounter = -1;
                
                if (srvs != null) {
                    for (int i=0; i<srvs.length; i++)
                        if (srvs[i] != null) {
                            //Syslog.debug(this,Service "+i+" = "+srvs[i].toString());
                            srvsCounter = i+1;
                        }

                    if (srvsCounter == -1) 
                        return null;
                    else {
                        ServiceURL[] srvURLs = new ServiceURL[srvsCounter];
                        for (int i=0; i<srvsCounter; i++)
                            srvURLs[i] = srvs[i];
                        
                        /*
                        Syslog.debug(this,"free(after call)="+java.lang.Runtime.getRuntime().freeMemory());
                        Syslog.debug(this,"\ttotal(after call)="+java.lang.Runtime.getRuntime().totalMemory());            
                        */

                        return srvURLs;
                    }
                } else
                    return null;
                
            } catch (Exception ex) {
                ex.printStackTrace();
            }
            return null;
        }
}
 