package WSAMI;

import CoreBroker.CBException;

import org.w3c.dom.*;
import javax.xml.parsers.*;

import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import java.io.IOException;

public class WSAMICustomizerDocument extends WSAMIDocument {
    private String local;
    private String remote;
    private String[] qosCriterion;
    private boolean colocation = false ;

    public WSAMICustomizerDocument() {}
   
    public WSAMICustomizerDocument(String XSDfilesPath, String filename) 
            throws CBException {

       
        Document document = getDocumentFromFilename(XSDfilesPath, filename);
       
        //Node customizerNode = document.getElementsByTagName("Customizer").item(0);
        //this.setName(customizerNode.getAttributes().item(0).getNodeValue());
        
        Node localNode = document.getElementsByTagName("Local").item(0);
        this.setLocal(localNode.getAttributes().item(0).getNodeValue());
        
        Node remoteNode = document.getElementsByTagName("Remote").item(0);
        this.setRemote(remoteNode.getAttributes().item(0).getNodeValue());
        
        Node customizerNode = document.getElementsByTagName("Customizer").item(0);
        Node colocationNode = customizerNode.getAttributes().getNamedItem("Colocation");
        
        if (colocationNode.getNodeValue().equals("false"))
            this.setColocation(false);
        else
            this.setColocation(true);
        
        NodeList qosCriterionNodes = document.getElementsByTagName("QoSCriterion");
        String[] qosCrit = new String[qosCriterionNodes.getLength()];
       
        for (int i=0; i<qosCriterionNodes.getLength(); i++)
            qosCrit[i] = qosCriterionNodes.item(i).getAttributes().item(0).getNodeValue();
        this.setQoSCriterion(qosCrit);

    }
   
   
    public void setLocal(String _local) {
      local = _local;
    }

    public void setRemote(String _remote) {
      remote = _remote;
    }

    public void setColocation(boolean _colocation) {
      colocation = _colocation;
    }
    
    public void setQoSCriterion(String[] _qosCriterion) {
        qosCriterion = new String[_qosCriterion.length];
        for (int i=0; i<_qosCriterion.length; i++)
            qosCriterion[i] = _qosCriterion[i];
    }

    public String getLocal() {
        return local;
    }

    public String getRemote() {
        return remote;
    }

    public boolean getColocation() {
        return colocation;
    }
    
    public String[] getQoSCriterion() {
        return qosCriterion;
    }
   
    public Document getXML() {
        Document d = super.getXML();
        if (d != null) {
            Element definition = (Element)d.getElementsByTagName("Definition").item(0);
          
            Element el1 = d.createElement("Customizer");
            el1.setAttribute("name",name);
            if (getColocation())
                el1.setAttribute("Colocation", "true");
            else
                el1.setAttribute("Colocation", "false");            
            definition.appendChild(el1);

            Element el2 = d.createElement("QoSCriterion");
            el2.setAttribute("name", qosCriterion[0]);
            el1.appendChild(el2);
          
            el2 = d.createElement("Local");
            el2.setAttribute("hrefSchema", local);
            el1.appendChild(el2);

            el2 = d.createElement("Remote");
            el2.setAttribute("hrefSchema", remote);
            el1.appendChild(el2);
         
            return d;
        } else
            return null;
    }

}

