package WSAMI;

import CoreBroker.CBException;

import org.w3c.dom.*;
import javax.xml.parsers.*;

import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import java.io.IOException;


public class WSAMIServiceDocument extends WSAMIDocument {
    
    private String _abstract;
    private String concrete;
    private WSAMIServiceDocument_RequestService[] ReqServices;

    public WSAMIServiceDocument() {}
   
    public WSAMIServiceDocument(String XSDfilesPath, String filename) 
            throws CBException {
                         
        Document document = getDocumentFromFilename(XSDfilesPath, filename);     
        
        //Node serviceNode = document.getElementsByTagName("Service").item(0);
        //this.setName(serviceNode.getAttributes().item(0).getNodeValue());
        
        Node concreteNode = document.getElementsByTagName("Concrete").item(0);
        this.setConcrete(concreteNode.getAttributes().item(0).getNodeValue());
        
        Node abstractNode = document.getElementsByTagName("Abstract").item(0);
        this.setAbstract(abstractNode.getAttributes().item(0).getNodeValue());
        
        NodeList reqServiceNodes = document.getElementsByTagName("ReqService");

        this.setNReqServices(reqServiceNodes.getLength());
        for (int i=0; i<reqServiceNodes.getLength(); i++) {
            String name = null;
            boolean optional = false;
            boolean multiple = false;
            boolean instance = false;
            try {
               name = reqServiceNodes.item(i).getAttributes().getNamedItem("name").getNodeValue();
            } catch (Exception ex) {
                // if doesnot exist the null value generates an Exception
            }
            try {
              multiple = Boolean.valueOf(reqServiceNodes.item(i).getAttributes().getNamedItem("multiple").getNodeValue()).booleanValue();
            } catch (Exception ex) {
                // if doesnot exist the null value generates an Exception
            }
            try {
               optional = Boolean.valueOf(reqServiceNodes.item(i).getAttributes().getNamedItem("optional").getNodeValue()).booleanValue();
            } catch (Exception ex) {
                // if doesnot exist the null value generates an Exception
            }
            try {
               instance = Boolean.valueOf(reqServiceNodes.item(i).getAttributes().getNamedItem("instance").getNodeValue()).booleanValue();
            } catch (Exception ex) {
                // if doesnot exist the null value generates an Exception
            }
         this.setReqService(i, name, optional, multiple, instance);
        }                     
    }
   
    public void setAbstract(String _abstract_) {
        _abstract = _abstract_;
    }

    public void setConcrete(String _concrete) {
        concrete = _concrete;
    }

    public void setNReqServices(int n) {
        ReqServices = new WSAMIServiceDocument_RequestService[n];
    }

    public void setReqService(int pos, String _abstract_, 
            boolean _isOptional, boolean _isMultiple, boolean _isInstance) {
        ReqServices[pos] =  new WSAMIServiceDocument_RequestService(_abstract_, _isOptional, _isMultiple, _isInstance);
    }

    public String getAbstract() {
        return _abstract;
    }

    public String getConcrete() {
        return concrete;
    }

    public int getNReqServices() {
        return ReqServices.length;
    }

    public WSAMIServiceDocument_RequestService getReqService(int pos) {
        if (pos > ReqServices.length)
            return null;
        else
            return new WSAMIServiceDocument_RequestService(ReqServices[pos].getAbstract(),
                            ReqServices[pos].isOptional(), 
                            ReqServices[pos].isMultiple(), 
                            ReqServices[pos].isInstance());
    }

    public WSAMIServiceDocument_RequestService[] getReqServices() {
        
        if (getNReqServices() == 0)
            return null;
        else {
            WSAMIServiceDocument_RequestService[] reqServ = 
                            new WSAMIServiceDocument_RequestService[getNReqServices()];
            for (int i=0; i<getNReqServices(); i++)
                reqServ[i] = getReqService(i);
            return reqServ;
        }
    }
   
    public Document getXML() {            
       Document d = super.getXML();
       if (d != null) {          
           Element definition = (Element)d.getElementsByTagName("Definition").item(0);
           Element serviceEl = d.createElementNS("http://xml.apache.org/axis/wsdd/","Service");
           serviceEl.setAttribute("name",name);
           definition.appendChild(serviceEl);

           Element abstractEl = d.createElementNS("http://xml.apache.org/axis/wsdd/","Abstract");
           abstractEl.setAttribute("hrefSchema", _abstract);
           serviceEl.appendChild(abstractEl);
          
           Element concreteEl = d.createElementNS("http://xml.apache.org/axis/wsdd/","Concrete");
           concreteEl.setAttribute("hrefSchema", concrete);
           serviceEl.appendChild(concreteEl);
           
           // Add required services XML tags
           
           return d;          
       } else
           return null;
   }
   
}

