package csoap.wsdl;

import javax.xml.namespace.QName;
/**

* ElementDesc.java
*
* @author Mirco Musolesi
* @version 0.1 July 2003
*  
* This class is modelled according the org.apache.axis.description.ElementDesc class written
* and org.apache.axis.description.FieldDesc by Glen Daniels.
*  
*/
public class ElementDesc {

/**The name of the Java element in question*/
private String fieldName;

/**The XML QName this element maps to*/
private QName xmlName;

/**The XML Type this element maps to/from*/
private QName xmlType;

/**The minOccurs value*/
private int minOccurs;

/**The maxOccurs value*/
private int maxOccurs;



/**
* Constructor
*/
public ElementDesc() {
}



/**
* Obtains the fieldName for this element
*/
public String getFieldName() {
	return fieldName;
}



/**
* Sets the fieldName for this element
*/
public void setFieldName(String fieldName) {
	this.fieldName=fieldName;
}



/**
* Obtains the XML QName for this element
*/
public QName getXmlName() {
	return xmlName;
}



/**
* Sets the XML QName for this element.
*/
public void setXmlName(QName xmlName) {
	this.xmlName=xmlName;
}



/**
* Obtains the XML type (for example xsd:string) for this element.
*/
public QName getXmlType () {
	return xmlType;
}



/**
* Sets the XML type for this element
*/
public void setXmlType(QName xmlType) {
	this.xmlType=xmlType;	
}



/**
* Obtains minOccurs
*/
public int getMinOccurs() {
	return minOccurs;
}



/**
* Sets minOccurs
*/
public void setMinOccurs(int minOccurs) {
	this.minOccurs=minOccurs;
}



/**
* Obtains maxOccurs
*/
public int getMaxOccurs() {
	return maxOccurs;
}



/**
* Set maxOccurs
*/
public void setMaxOccurs(int maxOccurs) {
	this.maxOccurs=maxOccurs;
}


}//end class
