/*
*
* Generator.java
*
* @author Mirco Musolesi
* @version 0.1 July 2003
*
*  
*/


package csoap.wsdl;

import javax.wsdl.*;
import javax.wsdl.factory.*;
import javax.wsdl.xml.*;
import javax.xml.namespace.*;
import javax.wsdl.extensions.*;
import javax.wsdl.extensions.soap.*;

import javax.xml.parsers.*;

import org.w3c.dom.*;
import org.xml.sax.*; 

import com.ibm.wsdl.*;

//WSIF
import org.apache.wsif.*;
import org.apache.wsif.schema.*;
import org.apache.wsif.wsdl.*;
import org.apache.wsif.WSIFConstants;
//import org.apache.commons.logging.*;

//Xerces
import org.apache.xerces.parsers.DOMParser;

import java.io.*;
import java.net.URL;
import java.net.MalformedURLException;

import java.util.Collection;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.StringTokenizer;
import java.util.Vector;


public class Generator extends csoap.wsdl.DeploymentGenerator {

    //    boolean BigDecimalSupported = false;

/*
* Constructor
*/
    public Generator() 
    {
	super();
    }



/**
* Gets the correct prefix given a namespace. If the namespace is unknown, it returns null
* @param nameSpace a namespace
* @retutn the prefix if the mapping is known, null otherwise.
*/

    /*
private String getPrefix(String nameSpace) {


        String schemaNameSpace1999="http://www.w3.org/1999/XMLSchema";
	String schemaNameSpace2000="http://www.w3.org/2000/XMLSchema";
	String schemaNameSpace2001="http://www.w3.org/2001/XMLSchema";
	String result=null;
	if (nameSpace.equals(schemaNameSpace1999))
		result="xsd";
        else if (nameSpace.equals(schemaNameSpace2000))
		result="xsd";
        else if (nameSpace.equals(schemaNameSpace2001))
		result="xsd";
	return result;
}
    */



/**
* Gets the package given the whole type name.
* Example getPackageName(java.lang.String) is java.lang
* @param str string to be processed
* @return the package name
*/
    /*
private String getPackageName (String str) {
 	int index=str.lastIndexOf(".");
 	String substring=str.substring(0,index);
 	return substring;
}


    */

/**
* Gets the Java type that maps the given XML type. QName class represents the value of 
* a qualified name as specified in XML Schema Part2: Datatypes specification. 
* @param qname a qname type representing the given XML type to be converted
* @return the java type if the mapping is known or the suitable user-defined Java type
*/
    /*
private String getJavaType (QName qname) {
	String localPart=qname.getLocalPart();
	String namespace=qname.getNamespaceURI();
	return getJavaType(localPart,namespace);
}

    */


/**
* Gets the Java type that maps the given XML data type 
* @param XMLdataType a XML data type
* @param namespace its namespace
* @return the Java type if the mapping is known or the suitable user-defined Java type 
*/
    /*
private String getJavaType (String XMLDataType, String namespace) {
		
	String ret=null;
	String schemaNameSpace1999="http://www.w3.org/1999/XMLSchema";
	String schemaNameSpace2000="http://www.w3.org/2000/XMLSchema";
	String schemaNameSpace2001="http://www.w3.org/2001/XMLSchema";
	String soapNameSpace="http://schemas.xmlsoap.org/soap/encoding/";
	String wsdlNameSpace="http://schemas.xmlsoap.org/wsdl/";
	//case XML Schema type)
	if ((namespace.equals(schemaNameSpace1999))||
	    (namespace.equals(schemaNameSpace2000))||
	    (namespace.equals(schemaNameSpace2001))) {
		if (XMLDataType.equals("string")) ret="java.lang.String";
		else if (XMLDataType.equals("integer")) ret="java.math.BigInteger"; 
		else if (XMLDataType.equals("int")) ret="int";
		else if (XMLDataType.equals("long")) ret="long";
		else if (XMLDataType.equals("short")) ret="short";
		else if (XMLDataType.equals("decimal")) ret="java.math.BigDecimal";	

		//****************************************************
		//********* ADD FOR BIGDECIMAL SUPPORT WITH CVM
		//****************************************************

		//	else if (XMLDataType.equals("decimal") && BigDecimalSupported) ret="java.math.BigDecimal";		
		//else if (XMLDataType.equals("decimal") && !BigDecimalSupported) ret="java.lang.Double";
		
		else if (XMLDataType.equals("float")) ret="float";
		else if (XMLDataType.equals("double")) ret="double";
		else if (XMLDataType.equals("boolean")) ret="boolean";
		else if (XMLDataType.equals("byte")) ret="byte";
		else if (XMLDataType.equals("QName")) ret="java.xml.rpc.namespace.QName";
		else if (XMLDataType.equals("dateTime")) ret="java.util.Calendar";
		else if (XMLDataType.equals("base64Binary")) ret="byte[]";
		else if (XMLDataType.equals("hexBinary")) ret="byte[]";
	}
	else if (namespace.equals(soapNameSpace)) {
		if (XMLDataType.equals("string")) ret="java.lang.String";
		else if (XMLDataType.equals("boolean")) ret="java.lang.Boolean";
		else if (XMLDataType.equals("float")) ret="java.lang.Float";
		else if (XMLDataType.equals("double")) ret="java.lang.Double";
		else if (XMLDataType.equals("decimal")) ret="java.math.BigDecimal";
		else if (XMLDataType.equals("int")) ret="java.lang.Integer";
		else if (XMLDataType.equals("short")) ret="java.lang.Short";
		else if (XMLDataType.equals("byte")) ret="java.lang.Byte";
		else if (XMLDataType.equals("base64")) ret="Byte[]";
	}

	
	else if (namespace.substring(0,4).equals("urn:")) {
		//case URN-type namespace
		String namePackage=resolveNamespaceURN(namespace);	
		String upperCaseXMLDataType=firstLetterToUpperCase(XMLDataType);
		ret=namePackage+"."+upperCaseXMLDataType;
	} else	{	
		//everithing else (URL style namespace)
		String namePackage=resolveNamespaceURL(namespace);
		String upperCaseXMLDataType=firstLetterToUpperCase(XMLDataType);
		ret=namePackage+upperCaseXMLDataType;
	}

    	//System.out.println("XMLDataType="+XMLDataType+"  namespace="+namespace+"   javaType="+ret);
	
	return ret;

}

*/


/**
* Gets the Java type holder for the given XML data type
* @param XMLDataType a XML data type
* @param namespace its namespace
* @return the Java type if the mapping is known or the suitable user-defined Java
*/
private String getJavaTypeHolder(String XMLDataType, String namespace) {
	
	String ret=null;
	String schemaNameSpace1999="http://www.w3.org/1999/XMLSchema";
	String schemaNameSpace2000="http://www.w3.org/2000/XMLSchema";
	String schemaNameSpace2001="http://www.w3.org/2001/XMLSchema";
	String soapNameSpace="http://schemas.xmlsoap.org/soap/encoding/";
	String wsdlNameSpace="http://schemas.xmlsoap.org/wsdl/";
	//case XML Schema type)
	if ((namespace.equals(schemaNameSpace1999))||
	    (namespace.equals(schemaNameSpace2000))||
	    (namespace.equals(schemaNameSpace2001))) {
		if (XMLDataType.equals("string")) ret="javax.xml.rpc.holders.StringHolder";
		else if (XMLDataType.equals("integer")) ret="javax.xml.rpc.holders.BigIntegerHolder";
		else if (XMLDataType.equals("int")) ret="javax.xml.rpc.holders.IntHolder";
		else if (XMLDataType.equals("short")) ret="javax.xml.rpc.holders.ShortHolder";
		else if (XMLDataType.equals("decimal")) ret="javax.xml.rpc.holders.BigDecimalHolder";

		//****************************************************
		//********* ADD FOR BIGDECIMAL SUPPORT WITH CVM
		//****************************************************
		
		//else if (XMLDataType.equals("decimal") && BigDecimalSupported) ret="javax.xml.rpc.holders.BigDecimalHolder";
		//else if (XMLDataType.equals("decimal") && !BigDecimalSupported) ret="javax.xml.rpc.holders.DoubleHolder";
		 
		else if (XMLDataType.equals("float")) ret="javax.xml.rpc.holders.FloatHolder";
		else if (XMLDataType.equals("double")) ret="javax.xml.rpc.holders.DoubleHolder";
		else if (XMLDataType.equals("boolean")) ret="javax.xml.rpc.holders.BooleanHolder";
		else if (XMLDataType.equals("byte")) ret="javax.xml.rpc.holders.ByteHolder";
		else if (XMLDataType.equals("QName")) ret="javax.xml.rpc.holders.QNameHolder";
		else if (XMLDataType.equals("DateTime")) ret="javax.xml.rpc.holders.CalendarHolder";
		else if (XMLDataType.equals("base64Binary")) ret="javax.xml.rpc.holders.ByteArrayHolder";
		else if (XMLDataType.equals("hexBinary")) ret="javax.xml.rpc.holders.ByteArrayHolder";
	}
	else if (namespace==soapNameSpace) {
		if (XMLDataType.equals("string")) ret="javax.xml.rpc.holders.StringHolder";
		else if (XMLDataType.equals("boolean")) ret="javax.xml.rpc.holders.BooleanWrapperHolder";
		else if (XMLDataType.equals("float")) ret="javax.xml.rpc.holders.FloatWrapperHolder";
		else if (XMLDataType.equals("double")) ret="javax.xml.rpc.holders.DoubleWrapperHolder";
		else if (XMLDataType.equals("decimal")) ret="javax.xml.rpc.holders.BigDecimalHolder";
		//****************************************************
		//********* ADD FOR BIGDECIMAL SUPPORT WITH CVM
		//****************************************************
		
		//else if (XMLDataType.equals("decimal") && BigDecimalSupported) ret="Java.xml.rpc.holders.BigDecimalHolder";
		//else if (XMLDataType.equals("decimal") && !BigDecimalSupported) ret="Java.xml.rpc.holders.DoubleHolder";
		
		else if (XMLDataType.equals("int")) ret="javax.xml.rpc.holders.IntegerWrapperHolder";
		else if (XMLDataType.equals("short")) ret="javax.xml.rpc.holders.ShortWrapperHolder";
		else if (XMLDataType.equals("byte")) ret="javax.xml.rpc.holders.ByteWrapperHolder";
		//else if (XMLDataType.equals("base64")) ret="javax.xml.rpc.holders. ";
	}
	
	else if (namespace.substring(0,4).equals("urn:")) {
		//case URN-type namespace
		String namePackage=resolveNamespaceURN(namespace);	
		String upperCaseXMLDataType=firstLetterToUpperCase(XMLDataType);
		ret=namePackage+"."+"holders"+"."+upperCaseXMLDataType+"Holder";
	} else	{	
		//everithing else (URL style namespace)
		String namePackage=resolveNamespaceURL(namespace);
		String upperCaseXMLDataType=firstLetterToUpperCase(XMLDataType);
		ret=namePackage+"holders"+"."+upperCaseXMLDataType+"Holder";
	}

	
    	//System.out.println("XMLDataType="+XMLDataType+"   namespace="+namespace+"   javaType="+ret);
	
	return ret;

}



/**
* Verifies if the given java type Holder is standard (in other words if it contained in the java.xml.rpc.holders
* package) or not
* @param holderName a string containing the holder name
* @return true if it is standard, false otherwise
*/
private boolean isAStandardHolder(String holderName) {
	boolean ret=false;
		if (holderName.equals("javax.xml.rpc.holders.StringHolder")) ret=true;
		else if (holderName.equals("javax.xml.rpc.holders.BigIntegerHolder")) ret=true;
		else if (holderName.equals("javax.xml.rpc.holders.IntHolder")) ret=true;
		else if (holderName.equals("javax.xml.rpc.holders.ShortHolder")) ret=true;
		else if (holderName.equals("javax.xml.rpc.holders.BigDecimalHolder")) ret=true;
		else if (holderName.equals("javax.xml.rpc.holders.FloatHolder")) ret=true;
		else if (holderName.equals("javax.xml.rpc.holders.DoubleHolder")) ret=true;
		else if (holderName.equals("javax.xml.rpc.holders.BooleanHolder")) ret=true;
		else if (holderName.equals("javax.xml.rpc.holders.ByteHolder")) ret=true;
		else if (holderName.equals("javax.xml.rpc.holders.QNameHolder")) ret=true;
		else if (holderName.equals("javax.xml.rpc.holders.CalendarHolder")) ret=true;
		else if (holderName.equals("javax.xml.rpc.holders.ByteArrayHolder")) ret=true;
		else if (holderName.equals("javax.xml.rpc.holders.ByteArrayHolder")) ret=true;
		else if (holderName.equals("Java.xml.rpc.holders.BooleanWrapperHolder")) ret=true;
		else if (holderName.equals("Java.xml.rpc.holders.FloatWrapperHolder")) ret=true;
		else if (holderName.equals("Java.xml.rpc.holders.DoubleWrapperHolder")) ret=true;
		else if (holderName.equals("Java.xml.rpc.holders.BigDecimalHolder")) ret=true;
		else if (holderName.equals("Java.xml.rpc.holders.IntegerWrapperHolder")) ret=true;
		else if (holderName.equals("Java.xml.rpc.holders.ShortWrapperHolder")) ret=true;
		else if (holderName.equals("Java.xml.rpc.holders.ByteWrapperHolder")) ret=true;
		//else if (holderName.equals("Java.xml.rpc.holders."))ret=true;
	return ret;
}
	
	
	

/**
* Resolves URN-type namespaces, trasforming them into package names according the specification
*	
* @param nsURN a URN-type namespace
* @return the package name according the specification
*/
/*
private String resolveNamespaceURN (String nsURN) {
	
	
	// PLEASE NOTE: Current limitations
	// The current implementation is able to manage a namespace with the following form:
	// 
	// NSS=TOK1["."TOK1]*
	// TOK1=AlphaChar[AlphaNumChar]*
	//
	//
	String ret=new String("");
	String localPartNameSpace=null;
	String initialPartNameSpace=nsURN.substring(0,4);
	localPartNameSpace=nsURN.substring(4);
	
	//changing ":" with "."
	
	StringTokenizer strTok=new StringTokenizer(localPartNameSpace,".");
	int numTokens=strTok.countTokens();
	String[] fragments=new String[numTokens];
	StringBuffer strBuf=new StringBuffer();
	int k=0;
	while (strTok.hasMoreTokens()) {
		fragments[k]=strTok.nextToken();
		k++;
	}
	for (int p=numTokens-1;p>-1;p--) {
		//case of a fragment (a token) beginning with a digit
		if (startWithADigit(fragments[p]))
			fragments[p]=addAnUnderscoreBefore(fragments[p]);
			
		strBuf.append(fragments[p]);
		if (p!=0)
			strBuf.append(".");
	}
	
	
	ret=strBuf.toString(); //temporary
	
	
	return ret;
	
	
}// end resolveNameSpaceURN

*/


/**
* Resolves URL-type namespaces, trasforming them into package names according the specification
* @param nsURI a URL-type namespace
* @return the package name according the specification
* 
*/
/*
private String resolveNamespaceURL (String nsURI) {
 
	String ret=new String("");
	
	try {
		//creating URL...
		URL url=new URL(nsURI);
		
		//processing the so-called host part...
		String hostPart=url.getHost();
		//System.out.println("hostPart: "+hostPart);
		StringTokenizer strTok=new StringTokenizer(hostPart,".");
		int numTokens=strTok.countTokens();
		//System.out.println("The number of tokens is "+numTokens);
		String[] fragments=new String[numTokens];
		StringBuffer strBuf=new StringBuffer();
		int k=0;
		while (strTok.hasMoreTokens()) {
			fragments[k]=strTok.nextToken();
			k++;
		}
		for (int p=numTokens-1;p>-1;p--) {
			//System.out.println("p value is "+p+" when token is "+fragments[p]);
			strBuf.append(fragments[p]);
			if (p!=0)
				strBuf.append(".");	
		}
		
		//processing the so-called path part
		String pathPart=url.getPath();
		StringTokenizer strTok2=new StringTokenizer(pathPart,"/");
		int numTokens2=strTok2.countTokens();
		String[] fragments2=new String[numTokens2];
		StringBuffer strBuf2=new StringBuffer();
		k=0;
		while (strTok2.hasMoreTokens()) {
			String rawFragment=strTok2.nextToken();
			
			//Now we have to replace the character '.' with '_'
			StringTokenizer strTok3=new StringTokenizer(rawFragment,".");
			int numTokens3=strTok3.countTokens();
			String[] fragments3=new String[numTokens3];
			StringBuffer strBuf3=new StringBuffer();
		 	int r=0;
		 	while (strTok3.hasMoreTokens()) {
		 		fragments3[r]=strTok3.nextToken();
		 		r++;
			}
			for (int p=0;p<numTokens3;p++) {
				strBuf3.append(fragments3[p]);
				if (p<numTokens3-1)
					strBuf3.append("_");
			}
			fragments2[k]=strBuf3.toString();
			k++;
		}
		for (int p=0;p<numTokens2;p++) {
			strBuf2.append(fragments2[p]);
			if (p<numTokens2-1)
				strBuf2.append(".");
		}
						
			
		ret=strBuf.toString()+"."+strBuf2.toString();	
	}
	catch (MalformedURLException e) {
			System.err.println ("Error: invalid namespace definition.");
			e.printStackTrace();
	}
	
	
	//String nsURI.indexOf(":"); 
	//StringTokenizer strTok=new StringTokenizer(
	return ret;

}//end private String resolveNamespaceURL (String nsURI)


*/

/**
* Converts the first letter of the given string to upper case
* @param str a string
* @return the given string with the first letter converted to upper case
*/
/*
private String firstLetterToUpperCase(String str) {
	String initialLetterString=str.substring(0,1);
	String upperCaseInitialLetterString=initialLetterString.toUpperCase();
	String subString=str.substring(1);
	String retString=upperCaseInitialLetterString+subString;
	return retString;
}
*/



/**
* Converts the first letter of the given string to lower case
* @param str a string
* @return the given string with the first letter converted to lower case
*/
/*
private String firstLetterToLowerCase(String str) {
	String initialLetterString=str.substring(0,1);
	String lowerCaseInitialLetterString=initialLetterString.toLowerCase();
	String subString=str.substring(1);
	String retString=lowerCaseInitialLetterString+subString;
	return retString;
}
*/



/**
* Add an underscore before the given string. This method is mainly used in the case of
* string that begin with numbers.
* @param str a string
* @param a string that is composed by an initial underscore character, followed by the given string
*/
/*
private String addAnUnderscoreBefore(String str) {
	String underscore="_";
	String ret=new String(underscore+str);
	return ret;
}
*/



/**
* Returns true if the first character is a number, false otherwise.
* @param str a string
* @return true if the first character is a number, false otherwise
*/
/*
private boolean startWithADigit(String str) {
	boolean isADigit=false;
	char first=str.charAt(0);
	//System.out.println("The string is "+str);
	//System.out.println("First char is "+first);
	if (Character.isDigit(first)) {
		isADigit=true;
		//System.out.println(str+" starts with a digit");
	}
	return isADigit;
}

*/


/**
* Returns the correct classpath for the given package
* @param packageName a package name
* @return the directory  generated according standard Java rules
*/
private String package2Path (String packageName) {
	
	String ret=new String();
	StringTokenizer strTok=new StringTokenizer(packageName,".");
	int numTokens=strTok.countTokens();
	String[] fragments=new String[numTokens];
	StringBuffer strBuf=new StringBuffer();
	String fileSeparator=System.getProperty("file.separator");
	int k=0;
	while (strTok.hasMoreTokens()) {
		fragments[k]=strTok.nextToken();
		k++;
	}
	for (int p=0;p<fragments.length;p++) {
		strBuf.append(fragments[p]);
		if (p!=numTokens-1)
			strBuf.append(fileSeparator);
	}
	ret=strBuf.toString();
	return ret;	
}




/**
* Generates files for deployng webservices applications.
* The following files are generated:
*
1) a WSDD deploy file
*
* @param fileName the WSDL file
* @param side indicates if the generation is for client or served side only. "c" stands for CLIENT, while "s" stands for server.
* @param dirName the directory for generated files
* @param verbose if true, debugging information are displayed
* @param implClass parameter implClass
* @return true if the generation is successful, false otherwise
*/
public boolean generate(String fileName, String side, boolean verbose,String dirName,String implClass, String scope) {

   

try {	
    boolean generation = generateWSDD(fileName, side, verbose, dirName, implClass, scope);


    if (generation == false) System.out.println("Error in generator WSDD file");
     	
	//*****************************************  		
	//Third phase - generation of the WSDD file
	//*****************************************
				 	
        //Creation of the directory for the interface file
        //it's the same of wsdd file...

    String javaTypeDef=getJavaType(def.getQName());
    
    String packageName=getPackageName(javaTypeDef);

        //defining interface directoryname
    String interfaceDirName=new String(packageName);
    
    //Creation of the directory for generated files
    File dir=new File(dirName+fileSeparator+interfaceDirName);
    dir.mkdir();        
    
                        
    try{  
	
	if (!generateClientFilesOnly) {
	    
	    
            //Creation of the WSDD file
            FileWriter fw=new FileWriter(dirName+fileSeparator+interfaceDirName+fileSeparator+"deploy.wsdd");
            
            //Generating initial comments 
            fw.write("\n <!-- Deployment file -->");
            fw.write("\n <!-- This file was auto-generated from WSDL file --> ");
            fw.write("\n <!-- using Generator class developed by Mirco Musolesi at INRIA Rocquencourt -->");
            fw.write("\n");
            
            fw.write("<wsdd>\n");
            fw.write("  <deployment xmlns="+'"'+"http://xml.apache.org/axis/wsdd/"+'"'+" ");
            fw.write("xmlns:java="+'"'+"http://xml.apache.org/axis/wsdd/providers/java"+'"'+">\n");
            fw.write("\t<service name="+'"');
            fw.write(serviceName+'"'+" scope="+'"');
            fw.write(scope+'"'+" provider="+'"');
            fw.write("JAVA:RPC"+'"'+">");
	    
            //definition of <parameter>
            fw.write("\n\t  <parameter name=");
            fw.write('"');
            fw.write("className");
            fw.write('"');
            fw.write(" value=");
            fw.write('"');
            fw.write(implClass);
            fw.write('"');
            fw.write("/>");

  //definition of <operation> 
            for (int k=0;k<operationsNum;k++) {
                    fw.write("\n\t\t<operation name="+'"');
                    String initialLetterString=opData[k].getOperationName().substring(0,1);
                    String lowerCaseInitialLetterString=initialLetterString.toLowerCase();
                    String subString=opData[k].getOperationName().substring(1);
                    String lowerCaseOperationName=lowerCaseInitialLetterString+subString;
                    //opName=lowerCaseOperationName;
                    /*
                    *	 PLEASE NOTE
                    * 	 We operate this conversion to mantain compability to Axis specification
                    */
                    fw.write(lowerCaseOperationName);//parameter name
                    fw.write('"'+" qname="+'"');
                    fw.write(prefixOperationQName+":"+opData[k].getOperationName());//parameter qname
                    fw.write('"');
                    fw.write(" xmlns:"+prefixOperationQName+"="+'"'+opData[k].getOperationNameSpace()+'"');
                    ParData[] parRequest=opData[k].getParDataRequest();
                    ParData[] parResponse=opData[k].getParDataResponse();
                    if (parResponse==null) {
                            fw.write(">");
                            if (parRequest!=null)
                                    for (int s=0;s<parRequest.length;s++) {
                                            fw.write("\n\t\t\t<parameter");
                                            fw.write(" name=");
                                            fw.write('"');
                                            fw.write(parRequest[s].getName());
                                            fw.write('"');
                                            fw.write(" type=");
                                            fw.write('"');
                                            String parPrefix;
                                            if (this.getPrefix(parRequest[s].getNameSpace())!=null)
                                                    parPrefix=this.getPrefix(parRequest[s].getNameSpace());
                                            else
                                                    parPrefix="tNS";
                                            fw.write(parPrefix);	
                                            fw.write(":");
                                            fw.write(parRequest[s].getType());
                                            fw.write('"');
                                            fw.write(" xmlns:");
                                            fw.write(parPrefix);
                                            fw.write("=");
                                            fw.write('"');
                                            fw.write(parRequest[s].getNameSpace());
                                            fw.write('"');
                                            fw.write(" mode=");
                                            fw.write('"');
                                            fw.write("IN");
                                            fw.write('"');
                                            fw.write("/>");
                                    }

                    }
                    if (parResponse!=null)
                            if (parResponse.length==1) {
                                    fw.write(" returnQName=");
                                    fw.write('"');
                                    fw.write(parResponse[0].getName());
                                    fw.write('"');
                                    fw.write(" returnType=");
                                    fw.write('"');
 
                                    String parPrefix;
                                    if (this.getPrefix(parResponse[0].getNameSpace())!=null)
                                            parPrefix=this.getPrefix(parResponse[0].getNameSpace());
                                    else
                                            parPrefix="rtNS";
                                    fw.write(parPrefix);
                                    fw.write(":");
                                    fw.write(parResponse[0].getType());
                                    fw.write('"');
                                    fw.write(" xmlns:");
                                    fw.write(parPrefix);
                                    fw.write("=");
                                    fw.write('"');
                                    fw.write(parResponse[0].getNameSpace());
                                    fw.write('"');
                                    fw.write(">");
                                    for (int s=0;s<parRequest.length;s++) {
                                            fw.write("\n\t\t\t<parameter");
                                            fw.write(" name=");
                                            fw.write('"');
                                            fw.write(parRequest[s].getName());
                                            fw.write('"');
                                            fw.write(" type=");
                                            fw.write('"');
                                            parPrefix=null;
                                            if (this.getPrefix(parRequest[s].getNameSpace())!=null)
                                                    parPrefix=this.getPrefix(parRequest[s].getNameSpace());
                                            else
                                                    parPrefix="tNS";
                                            fw.write(parPrefix);
                                            fw.write(":");
                                            fw.write(parRequest[s].getType());
                                            fw.write('"');
                                            fw.write(" xmlns");
                                            fw.write(":");
                                            fw.write(parPrefix);
                                            fw.write("=");
                                            fw.write('"');
                                            fw.write(parRequest[s].getNameSpace());
                                            fw.write('"');
                                            fw.write(" mode=");
                                            fw.write('"');
                                            fw.write("IN");
                                            fw.write('"');
                                            fw.write("/>");
                                    }
                                    //for (int s=0;s<parResponse.length;s++) {
                                    //	fw.write("\n\t\t\t<parameter");
                                    //	fw.write(" name=");
                                    //	fw.write('"');
                                    //	fw.write(parResponse[s].getName());
                                    //	fw.write('"');
                                    //	fw.write(" mode=");
                                    //	fw.write('"');
                                    //	fw.write("OUT");
                                    //	fw.write('"');
                                    //	fw.write("/>");
                                    //}
                    }
                    if (parResponse!=null)
                            if (parResponse.length>1) {
                                    fw.write(">");
                                    if (parRequest!=null)
                                            for (int s=0;s<parRequest.length;s++) {
                                                    fw.write("\n\t\t\t<parameter");  
                                                    fw.write(" name=");
                                                    fw.write('"');
                                                    fw.write(parRequest[s].getName());
                                                    fw.write('"');
                                                    fw.write(" type=");
                                                    fw.write('"');
                                                    String parPrefix=null;
                                                    if (this.getPrefix(parRequest[s].getNameSpace())!=null)
                                                            parPrefix=this.getPrefix(parRequest[s].getNameSpace());
                                                    else
                                                            parPrefix="tNS";
                                                    fw.write(parPrefix);
                                                    fw.write(":");
                                                    fw.write(parRequest[s].getType());
                                                    fw.write('"');
                                                    fw.write(" xmlns:");
                                                    fw.write(parPrefix);
                                                    fw.write("=");
                                                    fw.write('"');
                                                    fw.write(parRequest[s].getNameSpace());
                                                    fw.write('"');
                                                    fw.write(" mode=");
                                                    fw.write('"');
                                                    fw.write("IN");
                                                    fw.write('"');
                                                    fw.write("/>");
                                            }

                                            for (int s=0;s<parResponse.length;s++) {
                                                    fw.write("\n\t\t\t<parameter");
                                                    fw.write(" name=");
                                                    fw.write('"');
                                                    fw.write(parResponse[s].getName());
                                                    fw.write('"');
                                                    fw.write(" type=");
                                                    fw.write('"');
                                                    String parPrefix=null;
                                                    if (this.getPrefix(parResponse[s].getNameSpace())!=null)
                                                            parPrefix=this.getPrefix(parResponse[s].getNameSpace());
                                                    else
                                                            parPrefix="rtNS";
                                                    fw.write(parPrefix);	
                                                    fw.write(":");
                                                    fw.write(parResponse[s].getType());
                                                    fw.write('"');
                                                    fw.write(" xmlns:");
                                                    fw.write(parPrefix);
                                                    fw.write("=");
                                                    fw.write('"');
                                                    fw.write(parResponse[s].getNameSpace());
                                                    fw.write('"');
                                                    fw.write(" mode=");
                                                    fw.write('"');
                                                    fw.write("OUT");
                                                    fw.write('"');
                                                    fw.write("/>");
                                            }

                            }	


                    ExceptionData[] exceptions=opData[k].getExceptions();
                     
                    for(int d=0; d<exceptions.length;d++) {
                        
                        String exceptionName=exceptions[d].getName();
                        ExceptionParData[] exceptionParam=exceptions[d].getExceptionParam();
                        
                          
                        fw.write("\n\t\t\t<!-- ");
                        
                        fw.write("<fault");
                        fw.write(" name=");
                        fw.write('"');
                        fw.write(exceptionName);
                        fw.write('"');
                        fw.write(" qname=");
                        fw.write('"');
                        fw.write(exceptionParam[0].getName());
                        fw.write('"');
                        fw.write(" class=");
                        fw.write('"');
                        String faultClassJavaType=packageName+"."+firstLetterToUpperCase(exceptionName);
                        fw.write(faultClassJavaType);
                        fw.write('"');
                        fw.write(" type=");
                        fw.write('"');
                        fw.write("tns:");
                        fw.write(exceptionParam[0].getType());
                        fw.write('"');
                        fw.write(" xmlns:tns=");
                        fw.write('"');
                        fw.write(exceptionParam[0].getNameSpace());
                        fw.write('"');
                        fw.write("/>");
                                                
                        fw.write(" -->");
                    }
                    
                    
                    fw.write("\n\t\t</operation>");

            }

 
            //definition of <typeMapping>
            if (typesData!=null) 
            for (int k=0;k<typesData.length;k++) 
                if (!typesData[k].isArray()) {
                    
                    //_______________
                    //Case not array
                    //______________
                    
                    fw.write("\n\t\t<typeMapping");
                    fw.write(" xmlns:ns=");
                    fw.write('"');
                    fw.write(def.getTargetNamespace());
                    fw.write('"');
                    fw.write(" \n\t\t\t     qname=");
                    fw.write('"');
                    fw.write("ns:");
                    fw.write(typesData[k].getTypeName().getLocalPart());
                    fw.write('"');
                    fw.write(" \n\t\t\t     type=");
                    fw.write('"');

                    String javaType=getJavaType(typesData[k].getTypeName());

                    fw.write(javaType);
                    fw.write('"');
                    fw.write(" \n\t\t\t     serializer=");
                    fw.write('"');
                    fw.write(serializerClassName);
                    fw.write('"');
                    fw.write(" \n\t\t\t     deserializer=");
                    fw.write('"');
                    fw.write(deserializerClassName);
                    fw.write('"');
                    fw.write(" \n\t\t\t     encodingStyle=");
                    fw.write('"');
                    fw.write(encodingStyle);
                    fw.write('"');
                    fw.write("/>");
                }// end if (!typesData[k].isArray())
                else {
                 
                    //_______________
                    //Case array
                    //______________
                    
                    fw.write("\n\t\t<typeMapping");
                    fw.write(" xmlns:ns=");
                    fw.write('"');
                    fw.write(def.getTargetNamespace());
                    fw.write('"');
                    fw.write(" \n\t\t\t     qname=");
                    fw.write('"');
                    fw.write("ns:");
                    fw.write(typesData[k].getTypeName().getLocalPart());
                    fw.write('"');
                    fw.write(" \n\t\t\t     type=");
                    fw.write('"');

                    QName arrayTypeQName=typesData[k].getArrayType();
                    String javaArrayTypeTemp=getJavaType(arrayTypeQName);
                    
                    String javaArrayType=javaArrayTypeTemp+"[]";
                    //String javaArrayType=javaArrayTypeTemp;
                    
                    fw.write(javaArrayType);
                    fw.write('"');
                    fw.write(" \n\t\t\t     serializer=");
                    fw.write('"');
                    fw.write(arraySerializerClassName);
                    fw.write('"');
                    fw.write(" \n\t\t\t     deserializer=");
                    fw.write('"');
                    fw.write(arrayDeserializerClassName);
                    fw.write('"');
                    fw.write(" \n\t\t\t     encodingStyle=");
                    fw.write('"');
                    fw.write(encodingStyle);
                    fw.write('"');
                    fw.write("/>");
                
                
                
                }//end else
                    


            //closing all...
            fw.write("\n\t</service>");
            fw.write("\n  </deployment>\n");
            fw.write("</wsdd>");
            fw.close();
		}
	}
	catch (Exception e) {
		e.printStackTrace();
	}

 


        //****************************************************
        //Fourth phase: generation of the Interface java files
        //****************************************************
       
       String interfaceFileName=portTypeName+".java"; 
       
       try {
                        
        //Creation of the directory for the generated Interface java file
	File intDir=new File(dirName+fileSeparator+interfaceDirName);
	intDir.mkdirs();
			
	
	//Creation of the Interface java file;
	FileWriter fw2=new FileWriter(dirName+fileSeparator+interfaceDirName+fileSeparator+interfaceFileName);
	       
        //Creating initial comments
        fw2.write("/**");
        fw2.write("\n *");
	fw2.write("\n * ");
	
	fw2.write(interfaceFileName);
	fw2.write("\n *");
	fw2.write("\n * This file was auto-generated from WSDL file ");
	fw2.write("\n * using Generator class developed by Mirco Musolesi at INRIA Rocquencourt");
	fw2.write("\n */");
	
	//OLD VERSION
	//String localPartDefName=null;
	//String defCName=def.getQName().getLocalPart();
	//String initialPartDefName=defCName.substring(0,4);
	//if (initialPartDefName.equals("urn:")) {
	//	localPartDefName=defCName.substring(4);
	//}
	//else {
	//	System.err.println("Error during interface java file generation.");
	//	System.err.println("\nFIX ME: name prefix is different from urn:");
	//	System.err.println("\nTo solve this problem look at **fourth phase** of ");
	//	System.err.println("the generation process adding the process instructiond for.");
	//	System.err.println("your prefix.");
	//	System.exit (3);
	//}



	if (debug) {
	    //System.out.println("Def qname local part: "+def.getQName().getLocalPart());
	    //	System.out.println("Def qname namespace: "+def.getQName().getNamespaceURI());
	    //	System.out.println("JavaTypeDef: "+javaTypeDef);
	    //	System.out.println("PackageName: "+packageName);
	}
	

	
	String localPartDefName=packageName; //to mantain the structure of the previous implementation
	
	//Creating package statement;
	fw2.write("\npackage ");
	fw2.write(localPartDefName);//package name
	fw2.write(";");
	fw2.write("\n\n");
        
        //Creating interface declaration
        fw2.write("\npublic interface ");
        fw2.write(portTypeName);
        fw2.write(" extends java.rmi.Remote {\n"); 
        if (debug)
        	System.out.println("opData: "+opData);
       
        //Creating interface methods
        for (int k=0;k<opData.length;k++) {
        	
        	ParData[] parResponse=opData[k].getParDataResponse();
        	ParData[] parRequest=opData[k].getParDataRequest();
        	ExceptionData[] exceptions=opData[k].getExceptions();
        	fw2.write("\tpublic ");
        	        	       	
        	//Creating return type
               	if (parResponse!=null)
               		if (parResponse.length==1) {
               		
               			//SPECIAL CASE treatment (array)
               			//array recognition mechanism for inner types
				boolean retTypeIsAnArray=false;
				QName retTypeArrayType=null;
				if (debug) {
				    //System.out.println("parResponse[0] type"+parResponse[0].getType());
				    //System.out.println("parResponse[0] namespace"+parResponse[0].getNameSpace());
				    //System.out.println("parResponse[0] javatype"+getJavaType(parResponse[0].getType(),parResponse[0].getNameSpace()));
				}
								
				for (int q=0;q<typesData.length;q++) {
					
					//System.out.println("typesData[q].getTypeName"+typesData[q].getTypeName());
					
					if (typesData[q].getTypeName().getLocalPart().equals(parResponse[0].getType()))
						if (typesData[q].isArray()) {
							//System.out.println("found");
							retTypeIsAnArray=true;
							retTypeArrayType=typesData[q].getArrayType();
						}
				}
               			
               			//Generating return type	
               			if (!retTypeIsAnArray) {
               				String type=this.getJavaType(parResponse[0].getType(),parResponse[0].getNameSpace());
               				fw2.write(type);
               				if (debug)
               					System.out.println(parResponse[0].getType()+" is not an array");
               			}
               			else {
               				String typeTemp=this.getJavaType(retTypeArrayType);
               				String type=typeTemp+"[]";
               				fw2.write(type);
               				if (debug)
               					System.out.println(parResponse[0].getType()+" is an array");
               			}
               			
               		}

              
                if (parResponse==null) {
               		fw2.write("void");
       		}
               	else if (parResponse.length>1) {
               		fw2.write("void");	
        	}
        	fw2.write(" ");
        	fw2.write(firstLetterToLowerCase(opData[k].getOperationName()));
        
        	//Creating inputTypes
        	fw2.write("(");
        	
		//case 0 param response
		if (parResponse==null) {
		
 		       
 		         if (parRequest!=null) {
 		          	
 		          	//array recognition mechanism
          			for (int s=0;s<parRequest.length;s++) {
          				boolean typeIsAnArray=false;
          				QName retTypeArrayType=null;
          				for (int q=0;q<typesData.length;q++) {
          					if (typesData[q].getTypeName().getLocalPart().equals(parRequest[s].getType()))
          						if (typesData[q].isArray()) {
          							typeIsAnArray=true;
          							retTypeArrayType=typesData[q].getArrayType();
          							
          					}
          				}
          				if (!typeIsAnArray) {
          					String type=this.getJavaType(parRequest[s].getType(),parRequest[s].getNameSpace());
        					fw2.write(type);
        					
      			  		}
        				else {
        					String typeTemp=this.getJavaType(retTypeArrayType);
        					String type=typeTemp+"[]";
        					fw2.write(type);
        						
        				}		
        				fw2.write(" ");
        				fw2.write(parRequest[s].getName());
        				if (s!=(parRequest.length-1))
        						fw2.write(", ");  
        			}//end for (int s=0;s<parRequest.length;s++)
          			//end array recognition mechanism
          		}
        	}
        	
        	//case 1 param response 
        	if (parResponse!=null) {
        		if (parResponse.length==1) 
        		
        			
        			//for (int s=0;s<parRequest.length;s++) {
        			//	String type=this.getJavaType(parRequest[s].getType(),parRequest[s].getNameSpace());
        			//	fw2.write(type+" ");
        			//	fw2.write(parRequest[s].getName());
        			//	if (s!=(parRequest.length-1))
        			//	fw2.write(", ");
        			//}
	   				
	   			//array recognition mechanism
          			for (int s=0;s<parRequest.length;s++) {
          				boolean typeIsAnArray=false;
          				QName retTypeArrayType=null;
          				for (int q=0;q<typesData.length;q++) {
          					if (typesData[q].getTypeName().getLocalPart().equals(parRequest[s].getType()))
          						if (typesData[q].isArray()) {
          							typeIsAnArray=true;
          							retTypeArrayType=typesData[q].getArrayType();
          							//System.out.println("@@@@@@@TROVATO");
          					}
          				}
          				if (!typeIsAnArray) {
          					String type=this.getJavaType(parRequest[s].getType(),parRequest[s].getNameSpace());
        					fw2.write(type);
        					
      			  		}
        				else {
        					String typeTemp=this.getJavaType(retTypeArrayType);
        					String type=typeTemp+"[]";
        					fw2.write(type);
        					
        				}		
        				fw2.write(" ");
        				fw2.write(parRequest[s].getName());
        				if (s!=(parRequest.length-1))
        						fw2.write(", ");  
        			}//end for (int s=0;s<parRequest.length;s++)
          			//end array recognition mechanism
	   		
	   	
	   	}
 		 
		//case >1 param response	
       		if (parResponse!=null)
       			if (parResponse.length>1) {

	   			//array recognition mechanism
          			for (int s=0;s<parRequest.length;s++) {
          				boolean typeIsAnArray=false;
          				QName retTypeArrayType=null;
          				for (int q=0;q<typesData.length;q++) {
          					if (typesData[q].getTypeName().getLocalPart().equals(parRequest[s].getType()))
          						if (typesData[q].isArray()) {
          							typeIsAnArray=true;
          							retTypeArrayType=typesData[q].getArrayType();
          							
          					}
          				}
          				if (!typeIsAnArray) {
          					String type=this.getJavaType(parRequest[s].getType(),parRequest[s].getNameSpace());
        					fw2.write(type);
        					
      			  		}
        				else {
        					String typeTemp=this.getJavaType(retTypeArrayType);
        					String type=typeTemp+"[]";
        					fw2.write(type);

        						
        				}		
        				fw2.write(" ");
        				fw2.write(parRequest[s].getName());
        				if (s!=(parRequest.length-1))
        						fw2.write(", ");  
        			}//end for (int s=0;s<parRequest.length;s++)
	       			//end array recognition mechanism
      		 	
       		 	        if ((parResponse.length>0)&&(parRequest.length>0))
       		 	        	fw2.write(", ");
        				
        	    	
          		 	for (int s=0;s<parResponse.length;s++) {
             						
             			             				
             				//holderType is the name of the class that implements the holder
             				String holderType=this.getJavaTypeHolder(parResponse[s].getType(),parResponse[s].getNameSpace());
        				
        				//holderTypeValue is the name of the type contained in the holder
        				String holderValueType=this.getJavaType(parResponse[s].getType(),parResponse[s].getNameSpace());
        				
        				//array type recognition mechanism
        				boolean typeIsAnArray=false;
        				QName arrayHoldType=null;
        				String arrayHoldTypeStr=null;
        				
        				for (int q=0;q<typesData.length;q++) {
        					if (typesData[q].getTypeName().getLocalPart().equals(parResponse[s].getType())) 
        						if (typesData[q].isArray()) {
        							typeIsAnArray=true;
        							arrayHoldType=typesData[q].getArrayType();
        							arrayHoldTypeStr=getJavaType(arrayHoldType);
        							//System.out.println(typesData[q].getTypeName().getLocalPart()+" is an array");
        						} else {
        							typeIsAnArray=false;
        							//System.out.println(typesData[q].getTypeName().getLocalPart()+" is not an array");
        						}
        					}
        				        				
        				//PLEASE NOTE
        		        	//if the holder is not a standand java holder, in other words if
        				//it is not present in the javax.xml.rpc.holders package, a class 
        				//for this holder must be generated.
        				//
        				//Here in a sense we *request* the generation of these holders for user-defined types
        				//
        				if (debug)
        					System.out.println(holderType+" is a standard Holder?"+isAStandardHolder(holderType));
        				if (!isAStandardHolder(holderType)) {
        					HolderData holderDataItem=new HolderData();
        					holderDataItem.setHolderName(holderType);
        					holderDataItem.setHolderType(holderValueType);
        					holderDataItem.setIsArray(typeIsAnArray);
        					holderDataItem.setArrayType(arrayHoldTypeStr);
        					holderDataVector.add(holderDataItem); 

        				}//end if (!isAStandardHolder(holderType))
        				
        				fw2.write(holderType+" ");
        				fw2.write(parResponse[s].getName());
        				if (s!=(parResponse.length-1))
        					fw2.write(", ");
        						
        				
        			}
        				
               	}
        	
        	fw2.write(")");
        	
        	//managing exception...
        	
        	//"standard exception" java.rmi.RemoteException
        	fw2.write(" throws ");
        	fw2.write("java.rmi.RemoteException");
        		
		//user-defined exception
		if (exceptions!=null) {
			for (int i=0;i<exceptions.length;i++) {
			String exceptionName=exceptions[i].getName();
			
			fw2.write(",");
			fw2.write(packageName);
			fw2.write(".");
			fw2.write(firstLetterToUpperCase(exceptionName));
			
			}
		}//end if (exceptions!=null)
			
		//retrieving user defined exception
		//localPartDefName is the name of our package
		//String userDefException=localPartDefName+"."+
        	
        	fw2.write(";");	
        
        	fw2.write("\n");
        }//end for (int k=0;k<opData.length;k++)
        	
        //Closing interface declaration
        fw2.write("\n}");
        
 

	fw2.close();        
	

	
		
			        
        }
        catch (Exception e) {
        	e.printStackTrace();
        }
        
                       
        
        //*******************************************************
        //Fifth phase: generation of the complex types java files
        //*******************************************************
        
        //Retrieving number of complex data types
        int complexDataTypeNum=0;
        for (int k=0;k<typesData.length;k++)
        	if (typesData[k].isComplex())
        		complexDataTypeNum++;
        StringBuffer[] resultType=new StringBuffer[complexDataTypeNum];
        String[] resultTypePackageName=new String[complexDataTypeNum];
        StringBuffer resultTypeTemp=null;  
        //System.out.println ("Debugdsf: complexDataTypeNum"+complexDataTypeNum);
        int sb=0;
        String tns=null;
        
        for (int k=0;k<typesData.length;k++)
                   	 	
         	 // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        	 // CASE ONE
     		 // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    		 // Treatment of complex types that are array 
   		 // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        	 //
                 // Please note: it is a different case from complex types that *contain* an array
                 //
                 // An example can be the following:
       	         // 
                 //     <xsd:complexType name="ArrayOfString">
           	 //		<xsd:complexContent>
                 //			<xsd:restriction base="soapenc:Array">
               	 //				<xsd:sequence>	
            	 //					<xsd:element name="strings" minOccurs="0" maxOccurs="unbounded" type="RemoteService"/>
     	         //				</xsd:sequence>
   	         //			</xsd:restriction>
   	         //		</xsd:complexContent>
     	         //	</xsd:complexType>
                
                
                //We use resultTypeTemp StringBuffer variable to generate methods.
                //We append its content after the processing of inner variables.
                
                
                 

                 
               	 if (typesData[k].isComplex()) {
		        resultTypeTemp=new StringBuffer();
               		//generating constructor
        		resultTypeTemp.append("\n\n\tpublic ");
			resultTypeTemp.append(typesData[k].getTypeName().getLocalPart());
			resultTypeTemp.append("() {");
			resultTypeTemp.append("\n\t}");
               	 
               	 
               	 	if (typesData[k].isArray()) {
        	 		try {
					if (debug) {
						System.out.print(typesData[k].getTypeName().getLocalPart());
						System.out.println(" is an array type.");
						System.out.println("Array type: "+typesData[k].getArrayType());
						System.out.println("Array dimension "+typesData[k].getArrayDimension());
						System.out.println("Children: "+typesData[k].getChildren());					
					}
					
					//Please note: we have to introduce this parsing of the imported document, because
					//WSIF classes do not support the retrieving of the name attribute of the element node.
					//In the example above, the value of this attribute is "string".
					
					//Alternative solution: use of javax.xml.parsers.* classes	
					//DocumentBuilderFactory DOMfactory=DocumentBuilderFactory.newInstance();
					//DOMfactory.setNamespaceAware(true);
					//System.out.println("Is namespace aware? "+DOMfactory.isNamespaceAware());
					//DocumentBuilder DOMbuilder=DOMfactory.newDocumentBuilder();
					//System.out.println("DOM builder class"+DOMbuilder.getClass().getName());
					//Document document=DOMbuilder.parse(new File(fileName));
					
					//We use Xerces 2 DOM parser
					DOMParser DOMparser=new DOMParser();
					File f=new File(fileName);
					FileReader fileReader=new FileReader(f);
					InputSource is=new InputSource(fileReader);
					DOMparser.parse(is);
					Document document=DOMparser.getDocument();
					
					Node nodeComplex=null;		
					Node root=document.getDocumentElement();
					Element rootElement=(Element)root;
					
					Element defElement=null;
					String importedFile=null;
					NodeList importList;
					if (!clientSide) {
						importList=document.getElementsByTagName("import");
						Element importElement=(Element)importList.item(0);
						NamedNodeMap mapAttr=importElement.getAttributes();
						
					 	importedFile=mapAttr.getNamedItem("location").getNodeValue();
						if (debug)
							System.out.println("Imported file: "+importedFile);
					}
					else {
						importedFile=fileName;
					}
					
					//resolving directory of the imported file
					File tempFile=new File(fileName);
					String absolutePath=tempFile.getAbsolutePath();
					int ind=absolutePath.lastIndexOf(fileSeparator);
					String impFileDir;
					if (ind!=-1)
						impFileDir=absolutePath.substring(0,ind+1);
					else
						impFileDir=new String("");
					if (debug)
						System.out.println("Absolute path: "+tempFile.getAbsolutePath());
					
					String importedFileName;
					if (clientSide)
						importedFileName=importedFile;
					else
						importedFileName=impFileDir+importedFile;
					
					
					
					if (debug)
						System.out.println("Imported fileName: "+importedFileName);
					File f2=new File(importedFileName);
					if (debug)
						System.out.println("impFileDir: "+impFileDir);
					FileReader fileReader2=new FileReader(f2);
					InputSource is2=new InputSource(fileReader2);
					DOMparser.parse(is2);
					document=DOMparser.getDocument();
					rootElement=document.getDocumentElement();
					
					NodeList typesList=null;
									
					
	         			typesList=rootElement.getElementsByTagName("types");
					Element typesElement=(Element)typesList.item(0);
					if (debug)
						System.out.println("TypesElement "+typesElement);
					NodeList schemaList;
										
					//PLEASE NOTE:
					//We support in this current implementation the following namespace
					//schema namespace 1999 
					//schema namespace 2000
					//schema namespace 2001 
					//
					//if you want to add another namespace, you have to add the following lines (we
					//consider in this case typeList variable, but you to modify it for all the NodeList
					//variables that you find in this code)
					//
					//if (typesList==null)
					//	typesList=rootElement.getElementsByTagNameNS(yournamespace,"types");
					//at the end of the following code when you find this statement
					//"insert HERE your code to add another namespace"
					
					//case schema namespace 1999 definition
					schemaList=typesElement.getElementsByTagNameNS(schemaNameSpace1999,"schema");
					
					//System.out.println("schemaList1999"+schemaList.getLength());
					//if return is null, try schema namespace 2000 definition
					if ((schemaList==null)||(schemaList.getLength()==0)) {
						schemaList=typesElement.getElementsByTagNameNS(schemaNameSpace2000,"schema");
					 	if (debug)
					 		System.out.println("Schema version 2000");
					}			
					//if return is null, try schema namespace 2001 definition
					if ((schemaList==null)||(schemaList.getLength()==0)) {
						schemaList=typesElement.getElementsByTagNameNS(schemaNameSpace2001,"schema");
						if (debug)
							System.out.println("Schema version 2001");
					}
					//insert HERE your code to add another namespace
					
					if (debug) {
						System.out.println("schemalist "+schemaList);
						System.out.println("schemalist length "+schemaList.getLength());
					}
					Element schemaElement=(Element)schemaList.item(0);
					
					if (debug)
						System.out.println("schemaElement "+schemaElement);
					
					//case schema namespace 1999 definition
					NodeList complexTypesNodeList=schemaElement.getElementsByTagNameNS(schemaNameSpace1999,"complexType");
					
					//if return is null, try schema namespace 2000 definition
					if ((complexTypesNodeList==null)||(complexTypesNodeList.getLength()==0)) {
						complexTypesNodeList=schemaElement.getElementsByTagNameNS(schemaNameSpace2000,"complexType");
						if (debug)
							System.out.println("Complex Type debug-->I am trying Schema version 2000");
					}
					//if return is null, try schema namespace 2001 definition
					if ((complexTypesNodeList==null)||(complexTypesNodeList.getLength()==0)) {
						complexTypesNodeList=schemaElement.getElementsByTagNameNS(schemaNameSpace2001,"complexType");
						if (debug)
							System.out.println("Complex Type debug-->I am trying Schema version 2001");
					}
					if (debug) {
						System.out.println("Root "+complexTypesNodeList);
						System.out.println("Length "+complexTypesNodeList.getLength());
						System.out.println("typesData[k].getTypeName().getLocalPart())"+typesData[k].getTypeName().getLocalPart());
					}
					for (int w=0;w<complexTypesNodeList.getLength();w++) {
						Element complexTypeElement=(Element)complexTypesNodeList.item(w);
						NamedNodeMap atts=complexTypeElement.getAttributes();
						Node nameNode=atts.getNamedItem("name");
						if (debug) {
							System.out.println("nameNode node value: "+nameNode.getNodeValue());
						}
						if (nameNode.getNodeValue().equals(typesData[k].getTypeName().getLocalPart())) {
							nodeComplex=complexTypeElement;
						}					
					}
					
					NodeList childrenComplex=nodeComplex.getChildNodes();
					Node childComplex=childrenComplex.item(1);
					if (debug)
						System.out.println("childComplex: "+childComplex);
						
					Element elementComContent=(Element)childComplex;
					NodeList childrenComContent=elementComContent.getChildNodes();
					Node childRes=childrenComContent.item(1);
						
					Element elementRes=(Element)childRes;
					NodeList childrenRes=elementRes.getChildNodes();
					Node childSeq=childrenRes.item(1);
						
					Element elementSeq=(Element)childSeq;
					NodeList childrenSeq=elementSeq.getChildNodes();
					Node childElem=childrenSeq.item(1);
						
					Element elementElem=(Element)childElem;
					
					NamedNodeMap atts=childElem.getAttributes();
					Node nameNode=atts.getNamedItem("name");
					String name=nameNode.getNodeValue();
					if (debug)
						System.out.println("Type name:"+name);
				
					//Now we have the value of the name attribute of the element node....
					//So we can generate our code...	
					
		                 	resultType[sb]=new StringBuffer(); 
               		
					//Creating initial comments
        				resultType[sb].append("/**");
        				resultType[sb].append("\n *");
        				resultType[sb].append("\n * ");
					String complexTypeFileName=firstLetterToUpperCase(typesData[k].getTypeName().getLocalPart())+".java";
					resultType[sb].append(complexTypeFileName);
					resultType[sb].append("\n *");
					resultType[sb].append("\n * This file was auto-generated from WSDL file ");
					resultType[sb].append("\n * using Generator class developed by Mirco Musolesi at INRIA Rocquencourt");
					resultType[sb].append("\n */");
					resultType[sb].append("\npackage ");
					
					String tempPackName=getJavaType(typesData[k].getTypeName());
					String arrayTypePackageName=getPackageName(tempPackName);
					resultType[sb].append(arrayTypePackageName);//package name
					resultTypePackageName[sb]=arrayTypePackageName;
					
					resultType[sb].append(";");
					resultType[sb].append("\n");
				
					//generating class...
					resultType[sb].append("public class ");
					resultType[sb].append(firstLetterToUpperCase(typesData[k].getTypeName().getLocalPart())); //class name
					resultType[sb].append(" {");
					
					//generating class variable
					resultType[sb].append("\n\tpublic ");
					
					//System.out.println("typesData[k]"+typesData[k]);
					//System.out.println("typesData[k].getArrayType()"+typesData[k].getArrayType());				
					
					resultType[sb].append(getJavaType(typesData[k].getArrayType()));
					
					resultType[sb].append("[] ");
					resultType[sb].append(name);//variable name
					resultType[sb].append(";");
					
					//generating get method
					resultTypeTemp.append("\n\n\tpublic ");
					resultTypeTemp.append(getJavaType(typesData[k].getArrayType())); //arrayType
					resultTypeTemp.append("[]");
					resultTypeTemp.append(" get");
					resultTypeTemp.append(firstLetterToUpperCase(name));
					resultTypeTemp.append("() {");
					resultTypeTemp.append("\n\t\treturn ");
					resultTypeTemp.append(name);
					resultTypeTemp.append(";");
					resultTypeTemp.append("\n\t}");
					
					//generating set method
					resultTypeTemp.append("\n\n\tpublic void");
					resultTypeTemp.append(" set");
					resultTypeTemp.append(firstLetterToUpperCase(name));
					resultTypeTemp.append("(");
					resultTypeTemp.append(getJavaType(typesData[k].getArrayType()));
					resultTypeTemp.append("[] ");
					resultTypeTemp.append(name);
					resultTypeTemp.append(") {");
					resultTypeTemp.append("\n\t\tthis.");
					resultTypeTemp.append(name);
					resultTypeTemp.append("=");
					resultTypeTemp.append(name);
					resultTypeTemp.append(";");
					resultTypeTemp.append("\n\t}");
					
					
					//append the string containing methods
					
					resultType[sb].append(resultTypeTemp.toString());			
					//closing the class declaration
					resultType[sb].append("\n}");
					sb++;
				
				}
				catch (Exception e){
					e.printStackTrace();
				}
								
				
			}		
			else {
				if (debug) {
				        System.out.print(typesData[k].getTypeName().getLocalPart());
				        System.out.println(" is not an array.\n");
        				System.out.println("Namespace: "+typesData[k].getTypeName().getNamespaceURI());	             	
	             		}
	             		//debugging wsif constants
	            	 	//if (debug) {
	             		//
	             		//	System.out.println("WSIF constants");
	           	  	//	System.out.println("Soap-enc ns constant"+WSIFConstants.NS_URI_SOAP_ENC);
	             		//	System.out.println("WSDL ns constant"+WSIFConstants.NS_URI_WSDL);
	             		//}
	             		
	             	
                   		// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
       	 			// CASE TWO
     				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
   	 			// Treatment of the general case (excepting the declaration of an array using a complex type)
   				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        			//
             	        	//
                	        // You can find the treatment of the declaration of an array using a complex type above
	         	    	//
	         	    	// This a possible valid declaration:
	             		//
	     	        	//     <xsd:complexType name="RemoteService">
       				//	<xsd:sequence>
        			//		<xsd:element name="address" type="xsd:string"/>
      				//	        <xsd:element name="attr" type="xsd:string"/>
	     			//	        <xsd:element name="LCwau" type="xsd:string"/>
        			//		<xsd:element name="RCwau" type="xsd:string"/>
       				//	</xsd:sequence>
				//   </xsd:complexType>
                	 	//
               			//
          	       		// You can declare a complex Type that contains an array in this manner:
    		             	//     <xsd:complexType name="RemoteServices">
     				//	<xsd:sequence>
     	 			//		<xsd:element name="list" type="ArrayOfString"/>
      				//	</xsd:sequence>
 				//  </xsd:complexType>
                 	
                 	
                 		resultType[sb]=new StringBuffer(); 
     			        //Creating initial comments
     		   		resultType[sb].append("/**");
        			resultType[sb].append("\n *");
        			resultType[sb].append("\n * ");
				String complexTypeFileName=typesData[k].getTypeName().getLocalPart()+".java";
				resultType[sb].append(complexTypeFileName);
				resultType[sb].append("\n *");
				resultType[sb].append("\n * This file was auto-generated from WSDL file ");
				resultType[sb].append("\n * using Generator class developed by Mirco Musolesi at INRIA Rocquencourt");
				resultType[sb].append("\n */");
				resultType[sb].append("\npackage ");
				String tempPackName=getJavaType(typesData[k].getTypeName());
				String packName=getPackageName(tempPackName);
				resultType[sb].append(packName);//package name
				resultTypePackageName[sb]=packName;
				resultType[sb].append(";");
				resultType[sb].append("\n");
			
				//generating class...
				resultType[sb].append("public class ");
				resultType[sb].append(typesData[k].getTypeName().getLocalPart()); //class name
				resultType[sb].append(" {");
			
				//generating class variables...		
				ComplexType complexType=(ComplexType) typesData[k];
				if (debug) {
					System.out.println ("DEBUG complexType: "+complexType);
				}
			
				SequenceElement[] innerTypes=complexType.getSequenceElements();
				
				if (debug) {
					System.out.println ("DEBUG innerTypes: "+innerTypes);
					System.out.println ("DEBUG innerTypes: "+innerTypes.length);
				}
	
				
  		  		for (int p=0;p<innerTypes.length;p++) {
					SequenceElement innerTypesEl=innerTypes[p];
							
					if (innerTypesEl.isElement()) {
								
						ElementType innerTypesElElementType=(ElementType)innerTypesEl;
						
						//if (debug||restrDebug) {
						//if (innerTypesEl.isArray()) 
						//	System.out.println(innerTypesElElementType.getTypeName().getLocalPart()+" is an array.\n");
						//else
						//	System.out.println(innerTypesElElementType.getTypeName().getLocalPart()+" is not an array.\n");
						//
						//if (innerTypesEl.isComplex()) 
						//	System.out.println(innerTypesElElementType.getTypeName().getLocalPart()+" is complex.\n");
						//else
						//	System.out.println(innerTypesElElementType.getTypeName().getLocalPart()+" is not complex.\n");
						//}//end ifdebug
															 
						QName innerTypesElQName=innerTypesElElementType.getTypeName();
						QName innerTypesElDataType=innerTypesElElementType.getElementType();
						String innerTypesElQNameLocalPart=innerTypesElQName.getLocalPart();
						String innerTypesElQNameNameSpace=innerTypesElQName.getNamespaceURI();
						String innerTypesElDataTypeLocalPart=innerTypesElDataType.getLocalPart();
						String innerTypesElDataTypeNameSpace=innerTypesElDataType.getNamespaceURI();
						String javaType=this.getJavaType(innerTypesElDataTypeLocalPart,innerTypesElDataTypeNameSpace);
											
						//array recognition mechanism for inner types
						boolean isAnArray=false;
						QName complexTypeArrayType=null;
						for (int q=0;q<typesData.length;q++) {
							//System.out.println ("ARRAY*****typesDataName"+typesData[q].getTypeName().getLocalPart());
							//System.out.println ("ARRAY*****thisElementName"+innerTypesElDataType.getLocalPart());
							if (typesData[q].getTypeName().equals(innerTypesElDataType))
								 if (typesData[q].isArray()) {
								 	//System.out.println ("ARRAY*****"+innerTypesElDataType.getLocalPart()+" is an array.");
							 		isAnArray=true;
									complexTypeArrayType=typesData[q].getArrayType();
								}
							 else {
							 	//System.out.println ("ARRAY*****"+innerTypesElQName.getLocalPart()+" is not an array.");
							}
						}
				 		//case innerType is an array
				 		if (isAnArray) {
				 			resultType[sb].append("\n\tpublic ");
				 			resultType[sb].append(getJavaType(complexTypeArrayType));
				 			resultType[sb].append("[]");
				 			resultType[sb].append(" ");
							resultType[sb].append(innerTypesElQNameLocalPart);
							resultType[sb].append(";");
							
							//Generating get e set methods....
				 				
				 			//PLEASE NOTE
				 			//We use a resultTypeTemp to generate set and get method
				 			//We will append it at the end of the main for cycle.
				 			//The constructor was generated before
				 			
				 			//Generating get method
				 			resultTypeTemp.append("\n\n\tpublic ");
				 			resultTypeTemp.append(getJavaType(complexTypeArrayType));
				 			resultTypeTemp.append("[]");
				 			resultTypeTemp.append(" get");
				 			resultTypeTemp.append(firstLetterToUpperCase(innerTypesElQNameLocalPart));
				 			resultTypeTemp.append("() {");
				 			resultTypeTemp.append("\n\t\treturn ");
				 			resultTypeTemp.append(innerTypesElQNameLocalPart);
				 			resultTypeTemp.append(";");
				 			resultTypeTemp.append("\n\t}");
				 			
				 			//Generating set method
				 			resultTypeTemp.append("\n\n\tpublic void set");
				 			resultTypeTemp.append(firstLetterToUpperCase(innerTypesElQNameLocalPart));
				 			resultTypeTemp.append("(");
				 			resultTypeTemp.append(getJavaType(complexTypeArrayType));
				 			resultTypeTemp.append("[] ");
				 			resultTypeTemp.append(innerTypesElQNameLocalPart);
				 			resultTypeTemp.append(") {");
				 			resultTypeTemp.append("\n\t\tthis.");
				 			resultTypeTemp.append(innerTypesElQNameLocalPart);
				 			resultTypeTemp.append("=");
				 			resultTypeTemp.append(innerTypesElQNameLocalPart);
				 			resultTypeTemp.append(";");
				 			resultTypeTemp.append("\n\t}");
				 			
				 			//Generating get array item method
				 			resultTypeTemp.append("\n\n\tpublic ");
				 			resultTypeTemp.append(getJavaType(complexTypeArrayType));
				 			resultTypeTemp.append(" get");
				 			resultTypeTemp.append(firstLetterToUpperCase(innerTypesElQNameLocalPart));
				 			resultTypeTemp.append("(int i) {");
				 			resultTypeTemp.append("\n\t\treturn ");
				 			resultTypeTemp.append(innerTypesElQNameLocalPart);
				 			resultTypeTemp.append("[i];");
				 			resultTypeTemp.append("\n\t}");
				 			
				 			//Generating set array item method
				 			resultTypeTemp.append("\n\n\tpublic void set");
				 			resultTypeTemp.append(firstLetterToUpperCase(innerTypesElQNameLocalPart));
				 			resultTypeTemp.append("(int i, ");
				 			resultTypeTemp.append(getJavaType(complexTypeArrayType));
				 			resultTypeTemp.append(" value) {");
				 			resultTypeTemp.append("\n\t\tthis.");
				 			resultTypeTemp.append(innerTypesElQNameLocalPart);
				 			resultTypeTemp.append("[i]=value;");
				 			resultTypeTemp.append("\n\t}");
				 			
				 		
				 		
				 		}
				 		//case innerType is not array
				 		else {
				 			resultType[sb].append("\n\tpublic ");
				 			resultType[sb].append(getJavaType(innerTypesElDataType));
							resultType[sb].append(" ");
							resultType[sb].append(innerTypesElQNameLocalPart);
							resultType[sb].append(";");
									 			
				 			//Generating get e set methods....
				 				
				 			//PLEASE NOTE
				 			//We use a resultTypeTemp to generate set and get method
				 			//We will append it at the end of the main for cycle.
				 			//The constructor was generated before
				 			
				 			//Generating get method
				 			resultTypeTemp.append("\n\n\tpublic ");
				 			resultTypeTemp.append(getJavaType(innerTypesElDataType));
							
							if (getJavaType(innerTypesElDataType).equals("boolean")) resultTypeTemp.append(" is");
							else resultTypeTemp.append(" get");
				 			resultTypeTemp.append(firstLetterToUpperCase(innerTypesElQNameLocalPart));
				 			resultTypeTemp.append("() {");
				 			resultTypeTemp.append("\n\t\treturn ");
				 			resultTypeTemp.append(innerTypesElQNameLocalPart);
				 			resultTypeTemp.append(";");
				 			resultTypeTemp.append("\n\t}");
				 			
				 			//Generating set method
				 			resultTypeTemp.append("\n\n\tpublic void set");
				 			resultTypeTemp.append(firstLetterToUpperCase(innerTypesElQNameLocalPart));
				 			resultTypeTemp.append("(");
				 			resultTypeTemp.append(getJavaType(innerTypesElDataType));
				 			resultTypeTemp.append(" ");
				 			resultTypeTemp.append(innerTypesElQNameLocalPart);
				 			resultTypeTemp.append(") {");
				 			resultTypeTemp.append("\n\t\tthis.");
				 			resultTypeTemp.append(innerTypesElQNameLocalPart);
				 			resultTypeTemp.append("=");
				 			resultTypeTemp.append(innerTypesElQNameLocalPart);
				 			resultTypeTemp.append(";");
				 			resultTypeTemp.append("\n\t}");
				 			
				 		}
		
					} //end if (innerTypesEl.isElement())
				}// end for (int p=0;p<innerTypes.length;p++)
				
				
				//WORKING AREA
				
				//Generating type metadata section
				
				//Generating a comment...
				resultTypeTemp.append("\n\n");
				resultTypeTemp.append("\t// Type metadata");
				resultTypeTemp.append("\n");
				
				//Generating a declaration
				resultTypeTemp.append("\tprivate static ");
				String typeDescPackageName="csoap.wsdl";//TEMPORARY PACKAGE
				resultTypeTemp.append(typeDescPackageName);
				resultTypeTemp.append(".TypeDesc typeDesc=new ");
				resultTypeTemp.append(typeDescPackageName);
				resultTypeTemp.append(".TypeDesc(");
				resultTypeTemp.append(firstLetterToUpperCase(typesData[k].getTypeName().getLocalPart()));//class name
				resultTypeTemp.append(".class);");
				
				resultTypeTemp.append("\n");
				
				//Generating static section
				resultTypeTemp.append("\n\tstatic {");
				resultTypeTemp.append("\n\t\ttypeDesc.setXmlType(new javax.xml.namespace.QName(");
				resultTypeTemp.append('"');
				resultTypeTemp.append(typesData[k].getTypeName().getNamespaceURI());//namespace
				resultTypeTemp.append('"');
				resultTypeTemp.append(",");
				resultTypeTemp.append('"');
				resultTypeTemp.append(typesData[k].getTypeName().getLocalPart());//name
				resultTypeTemp.append('"');
				resultTypeTemp.append("));");
				resultTypeTemp.append("\n\t\t");
				resultTypeTemp.append(typeDescPackageName);
				resultTypeTemp.append(".ElementDesc elementField;");			
				
				
				//for each inner types we have to generate some types metadata
				for (int p=0;p<innerTypes.length;p++) {
					SequenceElement innerTypesEl=innerTypes[p];
							
					if (innerTypesEl.isElement()) {
								
						ElementType innerTypesElElementType=(ElementType)innerTypesEl;
						
						//extracting information
						QName innerTypesElQName=innerTypesElElementType.getTypeName();
						QName innerTypesElDataType=innerTypesElElementType.getElementType();
						String innerTypesElQNameLocalPart=innerTypesElQName.getLocalPart();
						String innerTypesElQNameNameSpace=innerTypesElQName.getNamespaceURI();
						String innerTypesElDataTypeLocalPart=innerTypesElDataType.getLocalPart();
						String innerTypesElDataTypeNameSpace=innerTypesElDataType.getNamespaceURI();
						String javaType=this.getJavaType(innerTypesElDataTypeLocalPart,innerTypesElDataTypeNameSpace);
						
						resultTypeTemp.append("\n");
						resultTypeTemp.append("\n\t\t");
						resultTypeTemp.append("elementField=new ");			
						resultTypeTemp.append(typeDescPackageName);
						resultTypeTemp.append(".ElementDesc();");
						
						//set fieldName
						resultTypeTemp.append("\n\t\telementField.setFieldName(");
						resultTypeTemp.append('"');
						resultTypeTemp.append(innerTypesElQNameLocalPart);
						resultTypeTemp.append('"');
						resultTypeTemp.append(");");
				
						//set XmlName
						resultTypeTemp.append("\n\t\telementField.setXmlName(new javax.xml.namespace.QName(");
						resultTypeTemp.append('"');
						resultTypeTemp.append('"');
						resultTypeTemp.append(",");
						resultTypeTemp.append('"');
						resultTypeTemp.append(innerTypesElQNameLocalPart);
						resultTypeTemp.append('"');
						resultTypeTemp.append("));");
						
						//set XmlType
						resultTypeTemp.append("\n\t\telementField.setXmlType(new javax.xml.namespace.QName(");
						resultTypeTemp.append('"');
						resultTypeTemp.append(innerTypesElDataTypeNameSpace); //Xml type namespace
						resultTypeTemp.append('"');
						resultTypeTemp.append(",");
						resultTypeTemp.append('"');
						resultTypeTemp.append(innerTypesElDataTypeLocalPart); //Xml type name
						resultTypeTemp.append('"');
						resultTypeTemp.append("));");
								
						//addFieldName
						resultTypeTemp.append("\n\t\ttypeDesc.addFieldDesc(elementField);");
																	
					}//end if (innerTypesEl.isElement())
										
					
										

				} //end for (int p=0;p<innerTypes.length;p++) 
									
				//closing static
				resultTypeTemp.append("\n\t}");						
				
				resultTypeTemp.append("\n");
				
				//generating getTypeDesc method
				resultTypeTemp.append("\n\t/**");
				resultTypeTemp.append("\n\t * Return type metadata object");
				resultTypeTemp.append("\n\t*/");
				resultTypeTemp.append("\n\tpublic static ");
				resultTypeTemp.append(typeDescPackageName);
				resultTypeTemp.append(".TypeDesc ");
				resultTypeTemp.append("getTypeDesc");
				resultTypeTemp.append("() {");
				resultTypeTemp.append("\n\t\treturn typeDesc;");
				resultTypeTemp.append("\n\t}");
				
				resultTypeTemp.append("\n");
				
				//generating equals method if type isn't simple type like int, long, double....
				if (true)
				    {
				resultTypeTemp.append("\n\tpublic synchronized boolean equals(java.lang.Object obj) {");
				resultTypeTemp.append("\n\t\tif (!(obj instanceof ");
				resultTypeTemp.append(firstLetterToUpperCase(typesData[k].getTypeName().getLocalPart()));
				resultTypeTemp.append(")) return false;");
				resultTypeTemp.append("\n\t\t");
				resultTypeTemp.append(firstLetterToUpperCase(typesData[k].getTypeName().getLocalPart()));
				resultTypeTemp.append(" other=(");
				resultTypeTemp.append(firstLetterToUpperCase(typesData[k].getTypeName().getLocalPart()));
				resultTypeTemp.append(") obj;");
				resultTypeTemp.append("\n\t\tif (obj==null) return false;");
				resultTypeTemp.append("\n\t\tif (this==obj) return true;");
				resultTypeTemp.append("\n\t\tboolean resp;");
				resultTypeTemp.append("\n\t\tresp=");
							
				for (int p=0;p<innerTypes.length;p++) {
					SequenceElement innerTypesEl=innerTypes[p];
							
					if (innerTypesEl.isElement()) {
								
						ElementType innerTypesElElementType=(ElementType)innerTypesEl;
						
						//extracting information
						QName innerTypesElQName=innerTypesElElementType.getTypeName();
						QName innerTypesElDataType=innerTypesElElementType.getElementType();
						String innerTypesElQNameLocalPart=innerTypesElQName.getLocalPart();
						String innerTypesElQNameNameSpace=innerTypesElQName.getNamespaceURI();
						String innerTypesElDataTypeLocalPart=innerTypesElDataType.getLocalPart();
						String innerTypesElDataTypeNameSpace=innerTypesElDataType.getNamespaceURI();
						String javaType=this.getJavaType(innerTypesElDataTypeLocalPart,innerTypesElDataTypeNameSpace);
						
						if (!innerTypesElDataTypeLocalPart.equals("float") && !innerTypesElDataTypeLocalPart.equals("int") && !innerTypesElDataTypeLocalPart.equals("long") && !innerTypesElDataTypeLocalPart.equals("boolean") && !innerTypesElDataTypeLocalPart.equals("double") && !innerTypesElDataTypeLocalPart.equals("byte")) {
						
							resultTypeTemp.append("((");
							resultTypeTemp.append(innerTypesElQNameLocalPart);
							resultTypeTemp.append("==null && other.get");
							resultTypeTemp.append(firstLetterToUpperCase(innerTypesElQNameLocalPart));
							resultTypeTemp.append("()==null)||");
							resultTypeTemp.append("\n\t\t\t");
							resultTypeTemp.append("(");
							resultTypeTemp.append(innerTypesElQNameLocalPart);
							resultTypeTemp.append("!=null && ");
							resultTypeTemp.append("\n\t\t\t");
							resultTypeTemp.append(innerTypesElQNameLocalPart);
							resultTypeTemp.append(".equals(other.get");
							resultTypeTemp.append(firstLetterToUpperCase(innerTypesElQNameLocalPart));
							resultTypeTemp.append("()))) && ");
						}
						else 
						    if (!innerTypesElDataTypeLocalPart.equals("boolean")) 
							{
							    resultTypeTemp.append("((");
							    resultTypeTemp.append(innerTypesElQNameLocalPart);
							    resultTypeTemp.append("==");
							    resultTypeTemp.append("other.get");
							    resultTypeTemp.append(firstLetterToUpperCase(innerTypesElQNameLocalPart));
							    resultTypeTemp.append("()");
							    resultTypeTemp.append("))");
							    resultTypeTemp.append("&&");
							    
							}
						    else 
							{
							    resultTypeTemp.append("((");
							    resultTypeTemp.append(innerTypesElQNameLocalPart);
							    resultTypeTemp.append("==");
							    resultTypeTemp.append("other.is");
							    resultTypeTemp.append(firstLetterToUpperCase(innerTypesElQNameLocalPart));
							    resultTypeTemp.append("()");
							resultTypeTemp.append("))");
							resultTypeTemp.append("&&");
							}			
						
					}//end if (innerTypesEl.isElement())
										
					
										

				} //end for (int p=0;p<innerTypes.length;p++) 
				
				
				resultTypeTemp.append("true;");
				resultTypeTemp.append("\n\t\treturn resp;");
				
				
				
				
				
				resultTypeTemp.append("\n\t}");
				
				    }
				
							
				resultType[sb].append(resultTypeTemp.toString());
				resultType[sb].append("\n}");//closing...
				//System.out.println("DEBUG sb before:"+sb);
				//System.out.println("DEBUG code:"+resultType[sb].toString());
				sb++;
			} //end else....in other words of the case it is not an array	
		
		}// end  for (int k=0;k<typesData.length;k++)if (typesData[k].isComplex())
			
	
	try {
		//Creation of the directories for the generated Java files
		sb=0;
		String path=null;
		for (int k=0;k<typesData.length;k++) {
			path=package2Path(resultTypePackageName[k]);
			File tFile=new File(dirName+fileSeparator+path);
			tFile.mkdirs();
		}	
	
	
		//Creation of the types files
		sb=0;
		for (int k=0;k<typesData.length;k++) {
			if (typesData[k].isComplex()) {
				path=package2Path(resultTypePackageName[k]);
				FileWriter fw3=new FileWriter(dirName+fileSeparator+path+fileSeparator+typesData[k].getTypeName().getLocalPart()+".java");
				fw3.write(resultType[sb].toString());
				fw3.close();
				resultType[sb]=null;
				sb++;
			}
		}
	
		System.gc();

	}
	catch (Exception e) {
		e.printStackTrace();
	}
	

	//*******************************************************
 	//Sixth phase: generation of the holders java files
	//*******************************************************
        
   	//counting elements
	int count=0;
       	for (Enumeration e=holderDataVector.elements(); e.hasMoreElements() ;) {
       		e.nextElement();
       		count=count+1;
	}
   
	HolderData[] holderDataArray=new HolderData[count];
       	count=0;
	for (Enumeration e=holderDataVector.elements(); e.hasMoreElements() ;) {
       		holderDataArray[count]=(HolderData)e.nextElement();
       		count=count+1;
	}
        int holderTypesNum=holderDataArray.length;
	StringBuffer[] resultHolderType=new StringBuffer[holderTypesNum];
	for (int h=0;h<holderTypesNum;h++) {
		resultHolderType[h]=new StringBuffer(); 
     		//Creating initial comments
     		resultHolderType[h].append("/**");
        	resultHolderType[h].append("\n *");
        	resultHolderType[h].append("\n * ");
		String holderFileName=holderDataArray[h].getHolderClassName()+".java";
		resultHolderType[h].append(holderFileName);
		resultHolderType[h].append("\n *");
		resultHolderType[h].append("\n * This file was auto-generated from WSDL file ");
		resultHolderType[h].append("\n * using Generator class developed by Mirco Musolesi at INRIA Rocquencourt");
		resultHolderType[h].append("\n */");
		resultHolderType[h].append("\npackage ");
		
		resultHolderType[h].append(getPackageName(holderDataArray[h].getHolderName())); //append package name
		resultHolderType[h].append(";");
		resultHolderType[h].append("\n");
		resultHolderType[h].append("public final class ");
		resultHolderType[h].append(holderDataArray[h].getHolderClassName());
		resultHolderType[h].append(" implements javax.xml.rpc.holders.Holder {");
		
		if (!holderDataArray[h].isArray()) {
			//case 1 the holder type is not an array type
		
			//generating the value variable
			resultHolderType[h].append("\n\tpublic ");
			resultHolderType[h].append(holderDataArray[h].getHolderType()); //append the type of the value contained in the holder
			resultHolderType[h].append(" value;");
		
			resultHolderType[h].append("\n");
			
			//generating the constructor (no input parameter)
			resultHolderType[h].append("\n\tpublic ");
			resultHolderType[h].append(holderDataArray[h].getHolderClassName());
			resultHolderType[h].append("() {");
			resultHolderType[h].append("\n\t}");
		
			resultHolderType[h].append("\n");
		
			//generating the constructor (with input parameter)
			resultHolderType[h].append("\n\tpublic ");
			resultHolderType[h].append(holderDataArray[h].getHolderClassName());
			resultHolderType[h].append("(");
			resultHolderType[h].append(holderDataArray[h].getHolderType());
			resultHolderType[h].append(" value) {");
			resultHolderType[h].append("\n\t\tthis.value=value;");
			resultHolderType[h].append("\n\t}");
			resultHolderType[h].append("\n");
		}
		else {
			//case 2 the holder type is an array type
			resultHolderType[h].append("\n\tpublic ");
			resultHolderType[h].append(holderDataArray[h].getArrayType());
			resultHolderType[h].append("[] ");
			resultHolderType[h].append(" value;");
			
			resultHolderType[h].append("\n");
			
			//generating the constructor (no input parameter)
			resultHolderType[h].append("\n\tpublic ");
			resultHolderType[h].append(holderDataArray[h].getHolderClassName());
			resultHolderType[h].append("() {");
			resultHolderType[h].append("\n\t}");
		
			resultHolderType[h].append("\n");
			
			resultHolderType[h].append("\n\tpublic ");
			resultHolderType[h].append(holderDataArray[h].getHolderClassName());
			resultHolderType[h].append("(");
			resultHolderType[h].append(holderDataArray[h].getArrayType());
			resultHolderType[h].append("[] ");
			resultHolderType[h].append("value) {");
			resultHolderType[h].append("\n\t\tthis.value=value;");
			resultHolderType[h].append("\n\t}");
			resultHolderType[h].append("\n");	
						
		}//end else
		
		//closing all
		resultHolderType[h].append("}");
		
		
	}// end for (int h=0;h<holderTypesNum;h++)
	
	
	if (debug) {
		for (int k=0;k<holderTypesNum;k++) {
			System.out.println("\n\nGenerated java holder file "+holderDataArray[k].getHolderName()+".java");
			System.out.println(resultHolderType[k].toString());
			System.out.println("\n*************************************************************");
		}
	}
	
	try {
		//Creation of the directories for the generated Java holder files
		for (int k=0;k<holderDataArray.length;k++) {
			String path=package2Path(getPackageName(holderDataArray[k].getHolderName()));
			File hFile=new File(dirName+fileSeparator+path);
			hFile.mkdirs();
		}
	
			
		//Creation of the holder types files
		for (int t=0;t<holderDataArray.length;t++) {
			String path=package2Path(getPackageName(holderDataArray[t].getHolderName()));
			FileWriter fw4=new FileWriter(dirName+fileSeparator+path+fileSeparator+holderDataArray[t].getHolderClassName()+".java");
			fw4.write(resultHolderType[t].toString());
			fw4.close();
		}
	}
	catch (Exception e) {
		e.printStackTrace();
	}
	
	
	
	//*******************************************************
        //Seventh phase: generation of the exception file
        //*******************************************************
        
        //counting the number of exceptions file to be generated
	int exceptionFilesNum=0;
	Vector generatedExceptionFileVector0=new Vector(); 
	for (int k=0;k<opData.length;k++) {
	        ExceptionData[] exceptions=opData[k].getExceptions();
		for (int r=0;r<exceptions.length;r++) {
				String exceptionName=exceptions[r].getName();
				if (!generatedExceptionFileVector0.contains(exceptionName)) {
					exceptionFilesNum++;
					generatedExceptionFileVector0.add(exceptionName);
				}
			}
		}
	
	StringBuffer[] resultEx=new StringBuffer[exceptionFilesNum];
	String[] resultExName=new String[exceptionFilesNum];
	
	int ec=0; //exception counter
	Vector generatedExceptionFileVector=new Vector(); //Vector containing the names of the generated exceptions files
		
	for (int k=0;k<opData.length;k++) {
		
		ExceptionData[] exceptions=opData[k].getExceptions();
		
		for (int r=0;r<exceptions.length;r++) {
			
			String exceptionName=exceptions[r].getName();
			
			//case 1: the file has not been generated before so...we generate
			if (!generatedExceptionFileVector.contains(exceptionName)) {
			
				//System.out.println ("Generating the "+exceptionName+" file.");
			
				resultEx[ec]=new StringBuffer(); 
     			        
     			        //Creating initial comments
     		   		resultEx[ec].append("/**");
        			resultEx[ec].append("\n *");
        			resultEx[ec].append("\n * ");
        			String exceptionClassName=firstLetterToUpperCase(exceptions[r].getName());
				String exceptionFileName=firstLetterToUpperCase(exceptions[r].getName())+".java";
				resultEx[ec].append(exceptionFileName);
				resultEx[ec].append("\n *");
				resultEx[ec].append("\n * This file was auto-generated from WSDL file ");
				resultEx[ec].append("\n * using Generator class developed by Mirco Musolesi at INRIA Rocquencourt");
				resultEx[ec].append("\n */");
				resultEx[ec].append("\n");
				
				//generating package
				resultEx[ec].append("\npackage ");
				resultEx[ec].append(packageName);
				resultEx[ec].append(";");
				
				//generating class
				resultEx[ec].append("\npublic class ");
				resultEx[ec].append(exceptionClassName);
				resultEx[ec].append(" extends java.lang.Exception {");
				
				ExceptionParData[] exceptionParam=exceptions[r].getExceptionParam();
				
				//generating class variables
				for (int e=0;e<exceptionParam.length;e++) {
										
					resultEx[ec].append("\n\tpublic ");
					resultEx[ec].append(getJavaType(exceptionParam[e].getType(),exceptionParam[e].getNameSpace()));
					resultEx[ec].append(" ");
					resultEx[ec].append(exceptionParam[e].getName());
					resultEx[ec].append(";");
				}
				
				
				//generating methods
				
				resultEx[ec].append("\n");
				
				//generating simple exception constructor
				resultEx[ec].append("\n\tpublic ");
				resultEx[ec].append(exceptionClassName);
				resultEx[ec].append("() {");
				resultEx[ec].append("\n\t}");
				
				resultEx[ec].append("\n");
				
				//generating a constructor that set class variables
				resultEx[ec].append("\n\tpublic ");
				resultEx[ec].append(exceptionClassName);
				resultEx[ec].append("(");
				for (int e=0;e<exceptionParam.length;e++) {
					resultEx[ec].append(getJavaType(exceptionParam[e].getType(),exceptionParam[e].getNameSpace()));
					resultEx[ec].append(" ");
					resultEx[ec].append(exceptionParam[e].getName());
					if (e<exceptionParam.length-1)
						resultEx[ec].append(",");
				}
				resultEx[ec].append(") {");
				for (int e=0;e<exceptionParam.length;e++) {
					resultEx[ec].append("\n\t\t");
					resultEx[ec].append("this.");
					resultEx[ec].append(exceptionParam[e].getName());
					resultEx[ec].append("=");
					resultEx[ec].append(exceptionParam[e].getName());
					resultEx[ec].append(";");
				}
				resultEx[ec].append("\n\t}");
				
				resultEx[ec].append("\n");
				
				//generating get methods
				
				for (int e=0;e<exceptionParam.length;e++) {
					resultEx[ec].append("\n\tpublic ");
					resultEx[ec].append(getJavaType(exceptionParam[e].getType(),exceptionParam[e].getNameSpace()));
					resultEx[ec].append(" get");
					resultEx[ec].append(firstLetterToUpperCase(exceptionParam[e].getName()));
					resultEx[ec].append("() {");
					resultEx[ec].append("\n\t\treturn this.");
					resultEx[ec].append(exceptionParam[e].getName());
					resultEx[ec].append(";");
					resultEx[ec].append("\n\t}");
				}		
								
				resultEx[ec].append("\n}"); //closing the class
												
				//after the generation process, we add the name of the exception to
				// generatedExceptionFileVector
				generatedExceptionFileVector.add(exceptionName);
				resultExName[ec]=exceptionName;
				//...and we increment the counter...
				ec++;
			
			
			}
			//case 2 the file has been generated before so...we generate nothing.
			else {
				//System.out.println("Generated before");
			
			}
								
			//ExceptionParData[] exceptionDataArrayexceptions[r].getExceptionParam();
		
			
		} //for (int r=0;r<exceptions.length;r++)
	
	}//for (int k=0;k<opData.length;k++)
	
	
	if (debug) {
		for (int k=0;k<exceptionFilesNum;k++) {
			System.out.println("\n\nGenerated exception file "+resultExName[k]+".java:\n");
			System.out.println(resultEx[k].toString()); 
			System.out.println("\n*************************************************************");
		}
	}
					
	//Creation of the directories for the generated stub file
	//PLEASE NOTE: we have to put the generated file in the same directory of the interface file
	//so we don't need to generate the directory
	
	String 	exceptionsDirName=interfaceDirName;	
	
	try {
		//Creation of the exceptions files
		for (int k=0;k<resultEx.length;k++) {
			FileWriter fw5=new FileWriter(dirName+fileSeparator+exceptionsDirName+fileSeparator+resultExName[k]+".java");
			fw5.write(resultEx[k].toString());
			fw5.close();
			resultEx[k]=null;
			System.gc();
		}
	} 
	catch (Exception e){
		e.printStackTrace();
	}
	
	
	
	//*******************************************************
        //Eigth phase: generation of the stub file
        //*******************************************************
        
        
        
        //Generating initial comment
	
        String stubDirName=interfaceDirName;
	String javaTypeD=getJavaType(def.getQName());
	String packageNameStub=getPackageName(javaTypeD);
	String stubFileNameTemp=bin.getQName().getLocalPart();
	String stubFileNameTemp2=firstLetterToUpperCase(stubFileNameTemp)+"Stub";
	String stubFileName=firstLetterToUpperCase(stubFileNameTemp)+"Stub.java";
	
        try {	
	//Creation of the directories for the generated stub file
	//PLEASE NOTE: we have to put the generated file in the same directory of the interface file
	//so we don't need to generate the directory
		
		
	//Creation of the stub file
	FileWriter fw6=new FileWriter(dirName+fileSeparator+stubDirName+fileSeparator+stubFileName);
	
        fw6.write("/**");
        fw6.write("\n *");
	fw6.write("\n * ");
	fw6.write(stubFileName);
	fw6.write("\n *");
	fw6.write("\n * This file was auto-generated from WSDL file ");
	fw6.write("\n * using Generator class developed by Mirco Musolesi at INRIA Rocquencourt");
	fw6.write("\n */");
	
	//Generating package name
	fw6.write("\n");
	fw6.write("package ");
	fw6.write(packageNameStub);
	fw6.write(";");
	
	//Generating import commands
	fw6.write("\nimport csoap.xml.rpc.CallImpl;");
	fw6.write("\nimport javax.xml.namespace.QName;");
	fw6.write("\nimport javax.xml.rpc.encoding.XMLType;");
	fw6.write("\nimport javax.xml.rpc.ParameterMode;");
	fw6.write("\nimport javax.xml.rpc.encoding.SerializerFactory;");
	fw6.write("\nimport javax.xml.rpc.encoding.DeserializerFactory;");
		
	//Generating class declaration");
	fw6.write("\npublic class ");
	fw6.write(stubFileNameTemp2); //class name
	fw6.write(" implements ");
	fw6.write(packageNameStub);
	fw6.write(".");
	fw6.write(portTypeName); //interface class name
	fw6.write(" {");
	
	fw6.write("\n");

	/// Generating Call
 	fw6.write("\n\tObject obj=null;");	
	fw6.write("\n");
	fw6.write("\n\tCallImpl call=new CallImpl();");	
	fw6.write("\n");

	//Generating constructor
	fw6.write("\n\tString addr;");
	fw6.write("\n\n\tpublic ");
	fw6.write(stubFileNameTemp2);
	fw6.write("(String ndAddress) {");

	fw6.write("\n\t\taddr=ndAddress;");
	fw6.write("\n\t}");
	
	fw6.write("\n");

       

	//Generating another constructor
	fw6.write("\n\n\tpublic ");
	fw6.write(stubFileNameTemp2);
	fw6.write("(java.net.URL url,javax.xml.rpc.Service service) {");
	fw6.write("\n\t\taddr=url.toString();");
	fw6.write("\n\t}");
	
	fw6.write("\n\n");
		
	//Generating methods

	        
        for (int k=0;k<opData.length;k++) {
        	
        	ParData[] parResponse=opData[k].getParDataResponse();
        	ParData[] parRequest=opData[k].getParDataRequest();
        	ExceptionData[] exceptions=opData[k].getExceptions();
        	
        	fw6.write("\tpublic ");
        	
        	//Creating return type
               	if (parResponse!=null)
               		if (parResponse.length==1) {
               		
               			//SPECIAL CASE treatment (array)
               			//array recognition mechanism for inner types

				if (debug) {
					System.out.println("parResponse[0] type"+parResponse[0].getType());
					System.out.println("parResponse[0] namespace"+parResponse[0].getNameSpace());
					System.out.println("parResponse[0] javatype"+getJavaType(parResponse[0].getType(),parResponse[0].getNameSpace()));
				}
				boolean retTypeIsAnArray=false;
				QName retTypeArrayType=null;	       	
        			String rType=null;				
				for (int q=0;q<typesData.length;q++) {
					
					//System.out.println("typesData[q].getTypeName"+typesData[q].getTypeName());
					
					if (typesData[q].getTypeName().getLocalPart().equals(parResponse[0].getType()))
						if (typesData[q].isArray()) {
							//System.out.println("found");
							retTypeIsAnArray=true;
							retTypeArrayType=typesData[q].getArrayType();
						}
				}
               			
               			//Generating return type	
               			if (!retTypeIsAnArray) {
               				rType=this.getJavaType(parResponse[0].getType(),parResponse[0].getNameSpace());
               				fw6.write(rType);
               				//System.out.println(parResponse[0].getType()+" is not an array");
               			}
               			else {
               				String typeTemp=this.getJavaType(retTypeArrayType);
               				rType=typeTemp+"[]";
               				fw6.write(rType);
               				//System.out.println(parResponse[0].getType()+" is an array");
               			}
               			
               		}
              
                if (parResponse==null) {
               		fw6.write("void");
       		}
               	else if (parResponse.length>1) {
               		fw6.write("void");	
        	}
        	fw6.write(" ");
        	fw6.write(firstLetterToLowerCase(opData[k].getOperationName()));
        
        	//Creating inputTypes
        	fw6.write("(");
        	
		//case 0 param response
		if (parResponse==null) {
 		         if (parRequest!=null) {
 		         
 		         

	  			//array recognition mechanism
          			for (int s=0;s<parRequest.length;s++) {
          				boolean typeIsAnArray=false;
          				QName retTypeArrayType=null;
          				for (int q=0;q<typesData.length;q++) {
          					if (typesData[q].getTypeName().getLocalPart().equals(parRequest[s].getType()))
          						if (typesData[q].isArray()) {
          							typeIsAnArray=true;
          							retTypeArrayType=typesData[q].getArrayType();
          							//System.out.println("@@@@@@@TROVATO");
          					}
          				}
          				if (!typeIsAnArray) {
          					String type=this.getJavaType(parRequest[s].getType(),parRequest[s].getNameSpace());
        					fw6.write(type);
        					
      			  		}
        				else {
        					String typeTemp=this.getJavaType(retTypeArrayType);
        					String type=typeTemp+"[]";
        					fw6.write(type);
        						
        				}		
        				fw6.write(" ");
        				fw6.write(parRequest[s].getName());
        				if (s!=(parRequest.length-1))
        						fw6.write(", ");  
        			}//end for (int s=0;s<parRequest.length;s++)
          			//end array recognition mechanism
        			        		
          		
          		}
        	}
        	
        	
        	//case 1 param response 
        	if (parResponse!=null) {
        		if (parResponse.length==1) {
        			
	   			//array recognition mechanism
          			for (int s=0;s<parRequest.length;s++) {
          				boolean typeIsAnArray=false;
          				QName retTypeArrayType=null;
          				for (int q=0;q<typesData.length;q++) {
          					if (typesData[q].getTypeName().getLocalPart().equals(parRequest[s].getType()))
          						if (typesData[q].isArray()) {
          							typeIsAnArray=true;
          							retTypeArrayType=typesData[q].getArrayType();
          							//System.out.println("@@@@@@@TROVATO");
          					}
          				}
          				if (!typeIsAnArray) {
          					String type=this.getJavaType(parRequest[s].getType(),parRequest[s].getNameSpace());
        					fw6.write(type);
        					
      			  		}
        				else {
        					String typeTemp=this.getJavaType(retTypeArrayType);
        					String type=typeTemp+"[]";
        					fw6.write(type);
        						
        				}		
        				fw6.write(" ");
        				fw6.write(parRequest[s].getName());
        				if (s!=(parRequest.length-1))
        						fw6.write(", ");  
        			}//end for (int s=0;s<parRequest.length;s++)
          			//end array recognition mechanism
        	        	
        		
        		} //if (parResponse.length==1)
	   	} //if (parResponse!=null)
 		
 				
		//case >1 param response	
       		if (parResponse!=null)
       			if (parResponse.length>1) {
       			 
	   			//array recognition mechanism
          			for (int s=0;s<parRequest.length;s++) {
          				boolean typeIsAnArray=false;
          				QName retTypeArrayType=null;
          				for (int q=0;q<typesData.length;q++) {
          					if (typesData[q].getTypeName().getLocalPart().equals(parRequest[s].getType()))
          						if (typesData[q].isArray()) {
          							typeIsAnArray=true;
          							retTypeArrayType=typesData[q].getArrayType();
          							//System.out.println("@@@@@@@TROVATO");
          					}
          				}
          				if (!typeIsAnArray) {
          					String type=this.getJavaType(parRequest[s].getType(),parRequest[s].getNameSpace());
        					fw6.write(type);
        					
      			  		}
        				else {
        					String typeTemp=this.getJavaType(retTypeArrayType);
        					String type=typeTemp+"[]";
        					fw6.write(type);
        						
        				}		
        				fw6.write(" ");
        				fw6.write(parRequest[s].getName());
        				if (s!=(parRequest.length-1))
        						fw6.write(", ");  
        			}//end for (int s=0;s<parRequest.length;s++)
          			//end array recognition mechanism
       		 	
       		 	
       		 	        if ((parResponse.length>0)&&(parRequest.length>0))
       		 	        	fw6.write(", ");
        				
        	    	
          		 	for (int s=0;s<parResponse.length;s++) {
             				             				            				
             				//holderType is the name of the class that implements the holder
             				String holderType=this.getJavaTypeHolder(parResponse[s].getType(),parResponse[s].getNameSpace());
        				
        				//holderTypeValue is the name of the type contained in the holder
        				String holderValueType=this.getJavaType(parResponse[s].getType(),parResponse[s].getNameSpace());
        				
        				//PLEASE NOTE
        		        	//if the holder is not a standand java holder, in other words if
        				//it is not present in the javax.xml.rpc.holders package, a class 
        				//for this holder must be generated.
        				//
        				//Here in a sense we *request* the generation of these holders for user-defined types
        				//
        				//f (debug)
        				//	System.out.println(holderType+" is a standard Holder?"+isAStandardHolder(holderType));
        				//if (!isAStandardHolder(holderType)) {
        				//		HolderData holderDataItem=new HolderData();
        				//		holderDataItem.setHolderName(holderType);
        				//	holderDataItem.setHolderType(holderValueType);
        				//	holderDataVector.add(holderDataItem);
        				//}//end if (!isAStandardHolder(holderType))
        				
        				fw6.write(holderType+" ");
        				fw6.write(parResponse[s].getName());
        				if (s!=(parResponse.length-1))
        				fw6.write(", ");
        						
        				
        			}
        				
               	}
        	
        	fw6.write(")");
       	
        	
               	//managing exception...
        	
        	//"standard exception" java.rmi.RemoteException
        	fw6.write(" throws ");
        	fw6.write("java.rmi.RemoteException");
        		
		//user-defined exception
		if (exceptions!=null) {
			for (int i=0;i<exceptions.length;i++) {
			
			String exceptionName=exceptions[i].getName();
			
			fw6.write(",");
			fw6.write(packageName);
			fw6.write(".");
			fw6.write(firstLetterToUpperCase(exceptionName));
			
			}
		}//end if (exceptions!=null)
			
		//retrieving user defined exception
		//localPartDefName is the name of our package
		//String userDefException=localPartDefName+"."+
        	        	
		fw6.write(" {");
		
		//declaring call
		//fw6.write("\n\t\tCallImpl call=new CallImpl();");	
		
		//set operation name
		fw6.write("\n\t\tcall.removeAllParameters();");
		fw6.write("\n\t\tcall.setOperationName(new QName");
		fw6.write("(");
		fw6.write('"');
		fw6.write(opData[k].getOperationNameSpace());
		fw6.write('"');
		fw6.write(",");
		fw6.write('"');
		fw6.write(opData[k].getOperationName());
		fw6.write('"');
		fw6.write("));");
		
		//generating call.registerTypeMapping
                // rafik add *******************
                if (typesData!=null && typesData.length>0)
		{
		           
        	fw6.write("\n\t\ttry {");
        	 	
        	//if (typesData!=null)
        		for (int kl=0;kl<typesData.length;kl++)
                        {
        			if (!typesData[kl].isArray()) {
        				fw6.write("\n\t\t\tcall.registerTypeMapping(");
        			    	
        	    			String javaTypeReg=getJavaType(typesData[kl].getTypeName());
        	    		        fw6.write("Class.forName(");
        				fw6.write('"');
        				fw6.write(javaTypeReg);
 					fw6.write('"');
 					fw6.write(")");
        	    		
        	    			fw6.write(",");
        				fw6.write("new QName(");
        				fw6.write('"');
                                        fw6.write(typesData[kl].getTypeName().getNamespaceURI());
        				fw6.write('"');
        				fw6.write(",");
        				fw6.write('"');
        				fw6.write(typesData[kl].getTypeName().getLocalPart());
                                        fw6.write('"');
        				fw6.write(")");
        				fw6.write(",");
        				
        				fw6.write("new ");
        				fw6.write(serializerClassName);
        				fw6.write("(");
        						
        				fw6.write("Class.forName(");
        				fw6.write('"');
        				fw6.write(javaTypeReg);
 					fw6.write('"');
 					fw6.write(")");										
        			    						
        				fw6.write(",");
        				fw6.write("new QName(");
        				fw6.write('"');
        				fw6.write(typesData[kl].getTypeName().getNamespaceURI());
        				fw6.write('"');
        				fw6.write(",");
        				fw6.write('"');
        				fw6.write(typesData[kl].getTypeName().getLocalPart());
        				fw6.write('"');
        				fw6.write(")");
        				fw6.write(")");
        			    			     					        						  					
        				fw6.write(",");
        			
        				fw6.write("new ");
        				fw6.write(deserializerClassName);
        				fw6.write("(");  
        						 	
        				fw6.write("Class.forName(");
        				fw6.write('"');
        				fw6.write(javaTypeReg);
 					fw6.write('"');
 					fw6.write(")");
        			   			
        				fw6.write(",");
        				fw6.write("new QName(");
        				fw6.write('"');
        				fw6.write(typesData[kl].getTypeName().getNamespaceURI());
        				fw6.write('"');
        				fw6.write(",");
        				fw6.write('"');
        				fw6.write(typesData[kl].getTypeName().getLocalPart());
        				fw6.write('"');
        				fw6.write("))");
        			    						    			 			     					
        				fw6.write(");");
                                } else { //if (!typesData[kl].isArray())
        				        			    	
        	    			String javaTypeReg=getJavaType(typesData[kl].getTypeName());
        	    		        
                                        // rafik add ****************************************************** 
                                        fw6.write("\n\t\t\tobj = java.lang.reflect.Array.newInstance(");
                                        
                                        
                                        QName arrayTypeQName=typesData[kl].getArrayType();
                                        String javaArrayTypeTemp=getJavaType(arrayTypeQName);
                    
                                        String javaArrayType=javaArrayTypeTemp+"[]";
                                        //String javaArrayType=javaArrayTypeTemp;

                                        //fw6.write(javaTypeReg);
					if (javaArrayTypeTemp.equals("int"))
					    {
						fw6.write("int.class");
						fw6.write(",1);");
					    }
					else
					    {
						fw6.write("Class.forName(");
						fw6.write('"');
						fw6.write(javaArrayTypeTemp);
						fw6.write('"');
						fw6.write("),1);");
					    }
                                                                               
                                        fw6.write("\n\t\t\tcall.registerTypeMapping(");

                                        fw6.write("obj.getClass()");

        	    			fw6.write(",");
        				fw6.write("new QName(");
        				fw6.write('"');
                                        fw6.write(typesData[kl].getTypeName().getNamespaceURI());
        				fw6.write('"');
        				fw6.write(",");
        				fw6.write('"');
        				fw6.write(typesData[kl].getTypeName().getLocalPart());
                                        fw6.write('"');
        				fw6.write(")");
        				fw6.write(",");
        				
        				fw6.write("new ");
        				fw6.write(arraySerializerClassName);
        				fw6.write("(");
        						
        				//fw6.write("Class.forName(");
        				//fw6.write('"');
        				//fw6.write(javaTypeReg);
 					//fw6.write('"');
 					//fw6.write(")");									
					fw6.write("obj.getClass()");	
        			    						
        				fw6.write(",");
        				fw6.write("new QName(");
        				fw6.write('"');
        				fw6.write(typesData[kl].getTypeName().getNamespaceURI());
        				fw6.write('"');
        				fw6.write(",");
        				fw6.write('"');
        				fw6.write(typesData[kl].getTypeName().getLocalPart());
        				fw6.write('"');
        				fw6.write(")");
        				fw6.write(")");
        			    			        						        						  					
        				fw6.write(",");
        			
        				fw6.write("new ");
        				fw6.write(arrayDeserializerClassName);
        				fw6.write("(");  
        						 	
        				//fw6.write("Class.forName(");
        				//fw6.write('"');
        				//fw6.write(javaTypeReg);
 					//fw6.write('"');
 					//fw6.write(")");

					fw6.write("obj.getClass()"); 			
        				fw6.write(",");
        				fw6.write("new QName(");
        				fw6.write('"');
        				fw6.write(typesData[kl].getTypeName().getNamespaceURI());
        				fw6.write('"');
        				fw6.write(",");
        				fw6.write('"');
        				fw6.write(typesData[kl].getTypeName().getLocalPart());
        				fw6.write('"');
        				fw6.write("))");
       						     					
        				fw6.write(");");
                                }
        			
                        }
        	fw6.write("\n\t\t}");
        	fw6.write("\n\t\tcatch (ClassNotFoundException e) {e.printStackTrace();}");
	}
	//END WORKING AREA
				
		//case 0 param response
		if (parResponse==null) {
 		         if (parRequest!=null) {
          			
          			//generating call.AddParameter...
          			for (int s=0;s<parRequest.length;s++) {
             				fw6.write("\n\t\tcall.addParameter(");
             				fw6.write('"');
             				fw6.write(parRequest[s].getName());
             				fw6.write('"');
             				fw6.write(",");
             				fw6.write("new QName(");
             				fw6.write('"');
             				fw6.write(parRequest[s].getNameSpace());
             				fw6.write('"');
             				fw6.write(",");
             				fw6.write('"');
             				fw6.write(parRequest[s].getType());
             				fw6.write('"');
             				fw6.write("),");
             				fw6.write("ParameterMode.IN");
             				fw6.write(");");
        			}
		
        			

        
        
        			//generating call.setEndpointAddress
				fw6.write("\n\t\tcall.setTargetEndpointAddress(addr);");
				          			
          			//generating invokeOneWay
          			fw6.write("\n\t\tcall.invokeOneWay(new Object[]{");
          			for (int s=0;s<parRequest.length;s++) {
				   if (parRequest[s].getType().equals("int"))
					fw6.write("new java.lang.Integer("+parRequest[s].getName()+")");
				    else if (parRequest[s].getType().equals("boolean"))
					fw6.write("new java.lang.Boolean("+parRequest[s].getName()+")");
                                    else
          				fw6.write(parRequest[s].getName());
				    if (s<parRequest.length-1)
					fw6.write(",");
          			}
          			fw6.write("});");
				
          		
          		
          		
          		} //if (parRequest!=null)
        	} //if (parResponse==null) 
        	
        	
        	
        	//case 1 param response 
        	if (parResponse!=null) 
        		if (parResponse.length==1) {
        		
        			//generating call.addParameter for response parameters
        			//fw6.write("\n\t\tcall.addParameter(");
             			//fw6.write('"');
             			//fw6.write(parResponse[0].getName());
             			//fw6.write('"');
             			//fw6.write(",");
             			//fw6.write("new QName(");
             			//fw6.write('"');
             			//fw6.write(parResponse[0].getNameSpace());
             			//fw6.write('"');
             			//fw6.write(",");
             			//fw6.write('"');
             			//fw6.write(parResponse[0].getType());
             			//fw6.write('"');
             			//fw6.write("),");
             			//fw6.write("ParameterMode.OUT");
             			//fw6.write(");");
                                
                                //generating setReturnType
                                fw6.write("\n\t\tcall.setReturnType(new QName(");
                                fw6.write('"');
                                fw6.write(parResponse[0].getNameSpace());
                                fw6.write('"');
                                fw6.write(",");
                                fw6.write('"');
                                fw6.write(parResponse[0].getType());
                                fw6.write('"');
                                fw6.write("));");
                                
                                //generating setReturnQName
                                fw6.write("\n\t\t//call.setReturnQName(new QName(");
                                fw6.write('"');
                                fw6.write('"');
                                fw6.write(",");
                                fw6.write('"');
                                fw6.write(parResponse[0].getName());
                                fw6.write('"');
                                fw6.write("));");
                                
        			//generating call.AddParameter for request parameters
          			for (int s=0;s<parRequest.length;s++) {
             				fw6.write("\n\t\tcall.addParameter(");
             				fw6.write('"');
             				fw6.write(parRequest[s].getName());
             				fw6.write('"');
             				fw6.write(",");
             				fw6.write("new QName(");
             				fw6.write('"');
             				fw6.write(parRequest[s].getNameSpace());
             				fw6.write('"');
             				fw6.write(",");
             				fw6.write('"');
             				fw6.write(parRequest[s].getType());
             				fw6.write('"');
             				fw6.write("),");
             				fw6.write("ParameterMode.IN");
             				fw6.write(");");
        			}
        			
        			//generating call.setEndpointAddress
				fw6.write("\n\t\tcall.setTargetEndpointAddress(addr);");
        						
				//SPECIAL CASE treatment (array)
               			//array recognition mechanism for inner types

				if (debug) {
					System.out.println("parResponse[0] type"+parResponse[0].getType());
					System.out.println("parResponse[0] namespace"+parResponse[0].getNameSpace());
					System.out.println("parResponse[0] javatype"+getJavaType(parResponse[0].getType(),parResponse[0].getNameSpace()));
				}
				boolean retTypeIsAnArray=false;
				QName retTypeArrayType=null;	       	
        			String rType=null;				
				for (int q=0;q<typesData.length;q++) {
					
					//System.out.println("typesData[q].getTypeName"+typesData[q].getTypeName());
					
					if (typesData[q].getTypeName().getLocalPart().equals(parResponse[0].getType()))
						if (typesData[q].isArray()) {
							//System.out.println("found");
							retTypeIsAnArray=true;
							retTypeArrayType=typesData[q].getArrayType();
						}
				}
               			
               			//Generating return type	
               			if (!retTypeIsAnArray) {
               			      		
               				String javaType=getJavaType(parResponse[0].getType(),parResponse[0].getNameSpace());
               				 
               				fw6.write("\n\t\tjava.lang.Object resp=");
               							
               				fw6.write("call.invoke(new Object[]{");
					for (int s=0;s<parRequest.length;s++) {
					    if (parRequest[s].getType().equals("int"))
						fw6.write("new java.lang.Integer("+parRequest[s].getName()+")");
                                            else if (parRequest[s].getType().equals("boolean"))
						fw6.write("new java.lang.Boolean("+parRequest[s].getName()+")");                                            
					    else fw6.write(parRequest[s].getName());
          					if (s<parRequest.length-1)
          						fw6.write(",");
          				}
          				fw6.write("});");
          				
          				
          				//generating return statement
          				fw6.write("\n\t\treturn ");
          				
          				if (javaType.equals("int")) {
               					fw6.write("((");
               					fw6.write("java.lang.Integer");
               					fw6.write(")");
               					fw6.write(" resp");
               					fw6.write(")");
               					fw6.write(".intValue();");
               				}
               				
               				else if (javaType.equals("long")) {
               					fw6.write("((");
               					fw6.write("java.lang.Long");
               					fw6.write(")");
               					fw6.write(" resp");
               					fw6.write(")");
               					fw6.write(".longValue();");
               				}
               				else if (javaType.equals("short")) {
               					fw6.write("((");
               					fw6.write("java.lang.Short");
               					fw6.write(")");
               					fw6.write(" resp");
               					fw6.write(")");
               					fw6.write(".shortValue();");
               				}
               				else if (javaType.equals("float")) {
               					fw6.write("((");
               					fw6.write("java.lang.Float");
               					fw6.write(")");
               					fw6.write(" resp");
               					fw6.write(")");
               					fw6.write(".floatValue();");
               				}
               				else if (javaType.equals("double")) {
               					fw6.write("((");
               					fw6.write("java.lang.Double");
               					fw6.write(")");
               					fw6.write(" resp");
               					fw6.write(")");
               					fw6.write(".doubleValue();");
               				}
               				else if (javaType.equals("boolean")) {
               					fw6.write("((");
               					fw6.write("java.lang.Boolean");
               					fw6.write(")");
               					fw6.write(" resp");
               					fw6.write(")");
               					fw6.write(".booleanValue();");
               				}               				               				
               				else if (javaType.equals("byte")) {
               					fw6.write("((");
               					fw6.write("java.lang.Byte");
               					fw6.write(")");
               					fw6.write(" resp");
               					fw6.write(")");
               					fw6.write(".byteValue();");
               				}
               				//else if (javaType.equals("byte[]")) {
					//fw6.write("((");
					//fw6.write("java.nio.ByteBuffer");
					//fw6.write(")");
					//fw6.write(" resp");
					//fw6.write(")");
					//fw6.write(".array();");
               				//}
               				            				
               				else {
               					//default case
               					fw6.write("(");
               					fw6.write(javaType);
               					fw6.write(") ");
               					fw6.write(" resp;");
               				}
               			           			
               			} //end if (!retTypeIsAnArray)
               			else {
               			       //generating return and invoke
					fw6.write("\n\t\treturn ");
					fw6.write("(");
					String typeTemp=this.getJavaType(retTypeArrayType);
               				rType=typeTemp+"[]";
               				fw6.write(rType);
               				fw6.write(")");
					fw6.write("call.invoke(new Object[]{");
					for (int s=0;s<parRequest.length;s++) {
					    if (parRequest[s].getType().equals("int"))
						fw6.write("new java.lang.Integer("+parRequest[s].getName()+")");
                                            else if (parRequest[s].getType().equals("boolean"))
						fw6.write("new java.lang.Boolean("+parRequest[s].getName()+")");
					    else fw6.write(parRequest[s].getName());
					    if (s<parRequest.length-1)
						fw6.write(",");
          				}
          				fw6.write("});");
               			
               			}
							
							
				

          			
			
			}	

	   	//case >1 param response	
       		if (parResponse!=null)
       			if (parResponse.length>1) {
       			 	
       			 	//generating call.AddParameter for response parameters
			   
          			for (int s=0;s<parResponse.length;s++) {
             				fw6.write("\n\t\tcall.addParameter(");
             				fw6.write('"');
             				fw6.write(parResponse[s].getName());
             				fw6.write('"');
             				fw6.write(",");
             				fw6.write("new QName(");
             				fw6.write('"');
             				fw6.write(parResponse[s].getNameSpace());
             				fw6.write('"');
             				fw6.write(",");
             				fw6.write('"');
             				fw6.write(parResponse[s].getType());
             				fw6.write('"');
             				fw6.write("),");
             				fw6.write("ParameterMode.OUT");
             				fw6.write(");");
        			}
        			
        			//generating call.AddParameter for request parameters
          			for (int s=0;s<parRequest.length;s++) {
             				fw6.write("\n\t\tcall.addParameter(");
             				fw6.write('"');
             				fw6.write(parRequest[s].getName());
             				fw6.write('"');
             				fw6.write(",");
             				fw6.write("new QName(");
             				fw6.write('"');
             				fw6.write(parRequest[s].getNameSpace());
             				fw6.write('"');
             				fw6.write(",");
             				fw6.write('"');
             				fw6.write(parRequest[s].getType());
             				fw6.write('"');
             				fw6.write("),");
             				fw6.write("ParameterMode.IN");
             				fw6.write(");");
             			}
             				
        			//generating call.setEndpointAddress
				fw6.write("\n\t\tcall.setTargetEndpointAddress(addr);");
        			        			
        			//generating invoke
          			fw6.write("\n\t\tjava.lang.Object resp=");
          			fw6.write("call.invoke(new Object[]{");
          			for (int s=0;s<parRequest.length;s++) {
				    if (parRequest[s].getType().equals("int"))
					fw6.write("new java.lang.Integer("+parRequest[s].getName()+")");
                                    else if (parRequest[s].getType().equals("boolean"))
                                        fw6.write("new java.lang.Boolean("+parRequest[s].getName()+")");                                    
				    else fw6.write(parRequest[s].getName());
				    if (s<parRequest.length-1)
					fw6.write(",");
          			}
          			fw6.write("});");
          			
          			
          			//treatment of holders types
          			fw6.write("\n\t\tif (resp instanceof java.rmi.RemoteException) {");
          			fw6.write("\n\t\t\tthrow (java.rmi.RemoteException)resp;");
          			fw6.write("\n\t\t}");
          			fw6.write("\n\t\telse {");
          			fw6.write("\n\t\t\tjava.util.Map output;");
          			fw6.write("\n\t\t\toutput=call.getOutputParams();");
          			for (int s=0;s<parResponse.length;s++) {
				    boolean isInt = false;
                                    boolean isBool = false;
          				fw6.write("\n\t\t\ttry {");
          				fw6.write("\n\t\t\t\t");
          				fw6.write(parResponse[s].getName());
          				fw6.write(".value=(");
          				        				
          				//array recognition mechanism
          				boolean typeIsAnArray=false;
          				QName retTypeArrayType=null;
          				for (int q=0;q<typesData.length;q++) {
          					if (typesData[q].getTypeName().getLocalPart().equals(parResponse[s].getType()))
          						if (typesData[q].isArray()) {
          							typeIsAnArray=true;
          							retTypeArrayType=typesData[q].getArrayType();
          							
          					}
          				}
          				if (!typeIsAnArray) {
          					String type=this.getJavaType(parResponse[s].getType(),parResponse[s].getNameSpace());
						if (type.equals("int")) {
							type = "java.lang.Integer";
							isInt = true;
							fw6.write("(");
						} else if (type.equals("boolean")) {
							type = "java.lang.Boolean";
							isBool = true;
							fw6.write("(");
						}
                                                
        					fw6.write(type);
        					
      			  		}
        				else {
        					String typeTemp=this.getJavaType(retTypeArrayType);
        					String type=typeTemp+"[]";
        					fw6.write(type);
        						
        				}		
					/*	
          				fw6.write(") ");
					fw6.write("output.get(new javax.xml.namespace.QName(");
          				fw6.write('"');
          				fw6.write('"');
          				fw6.write(",");
          				fw6.write('"');
          				fw6.write(parResponse[s].getName());
          				fw6.write('"');
          				fw6.write("));"); */
					/// rafik modification
     				fw6.write(") ");
					fw6.write("output.get(");
          				fw6.write('"');
          				fw6.write(parResponse[s].getName());
          				fw6.write('"');
          				fw6.write(")"); 
					if (isInt) fw6.write(").intValue()"); 
                                        if (isBool) fw6.write(").booleanValue()"); 
					fw6.write(";"); 
          				fw6.write("\n\t\t\t}");
          				fw6.write("\n\t\t\tcatch (java.lang.Exception exception) {");
          				fw6.write("\n\t\t\t\t");
          				fw6.write("throw (java.rmi.RemoteException)exception;");
          				fw6.write("\n\t\t\t}");
          				          				          				        				
          			}// end for (int s=0;s<parRequest.length;s++)
         			fw6.write("\n\t\t}");
  	       	} //end case >1 param response
		
			
		//closing method declaration
		fw6.write("\n\t}");
		        	
        	fw6.write("\n\n");
       	
       	 }// for (int k=0;k<opData.length;k++)
	
	//closing stub class declaration
	fw6.write("}");

        fw6.close();
	}
	catch (Exception e) {
		e.printStackTrace();
	}
	
	
	
	
	//*******************************************************
        //Nineth phase: generation of the implementation file
        //*******************************************************
       String implementationFileNameTemp=bin.getQName().getLocalPart();
	String implementationFileNameTemp2=firstLetterToUpperCase(implementationFileNameTemp)+"Impl";
	String implementationFileName=firstLetterToUpperCase(implementationFileNameTemp2)+".java";  
      
       try {		
	//Creation of the implementation file
	FileWriter fw7=new FileWriter(dirName+fileSeparator+interfaceDirName+fileSeparator+implementationFileName);
	//Creating initial comments
        fw7.write("/**");
        fw7.write("\n *");
	fw7.write("\n * ");
	fw7.write(implementationFileName);
	fw7.write("\n *");
	fw7.write("\n * This file was auto-generated from WSDL file ");
	fw7.write("\n * using Generator class developed by Mirco Musolesi at INRIA Rocquencourt");
	fw7.write("\n */");
	
	String javaTypeDefImpl=getJavaType(def.getQName());
	String packageNameImpl=getPackageName(javaTypeDefImpl);

	if (debug) {
		System.out.println("Def qname local part: "+def.getQName().getLocalPart());
		System.out.println("Def qname namespace: "+def.getQName().getNamespaceURI());
		System.out.println("JavaTypeDef: "+javaTypeDefImpl);
		System.out.println("PackageName: "+packageNameImpl);
	}
	
	//defining interface directoryname
	String implementationDirName=new String(packageName);
	
	String localPartDefNameImpl=packageNameImpl; //to mantain the structure of the previous implementation
	
	//Creating package statement;
	fw7.write("\npackage ");
	fw7.write(localPartDefNameImpl);//package name
	fw7.write(";");
	fw7.write("\n\n");
        
        //Creating interface declaration
        fw7.write("\npublic class ");
        fw7.write(implementationFileNameTemp2);
        fw7.write(" implements ");
        fw7.write(portTypeName);
        fw7.write(" {\n"); 
          
        if (debug)
        	System.out.println("opData: "+opData);
       
        //Creating interface methods
        for (int k=0;k<opData.length;k++) {
        	
        	ParData[] parResponse=opData[k].getParDataResponse();
        	ParData[] parRequest=opData[k].getParDataRequest();
        	ExceptionData[] exceptions=opData[k].getExceptions();
        	fw7.write("\tpublic ");
        	        	       	
        	//Creating return type
               	if (parResponse!=null)
               		if (parResponse.length==1) {
               		
               			//SPECIAL CASE treatment (array)
               			//array recognition mechanism for inner types
				boolean retTypeIsAnArray=false;
				QName retTypeArrayType=null;
				if (debug) {
					System.out.println("parResponse[0] type"+parResponse[0].getType());
					System.out.println("parResponse[0] namespace"+parResponse[0].getNameSpace());
					System.out.println("parResponse[0] javatype"+getJavaType(parResponse[0].getType(),parResponse[0].getNameSpace()));
				}
								
				for (int q=0;q<typesData.length;q++) {
					
					//System.out.println("typesData[q].getTypeName"+typesData[q].getTypeName());
					
					if (typesData[q].getTypeName().getLocalPart().equals(parResponse[0].getType()))
						if (typesData[q].isArray()) {
							//System.out.println("found");
							retTypeIsAnArray=true;
							retTypeArrayType=typesData[q].getArrayType();
						}
				}
               			
               			//Generating return type	
               			if (!retTypeIsAnArray) {
               				String type=this.getJavaType(parResponse[0].getType(),parResponse[0].getNameSpace());
               				fw7.write(type);
               				if (debug)
               					System.out.println(parResponse[0].getType()+" is not an array");
               			}
               			else {
               				String typeTemp=this.getJavaType(retTypeArrayType);
               				String type=typeTemp+"[]";
               				fw7.write(type);
               				if (debug)
               					System.out.println(parResponse[0].getType()+" is an array");
               			}
               			
               		}

              
                if (parResponse==null) {
               		fw7.write("void");
       		}
               	else if (parResponse.length>1) {
               		fw7.write("void");	
        	}
        	
        	
        	//PLEASE NOTE
        	//set a boolean flag for the generation of the return instruction
        	//if returnNull=true then generate <return null;> as method body
        	//else generate <return;">
        	
        	boolean returnNull=true;
        	if ((parResponse==null)||(parResponse.length>1)) returnNull=false;
        	        	
        	fw7.write(" ");
        	fw7.write(firstLetterToLowerCase(opData[k].getOperationName()));
        
        	//Creating inputTypes
        	fw7.write("(");
        	
		//case 0 param response
		if (parResponse==null) {
		
 		       
 		         if (parRequest!=null) {
 		          	
 		          	//array recognition mechanism
          			for (int s=0;s<parRequest.length;s++) {
          				boolean typeIsAnArray=false;
          				QName retTypeArrayType=null;
          				for (int q=0;q<typesData.length;q++) {
          					if (typesData[q].getTypeName().getLocalPart().equals(parRequest[s].getType()))
          						if (typesData[q].isArray()) {
          							typeIsAnArray=true;
          							retTypeArrayType=typesData[q].getArrayType();
          							
          					}
          				}
          				if (!typeIsAnArray) {
          					String type=this.getJavaType(parRequest[s].getType(),parRequest[s].getNameSpace());
        					fw7.write(type);
        					
      			  		}
        				else {
        					String typeTemp=this.getJavaType(retTypeArrayType);
        					String type=typeTemp+"[]";
        					fw7.write(type);
        						
        				}		
        				fw7.write(" ");
        				fw7.write(parRequest[s].getName());
        				if (s!=(parRequest.length-1))
        						fw7.write(", ");  
        			}//end for (int s=0;s<parRequest.length;s++)
          			//end array recognition mechanism
          		}
        	}
        	
        	//case 1 param response 
        	if (parResponse!=null) {
        		if (parResponse.length==1) 
        		
        			
        			//for (int s=0;s<parRequest.length;s++) {
        			//	String type=this.getJavaType(parRequest[s].getType(),parRequest[s].getNameSpace());
        			//	fw2.write(type+" ");
        			//	fw2.write(parRequest[s].getName());
        			//	if (s!=(parRequest.length-1))
        			//	fw2.write(", ");
        			//}
	   				
	   			//array recognition mechanism
          			for (int s=0;s<parRequest.length;s++) {
          				boolean typeIsAnArray=false;
          				QName retTypeArrayType=null;
          				for (int q=0;q<typesData.length;q++) {
          					if (typesData[q].getTypeName().getLocalPart().equals(parRequest[s].getType()))
          						if (typesData[q].isArray()) {
          							typeIsAnArray=true;
          							retTypeArrayType=typesData[q].getArrayType();
          							//System.out.println("@@@@@@@TROVATO");
          					}
          				}
          				if (!typeIsAnArray) {
          					String type=this.getJavaType(parRequest[s].getType(),parRequest[s].getNameSpace());
        					fw7.write(type);
        					
      			  		}
        				else {
        					String typeTemp=this.getJavaType(retTypeArrayType);
        					String type=typeTemp+"[]";
        					fw7.write(type);
        						
        				}		
        				fw7.write(" ");
        				fw7.write(parRequest[s].getName());
        				if (s!=(parRequest.length-1))
        						fw7.write(", ");  
        			}//end for (int s=0;s<parRequest.length;s++)
          			//end array recognition mechanism
	   		
	   	
	   	}
 		
		//case >1 param response	
       		if (parResponse!=null)
       			if (parResponse.length>1) {

	   			//array recognition mechanism
          			for (int s=0;s<parRequest.length;s++) {
          				boolean typeIsAnArray=false;
          				QName retTypeArrayType=null;
          				for (int q=0;q<typesData.length;q++) {
          					if (typesData[q].getTypeName().getLocalPart().equals(parRequest[s].getType()))
          						if (typesData[q].isArray()) {
          							typeIsAnArray=true;
          							retTypeArrayType=typesData[q].getArrayType();
          							
          					}
          				}
          				if (!typeIsAnArray) {
          					String type=this.getJavaType(parRequest[s].getType(),parRequest[s].getNameSpace());
        					fw7.write(type);
        					
      			  		}
        				else {
        					String typeTemp=this.getJavaType(retTypeArrayType);
        					String type=typeTemp+"[]";
        					fw7.write(type);
        						
        				}		
        				fw7.write(" ");
        				fw7.write(parRequest[s].getName());
        				if (s!=(parRequest.length-1))
        						fw7.write(", ");  
        			}//end for (int s=0;s<parRequest.length;s++)
	       			//end array recognition mechanism
      		 	
       		 	        if ((parResponse.length>0)&&(parRequest.length>0))
       		 	        	fw7.write(", ");
        				
        	    	
          		 	for (int s=0;s<parResponse.length;s++) {
             						
             			             				
             				//holderType is the name of the class that implements the holder
             				String holderType=this.getJavaTypeHolder(parResponse[s].getType(),parResponse[s].getNameSpace());
        				
        				//holderTypeValue is the name of the type contained in the holder
        				String holderValueType=this.getJavaType(parResponse[s].getType(),parResponse[s].getNameSpace());
        				
        				//array type recognition mechanism
        				boolean typeIsAnArray=false;
        				QName arrayHoldType=null;
        				String arrayHoldTypeStr=null;
        				
        				for (int q=0;q<typesData.length;q++) {
        					if (typesData[q].getTypeName().getLocalPart().equals(parResponse[s].getType())) 
        						if (typesData[q].isArray()) {
        							typeIsAnArray=true;
        							arrayHoldType=typesData[q].getArrayType();
        							arrayHoldTypeStr=getJavaType(arrayHoldType);
        							//System.out.println(typesData[q].getTypeName().getLocalPart()+" is an array");
        						} else {
        							typeIsAnArray=false;
        							//System.out.println(typesData[q].getTypeName().getLocalPart()+" is not an array");
        						}
        					}
        				        				
        				//PLEASE NOTE
        		        	//if the holder is not a standand java holder, in other words if
        				//it is not present in the javax.xml.rpc.holders package, a class 
        				//for this holder must be generated.
        				//
        				//Here in a sense we *request* the generation of these holders for user-defined types
        				//
        				if (debug)
        					System.out.println(holderType+" is a standard Holder?"+isAStandardHolder(holderType));
        				if (!isAStandardHolder(holderType)) {
        					HolderData holderDataItem=new HolderData();
        					holderDataItem.setHolderName(holderType);
        					holderDataItem.setHolderType(holderValueType);
        					holderDataItem.setIsArray(typeIsAnArray);
        					holderDataItem.setArrayType(arrayHoldTypeStr);
        					//holderDataVector.add(holderDataItem);
        				}//end if (!isAStandardHolder(holderType))
        				
        				fw7.write(holderType+" ");
        				fw7.write(parResponse[s].getName());
        				if (s!=(parResponse.length-1))
        					fw7.write(", ");
        						
        				
        			}
        				
               	}
        	
        	fw7.write(")");
        	
        	//managing exception...
        	
        	//"standard exception" java.rmi.RemoteException
        	fw7.write(" throws ");
        	fw7.write("java.rmi.RemoteException");
        		
		//user-defined exception
		if (exceptions!=null) {
			for (int i=0;i<exceptions.length;i++) {
			
			String exceptionName=exceptions[i].getName();
			
			fw7.write(",");
			fw7.write(packageName);
			fw7.write(".");
			fw7.write(firstLetterToUpperCase(exceptionName));
			
			}
		}//end if (exceptions!=null)
			
		//generating method body
                //Rafik add               
                //if return is boolean
                boolean bool = false; 
                if ((parResponse!=null)&&(parResponse.length==1)) {
		//if (parResponse != null) {
		    String type=this.getJavaType(parResponse[0].getType(),parResponse[0].getNameSpace());
		    
                     if(type != null && type.equals("boolean")){
			fw7.write(" {");
			fw7.write("\n\t\treturn false;");
			fw7.write("\n\t}");
                        bool = true;
		     }
		     if(type != null && type.equals("int")){
			fw7.write(" {");
			fw7.write("\n\t\treturn -1;");
			fw7.write("\n\t}");
                        bool = true;
		     }
		}
                
		    if (!bool){ 
			if (returnNull) {
			    fw7.write(" {");
			    fw7.write("\n\t\treturn null;");
			    fw7.write("\n\t}");
			}
			else {
			    fw7.write(" {");
			    fw7.write("\n\t\treturn;");
			    fw7.write("\n\t}");
			}
		    }
		
		   	        
        	fw7.write("\n");
        }//end for (int k=0;k<opData.length;k++)
        	
        //Closing implementation file declaration
        fw7.write("\n}");
              

	
	fw7.close();
	}
	catch (Exception e) {
		e.printStackTrace();
	}
	
	
        //*************************************************  		
	//10th phase - generation of the WSDD undeploy file
	//*************************************************
	
        //Creation of the directory for the interface file
        //it's the same of wsdd file...
        //String javaTypeDef=getJavaType(def.getQName());
        //String packageName=getPackageName(javaTypeDef);

        //defining interface directoryname
        //String interfaceDirName=new String(packageName);

        //Creation of the directory for generated files
        //File dir=new File(dirName+fileSeparator+interfaceDirName);
        //dir.mkdir();        
             
                        
        try{  
                       
            if (!generateClientFilesOnly) {
          
           
                //Creation of the WSDD undeployment file
                FileWriter fw8=new FileWriter(dirName+fileSeparator+interfaceDirName+fileSeparator+"undeploy.wsdd");
            
                //Generating initial comments 
                fw8.write("\n <!-- Undeployment file -->");
                fw8.write("\n <!-- This file was auto-generated from WSDL file --> ");
                fw8.write("\n <!-- using Generator class developed by Mirco Musolesi at INRIA Rocquencourt -->");
                fw8.write("\n");
                fw8.write("<wsdd>");
                fw8.write("\n\t<undeploy>");
                fw8.write("\n\t\t<service name=");
                fw8.write('"');
                fw8.write(serviceName);
                fw8.write('"');
                fw8.write("/>");
                fw8.write("\n\t</undeploy>");
                fw8.write("\n</wsdd>");
                fw8.close();
            }//end if
        }
        catch (Exception e) {
                e.printStackTrace();
        }
            
	
	//********************************************
        //11th phase: creation of a generation report
        //********************************************
        
	try {		
			
		//Creating a generation report
		if (debug) {
		    //System.out.println("Generation summary:");
			//wsdd file generation report
			if (!generateClientFilesOnly)
				//System.out.println("The file "+dirName+fileSeparator+interfaceDirName+fileSeparator+"deploy.wsdd"+" has been created.");
			
			//interface java file report
			    //	System.out.println("The file "+dirName+fileSeparator+interfaceDirName+fileSeparator+interfaceFileName+" has been created."); 
	   			   		
			//types java files report
			for (int k=0;k<typesData.length;k++) 
				if (typesData[k].isComplex()) {
					String path=package2Path(resultTypePackageName[k]);
				//	System.out.println ("The file "+dirName+fileSeparator+path+fileSeparator+typesData[k].getTypeName().getLocalPart()+".java has been created.");
				}
				
			//holder types java files report
			for (int t=0;t<holderDataArray.length;t++) {
				String path=package2Path(holderDataArray[t].getHolderName());
				//System.out.println("The file "+dirName+fileSeparator+path+fileSeparator+holderDataArray[t].getHolderClassName()+".java"+" has been created.");
			}
			
			//exceptions files report
			for (int k=0;k<resultEx.length;k++) {
			    //	System.out.println("The file "+dirName+fileSeparator+exceptionsDirName+fileSeparator+resultExName[k]+".java"+" has been created.");
			}
			
			//stub file report
			//System.out.println("The file "+dirName+fileSeparator+stubDirName+fileSeparator+stubFileName+" has been created.");
			
			//implementation file report
			//	System.out.println("The file "+dirName+fileSeparator+interfaceDirName+implementationFileName+" has been created.");
						
			//undeploy file
                        //if (!generateClientFilesOnly)
				//System.out.println("The file "+dirName+fileSeparator+interfaceDirName+fileSeparator+"deploy.wsdd"+" has been created.");
                        
			//	System.out.println("\n\n*************************************************************");
			//	System.out.println("\n");
				
		}
		//Generation ok...so
		return true;
	
	}
	catch (Exception e) {
		if (debug) {
			e.printStackTrace();
			//System.out.println("Generation summary:\n");
			//System.out.println("Error during the generation process.");
			//System.out.println("\n\n*************************************************************");
		}
		return false;
	}
	
	
	
}// end try
catch (Exception e) {
		e.printStackTrace();
		return false;
	}


 }


    private static void printUsage() {
			System.err.println("Error before generation.");
			System.err.println("Incorrect use of parameters.");      			
        		System.err.println("Usage Generator");
        		System.err.println("-n WSDLfileName");
        		System.err.println("-s side");
        		System.err.println("   	-s c for client side generation only");
        		System.err.println("   	-s s for server side generation only");
        		System.err.println("-v verbose");
        		System.err.println("-d directory for generated files");
        		System.err.println("-c implClass parameter");
        		System.err.println("-h help");
        		
        }
	
	//main
	public static void main (String args[]) {
		Generator generator=new Generator();
		String fileName=new String("");
		boolean parametersOK=true;
		String side=new String("a"); //a stands for all (client and server generation)
        	boolean verbose=false;
        	String dirName=new String ("generatedFiles");
        	String implClass=new String ("implClass");
        	
        	
        	try {
        		int k=0;
        		while (k<args.length) {
        		
        			//checking if this a valid option
        			if ((!args[k].equals("-h"))&&
				    (!args[k].equals("-n"))&&
				    (!args[k].equals("-s"))&&
				    (!args[k].equals("-v"))&&
				    (!args[k].equals("-d"))&&
				    (!args[k].equals("-c"))) {
					printUsage();
        				System.exit(-4);
        			}
        			
        			//processing help parameter
        			if (args[k].equals("-h")) {
					printUsage();
        				k++;     		     
        			}
        			
       		 		//processing wsdl name file parameter
        			if (args[k].equals("-n")) {
        				fileName=args[k+1];
        				k=k+2;
        			}
        			
        			//processing side parameter
        			else if (args[k].equals("-s")) {
        				if (args[k+1].equals("s"))
        					side="s";
        				if (args[k+1].equals("c"))
        					side="c";
  			      		k=k+2;
        			}
        		
        			//processing verbose parameter
  		      		else if (args[k].equals("-v")) {
        				verbose=true;
        				k++;
        			}
        		
        			//processing dirName parameter
        			else if (args[k].equals("-d")) {
        				dirName=args[k+1];
        				k=k+2;
        			}
        		
        			//processing implClass parameter
        			else if (args[k].equals("-c")) {
        				implClass=args[k+1];
        				k=k+2;
        			}
        			
        			
        			        			
        		} //end while
        		        		

                
                }//end try
                catch (Exception e) {
               		printUsage();
               		System.exit(-4);
                	
                }
		try {
		        //last checking before generation
        		if (fileName.equals("")) {
        			parametersOK=false;
        			System.err.println ("-n fileName parameter is compulsory");
        		}
        		
        		if (parametersOK) {
        			generator.generate(fileName,side,verbose,dirName,implClass,"application");
                	} 
		
		
		
		}
		catch (Exception e) {
			System.err.println("Error during the generation process.");
			e.printStackTrace();
		}                
                
                
                
                
                
       }//end main



}//end class Generator
