package csoap.xml.rpc.encoding;

import csoap.xml.soap.*;
import java.lang.*;
import java.util.Vector;
import java.util.Iterator;
import java.lang.reflect.Array;
import javax.xml.namespace.QName;
import javax.xml.rpc.encoding.XMLType;

public class DeserializerArrayType implements DeserializerBase
{
  Vector JAVATypes = new Vector();
  String mechanismType="default";
  Integer dim;
  javax.xml.rpc.encoding.TypeMapping  typeMapping ;
  DeserializerBase deserializer;
  javax.xml.rpc.encoding.DeserializerFactory deserializerFactory;
  String typeDim;
  String prefix ="",type ="",uri ="";
  QName xmlType;
  Mapping mapping = new Mapping();


  public DeserializerArrayType()
  {
  JAVATypes.addElement(int.class);
  JAVATypes.addElement(boolean.class);
  JAVATypes.addElement(byte.class);
  JAVATypes.addElement(java.math.BigDecimal.class);
  JAVATypes.addElement(double.class);
  JAVATypes.addElement(float.class);
  JAVATypes.addElement(Integer.class);
  JAVATypes.addElement(long.class);
  JAVATypes.addElement(javax.xml.namespace.QName.class);
  JAVATypes.addElement(short.class);
  JAVATypes.addElement(String.class);
  JAVATypes.addElement(Object.class);
  }
  public void setMechanismType(String MechanismType)
  {
    mechanismType = MechanismType;
  }
  public String getMechanismType()
  {
    return mechanismType;
  }
  public Object deserialize(javax.xml.soap.SOAPElement soAPElement, javax.xml.rpc.encoding.TypeMappingRegistry typeMappingRegistry, csoap.deployment.Service service)
  {
    SOAPElementImpl sOAPElement =(SOAPElementImpl)soAPElement;
    Object objArray=null;
    typeDim = sOAPElement.getAttributeValue(new NameImpl("arrayType"));
    dim = new Integer(typeDim.substring(typeDim.indexOf("[")+1,typeDim.indexOf("]")));
    type = typeDim;
    if (typeDim.indexOf(":") != -1)
    {
      prefix = typeDim.substring(0, typeDim.indexOf(":"));
      type = typeDim.substring(typeDim.indexOf(":") + 1,typeDim.indexOf("["));
      uri = sOAPElement.getNamespaceURI(prefix);
    }
    xmlType = QName.valueOf("{"+uri+"}"+type);
    String result ="";
    Iterator childs = sOAPElement.getChildElements();
    int i = 0;

    javax.xml.soap.SOAPElement child = null;
      if (JAVATypes.indexOf(mapping.getType(xmlType)) == 0 )
      {
        objArray = new int[dim.intValue()];
        for (i = 0; i < dim.intValue(); i++)
        {
          child = (javax.xml.soap.SOAPElement)childs.next();
          Integer resultInteger = new Integer(child.getValue());
          Array.setInt(objArray,i,resultInteger.intValue());
        }
      }
      else
      {
      switch (JAVATypes.indexOf(mapping.getType(xmlType)))
      {
        case 1: objArray = new boolean[dim.intValue()];break;
        case 2: objArray = new byte[dim.intValue()];break;
        case 3: objArray = new java.math.BigDecimal[dim.intValue()];break;
        case 4: objArray = new double[dim.intValue()];break;
        case 5: objArray = new float[dim.intValue()];break;
        case 6: objArray = new Integer[dim.intValue()];break;
        case 7: objArray = new long[dim.intValue()];break;
        case 8: objArray = new javax.xml.namespace.QName[dim.intValue()];break;
        case 9: objArray = new short[dim.intValue()];break;
        case 10: objArray = new String[dim.intValue()];break;
        case 11: objArray = new Object[dim.intValue()];break;
        
        default : csoap.deployment.typeMappingDeployed typeDeploy = service.getTypeMapping(xmlType);
                  
                  String classString = typeDeploy.getType();
                  try
                  {
                  Class classElementArray = Class.forName(classString);
                  objArray = Array.newInstance(classElementArray, dim.intValue());
                  }
                  catch(Exception e)
                  {
                   System.out.println(classString+ " : Not Exist"); 
                  }

      }
          for (i = 0; i < dim.intValue(); i++)
          {
            child = (javax.xml.soap.SOAPElement)childs.next();
            
            child = Reference.getSOAPElementForDeserialiser(child);            
            // handles only array of simple types
            // to introduce the handling of complex type arrays
            // the child.getValue() must be replaced with 
            // the recursive retrieving of the content of 
            // the complex value
            typeMapping = typeMappingRegistry.getTypeMapping(xmlType.getNamespaceURI());
            deserializerFactory = typeMapping.getDeserializer(null,xmlType);
            deserializer = (DeserializerBase)deserializerFactory.getDeserializerAs("default");
            Array.set(objArray, i, deserializer.deserialize(child,typeMappingRegistry, service));

            
          }
        }
    return objArray;
  }

}
