package csoap.xml.rpc.encoding;

import javax.xml.rpc.encoding.*;
import java.util.*;
import javax.xml.namespace.QName;

public class DeserializerBase64Factory implements DeserializerFactory{

Vector deserializers = new Vector();
Vector mechanismTypes = new Vector();

public DeserializerBase64Factory(Class JavaClass,  QName XmlType)
{
    this.addDeserializer(new DeserializerBase64(JavaClass, XmlType));
}

public DeserializerBase64Factory()
{
    this.addDeserializer(new DeserializerBase64(byte[].class, javax.xml.rpc.encoding.XMLType.XSD_BASE64));
}
public Deserializer getDeserializerAs(String mechanismType)
{
  return (Deserializer)deserializers.elementAt(mechanismTypes.indexOf(mechanismType));
}

public Iterator getSupportedMechanismTypes()
{
  return mechanismTypes.iterator();
}

public void addDeserializer(Deserializer newDeserializer)
{
 deserializers.addElement(newDeserializer);
 mechanismTypes.addElement(newDeserializer.getMechanismType());
}

}
