package csoap.xml.rpc.encoding;

import csoap.xml.soap.*;
import javax.xml.namespace.QName;
import javax.xml.soap.Name;
import java.text.SimpleDateFormat;
import java.util.TimeZone;
import javax.xml.rpc.encoding.TypeMappingRegistry;

public class SerializerSimpleType implements SerializerBase {
    
    String mechanismType="default";
    QName XMLType = null;
    Class JAVAType = null;

    private static SimpleDateFormat zulu =
       new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'");
                         //  0123456789 0 123456789

    static {
        zulu.setTimeZone(TimeZone.getTimeZone("GMT"));
    }

  
    public SerializerSimpleType(Class jAVAType,QName xMLType) 
    {
	XMLType = xMLType;
        JAVAType = jAVAType;
    }
    
    public String getMechanismType() {
        return mechanismType;
    }
    
    public javax.xml.soap.SOAPElement serialize(Object obj, Name name, javax.xml.soap.SOAPElement SOAPParent, TypeMappingRegistry typeMappingRegistry) {
	
	 // CASTING OF JAX-RPC ON CSOAP CLASS IMPLEMENTATION
	//csoap.xml.rpc.encoding.TypeMappingRegistryImpl typeMappingRegistry2 = (csoap.xml.rpc.encoding.TypeMappingRegistryImpl)typeMappingRegistry;

	csoap.xml.soap.SOAPElementImpl SOAPParent2 = (csoap.xml.soap.SOAPElementImpl)SOAPParent; 
	
	SOAPElementImpl forReturn = new SOAPElementImpl((NameImpl)name);
	String pre = null;
	if (SOAPParent2 != null) pre =  SOAPParent2.getPrefixOf(XMLType.getNamespaceURI());
	if (pre != null && !pre.equals(""))
	    {
		forReturn.addAttribute(new NameImpl("type", "xsi"),pre + ":" + XMLType.getLocalPart()); 
	    }
       else 
	   { 
	       forReturn.addAttribute(new NameImpl("type", "xsi"), "nse:" + XMLType.getLocalPart());
	       forReturn.addNamespaceDeclaration("nse",XMLType.getNamespaceURI());
	   }
	
	if (obj != null)
	    {   // if JAVA CLASS NOT java.util.Calendar use Obj.toString
		// else specifique serialisation for calendar
		if (!JAVAType.getName().equals(java.util.Calendar.class.getName()))  forReturn.addTextNode(obj.toString());
		else // Calendar serialisation
		    {
			java.util.Calendar obj2 = (java.util.Calendar)obj;
			java.util.Date date = obj2.getTime(); 
                        forReturn.addTextNode(zulu.format(date));
			//forReturn.addTextNode(objetDate.toString());
		    }
	    }
	else forReturn.addAttribute(new NameImpl("nil", "xsi"), "true");
                                 
	
	return forReturn;
    }
    
    public void setMechanismType(String MechanismType) {
        mechanismType = MechanismType;
    }
}
