package csoap.xml.rpc.encoding;

import javax.xml.rpc.encoding.*;
import java.util.Vector;
import javax.xml.namespace.QName;


public class TypeMappingRegistryImpl implements TypeMappingRegistry {


    //boolean isBigDecimalSupported = false;
    Vector typeMappings = new Vector();
    Vector encodingStyles = new Vector();
    public Vector xmlTypes = new Vector();
    public Vector javaTypes = new Vector();    
   
    
    
    
    public TypeMappingRegistryImpl() 
    {
        //http://schemas.xmlsoap.org/soap/encoding/
        TypeMappingImpl typeMapping = new TypeMappingImpl();
        //simple type

        typeMapping.register(Integer.class, XMLType.SOAP_INT,new SerializerSimpleTypeFactory(Integer.class, XMLType.SOAP_INT),new DeserializerSimpleTypeFactory(Integer.class, XMLType.SOAP_INT));
        addMapping(Integer.class, XMLType.SOAP_INT);
	
        typeMapping.register(String.class, XMLType.SOAP_STRING,new SerializerSimpleTypeFactory(String.class, XMLType.SOAP_STRING),new DeserializerSimpleTypeFactory(String.class, XMLType.SOAP_STRING));
        addMapping(String.class, XMLType.SOAP_STRING);
	
        typeMapping.register(java.lang.Boolean.class,XMLType.SOAP_BOOLEAN,new SerializerSimpleTypeFactory(java.lang.Boolean.class,XMLType.SOAP_BOOLEAN),new DeserializerSimpleTypeFactory(java.lang.Boolean.class,XMLType.SOAP_BOOLEAN));
        addMapping(java.lang.Boolean.class,XMLType.SOAP_BOOLEAN);
	
        typeMapping.register(java.lang.Byte.class,XMLType.SOAP_BYTE,new SerializerSimpleTypeFactory(java.lang.Byte.class,XMLType.SOAP_BYTE),new DeserializerSimpleTypeFactory(java.lang.Byte.class,XMLType.SOAP_BYTE));
	addMapping(java.lang.Byte.class,XMLType.SOAP_BYTE);
	
        typeMapping.register(java.lang.Double.class,XMLType.SOAP_DOUBLE,new SerializerSimpleTypeFactory(java.lang.Double.class,XMLType.SOAP_DOUBLE),new DeserializerSimpleTypeFactory(java.lang.Double.class,XMLType.SOAP_DOUBLE));
	addMapping(java.lang.Double.class,XMLType.SOAP_DOUBLE);
	
        typeMapping.register(float.class,XMLType.SOAP_FLOAT,new SerializerSimpleTypeFactory(float.class,XMLType.SOAP_FLOAT),new DeserializerSimpleTypeFactory(float.class,XMLType.SOAP_FLOAT));
	addMapping(float.class,XMLType.SOAP_FLOAT);
	
        typeMapping.register(java.lang.Long.class,XMLType.SOAP_LONG,new SerializerSimpleTypeFactory(java.lang.Long.class,XMLType.SOAP_LONG),new DeserializerSimpleTypeFactory(java.lang.Long.class,XMLType.SOAP_LONG));
	addMapping(java.lang.Long.class,XMLType.SOAP_LONG);
	
        typeMapping.register(java.lang.Short.class,XMLType.SOAP_SHORT,new SerializerSimpleTypeFactory(java.lang.Short.class,XMLType.SOAP_SHORT),new DeserializerSimpleTypeFactory(java.lang.Short.class,XMLType.SOAP_SHORT));
	addMapping(java.lang.Short.class,XMLType.SOAP_SHORT);

	/// ARRAY TYPE 

	typeMapping.register(null, XMLType.SOAP_ARRAY,new SerializerArrayFactory(null, XMLType.SOAP_ARRAY),new DeserializerArrayFactory(null, XMLType.SOAP_ARRAY));
	addMapping(null, XMLType.SOAP_ARRAY);


	// array type
	/*
        typeMapping.register(int[].class, XMLType.SOAP_ARRAY,);
	addMapping(int[].class, XMLType.SOAP_ARRAY);
	
        typeMapping.register(String[].class, XMLType.SOAP_ARRAY, );
	addMapping(String[].class, XMLType.SOAP_ARRAY);
	
	typeMapping.register(boolean[].class,XMLType.SOAP_ARRAY,);
	addMapping(boolean[].class,XMLType.SOAP_ARRAY);
	
	typeMapping.register(byte[].class,XMLType.SOAP_ARRAY,);
	addMapping(byte[].class,XMLType.SOAP_ARRAY);
	
	typeMapping.register(double[].class,XMLType.SOAP_ARRAY,);
	addMapping(double[].class,XMLType.SOAP_ARRAY);
	
	typeMapping.register(float[].class,XMLType.SOAP_ARRAY,);
	addMapping(float[].class,XMLType.SOAP_ARRAY);
	
	typeMapping.register(long[].class,XMLType.SOAP_ARRAY,);
	addMapping(long[].class,XMLType.SOAP_ARRAY);
	
        typeMapping.register(short[].class,XMLType.SOAP_ARRAY,);
	addMapping(short[].class,XMLType.SOAP_ARRAY);
	*/
        // typeMapping.register();
        String encod[] = new String[1];
        encod[0] = "http://schemas.xmlsoap.org/soap/encoding/";
        typeMapping.setSupportedEncodings(encod);
        this.register("http://schemas.xmlsoap.org/soap/encoding/", typeMapping);
	
	
	//http://www.w3.org/2001/XMLSchema
        typeMapping = new TypeMappingImpl();
        // simple type
        typeMapping.register(int.class, XMLType.XSD_INT,new SerializerSimpleTypeFactory(int.class, XMLType.XSD_INT),new DeserializerSimpleTypeFactory(int.class, XMLType.XSD_INT));
	addMapping(int.class, XMLType.XSD_INT);
	
        typeMapping.register(String.class, XMLType.XSD_STRING,new SerializerSimpleTypeFactory(String.class, XMLType.XSD_STRING),new DeserializerSimpleTypeFactory(String.class, XMLType.XSD_STRING));
	addMapping(String.class, XMLType.XSD_STRING);
	
	typeMapping.register(boolean.class,XMLType.XSD_BOOLEAN,new SerializerSimpleTypeFactory(boolean.class,XMLType.XSD_BOOLEAN),new DeserializerSimpleTypeFactory(boolean.class,XMLType.XSD_BOOLEAN));
	addMapping(boolean.class,XMLType.XSD_BOOLEAN);
	
	typeMapping.register(byte.class,XMLType.XSD_BYTE,new SerializerSimpleTypeFactory(byte.class,XMLType.XSD_BYTE),new DeserializerSimpleTypeFactory(byte.class,XMLType.XSD_BYTE));
	addMapping(byte.class,XMLType.XSD_BYTE);

        typeMapping.register(double.class,XMLType.XSD_DOUBLE,new SerializerSimpleTypeFactory(double.class,XMLType.XSD_DOUBLE),new DeserializerSimpleTypeFactory(double.class,XMLType.XSD_DOUBLE));
	addMapping(double.class,XMLType.XSD_DOUBLE);
  
	typeMapping.register(float.class,XMLType.XSD_FLOAT,new SerializerSimpleTypeFactory(float.class,XMLType.XSD_FLOAT),new DeserializerSimpleTypeFactory(float.class,XMLType.XSD_FLOAT));
	addMapping(float.class,XMLType.XSD_FLOAT);
  
        typeMapping.register(long.class,XMLType.XSD_LONG,new SerializerSimpleTypeFactory(long.class,XMLType.XSD_LONG),new DeserializerSimpleTypeFactory(long.class,XMLType.XSD_LONG));
	addMapping(long.class,XMLType.XSD_LONG);

        typeMapping.register(short.class,XMLType.XSD_SHORT,new SerializerSimpleTypeFactory(short.class,XMLType.XSD_SHORT),new DeserializerSimpleTypeFactory(short.class,XMLType.XSD_SHORT));
	addMapping(short.class,XMLType.XSD_SHORT);

        typeMapping.register(java.math.BigInteger.class,XMLType.XSD_INTEGER,new SerializerSimpleTypeFactory(java.math.BigInteger.class,XMLType.XSD_INTEGER),new DeserializerSimpleTypeFactory(java.math.BigInteger.class,XMLType.XSD_INTEGER));
	addMapping(java.math.BigInteger.class,XMLType.XSD_INTEGER);

        typeMapping.register(javax.xml.namespace.QName.class,XMLType.XSD_QNAME,new SerializerSimpleTypeFactory(javax.xml.namespace.QName.class,XMLType.XSD_QNAME),new DeserializerSimpleTypeFactory(javax.xml.namespace.QName.class,XMLType.XSD_QNAME));
	addMapping(javax.xml.namespace.QName.class,XMLType.XSD_QNAME);

        typeMapping.register(java.util.Calendar.class,XMLType.XSD_DATETIME,new SerializerSimpleTypeFactory(java.util.Calendar.class,XMLType.XSD_DATETIME),new DeserializerSimpleTypeFactory(java.util.Calendar.class,XMLType.XSD_DATETIME));
	addMapping(java.util.Calendar.class,XMLType.XSD_DATETIME);

	//*************************************************************
	//COMMENT ADD FOR SUPPORT BIGDECIMAL WITH CVM
	//*************************************************************
	//	if (isBigDecimalSupported)
	//   {	       
	// typeMapping.register(java.math.BigDecimal.class,XMLType.XSD_DECIMAL,new SerializerSimpleTypeFactory(java.math.BigDecimal.class,XMLType.XSD_DECIMAL),new DeserializerSimpleTypeFactory(java.math.BigDecimal.class,XMLType.XSD_DECIMAL));
	//     addMapping(java.math.BigDecimal.class,XMLType.XSD_DECIMAL);
	       
	       
	       //	   }
	       //	else
	       // {
	       //	typeMapping.register(java.lang.Double.class,XMLType.XSD_DECIMAL,new SerializerSimpleTypeFactory(java.lang.Double.class,XMLType.XSD_DECIMAL),new DeserializerSimpleTypeFactory(java.lang.Double.class,XMLType.XSD_DECIMAL));
	       //	addMapping(java.lang.Double.class,XMLType.XSD_DECIMAL);   
	       // }      
	       
	       typeMapping.register(byte[].class,XMLType.XSD_BASE64,new SerializerBase64Factory(byte[].class,XMLType.XSD_BASE64),new DeserializerBase64Factory(byte[].class,XMLType.XSD_BASE64));
	       addMapping(byte[].class,XMLType.XSD_BASE64);




       encod[0] = "http://www.w3.org/2001/XMLSchema";
       typeMapping.setSupportedEncodings(encod);
       this.register("http://www.w3.org/2001/XMLSchema", typeMapping);
       


        //http://www.w3.org/1999/XMLSchema
        typeMapping = new TypeMappingImpl();

        // simple type
        typeMapping.register(int.class, qnameXML1999("int"),new SerializerSimpleTypeFactory(int.class, qnameXML1999("int")),new DeserializerSimpleTypeFactory(int.class, qnameXML1999("int")));
	addMapping(int.class, qnameXML1999("int"));

        typeMapping.register(String.class, qnameXML1999("string"),new SerializerSimpleTypeFactory(String.class, qnameXML1999("string")),new DeserializerSimpleTypeFactory(String.class, qnameXML1999("string")));
	addMapping(String.class, qnameXML1999("string"));

        typeMapping.register(boolean.class,qnameXML1999("boolean"),new SerializerSimpleTypeFactory(boolean.class,qnameXML1999("boolean")),new DeserializerSimpleTypeFactory(boolean.class,qnameXML1999("boolean")));
	addMapping(boolean.class,qnameXML1999("boolean"));

        typeMapping.register(byte.class,qnameXML1999("byte"),new SerializerSimpleTypeFactory(byte.class,qnameXML1999("byte")),new DeserializerSimpleTypeFactory(byte.class,qnameXML1999("byte")));
	addMapping(byte.class,qnameXML1999("byte"));

        typeMapping.register(double.class,qnameXML1999("double"),new SerializerSimpleTypeFactory(double.class,qnameXML1999("double")),new DeserializerSimpleTypeFactory(double.class,qnameXML1999("double")));
	addMapping(double.class,qnameXML1999("double"));

        typeMapping.register(float.class,qnameXML1999("float"),new SerializerSimpleTypeFactory(float.class,qnameXML1999("float")),new DeserializerSimpleTypeFactory(float.class,qnameXML1999("float")));
	addMapping(float.class,qnameXML1999("float"));

        typeMapping.register(long.class,qnameXML1999("long"),new SerializerSimpleTypeFactory(long.class,qnameXML1999("long")),new DeserializerSimpleTypeFactory(long.class,qnameXML1999("long")));
	addMapping(long.class,qnameXML1999("long"));

        typeMapping.register(short.class,qnameXML1999("short"),new SerializerSimpleTypeFactory(short.class,qnameXML1999("short")),new DeserializerSimpleTypeFactory(short.class,qnameXML1999("short")));
	addMapping(short.class,qnameXML1999("short"));

        typeMapping.register(java.math.BigInteger.class,qnameXML1999("integer"),new SerializerSimpleTypeFactory(java.math.BigInteger.class,qnameXML1999("integer")),new DeserializerSimpleTypeFactory(java.math.BigInteger.class,qnameXML1999("integer")));
	addMapping(java.math.BigInteger.class,qnameXML1999("integer"));

        typeMapping.register(String.class,qnameXML1999("QName"),new SerializerSimpleTypeFactory(String.class,qnameXML1999("QName")),new DeserializerSimpleTypeFactory(String.class,qnameXML1999("QName")));
	addMapping(String.class,qnameXML1999("QName"));

        typeMapping.register(java.util.Calendar.class,qnameXML1999("dateTime"),new SerializerSimpleTypeFactory(java.util.Calendar.class,qnameXML1999("dateTime")),new DeserializerSimpleTypeFactory(java.util.Calendar.class,qnameXML1999("dateTime")));
	addMapping(java.util.Calendar.class,qnameXML1999("dateTime"));

	//*************************************************************
	//COMMENT ADD FOR SUPPORT BIGDECIMAL WITH CVM
	//*************************************************************
	//if (isBigDecimalSupported)
	//    {
	//	typeMapping.register(java.math.BigDecimal.class,qnameXML1999("decimal"),new SerializerSimpleTypeFactory(java.math.BigDecimal.class,qnameXML1999("decimal")),new DeserializerSimpleTypeFactory(java.math.BigDecimal.class,qnameXML1999("decimal")));
	//	addMapping(java.math.BigDecimal.class,qnameXML1999("decimal"));
		//   }
		//	else
		// {
		//	typeMapping.register(java.lang.Double.class,qnameXML1999("decimal"),new SerializerSimpleTypeFactory(java.lang.Double.class,qnameXML1999("decimal")),new DeserializerSimpleTypeFactory(java.lang.Double.class,qnameXML1999("decimal")));
		//	addMapping(java.lang.Double.class,qnameXML1999("decimal"));
		// }
  
		typeMapping.register(byte[].class,qnameXML1999("base64Binary"),new SerializerBase64Factory(byte[].class,qnameXML1999("base64Binary")),new DeserializerBase64Factory(byte[].class,qnameXML1999("base64Binary")));
	addMapping(byte[].class,qnameXML1999("base64Binary"));

        encod[0] = "http://www.w3.org/1999/XMLSchema";
        typeMapping.setSupportedEncodings(encod);
        this.register("http://www.w3.org/1999/XMLSchema", typeMapping);
    }
    
    private QName qnameXML1999(String type) {
        String ns = "http://www.w3.org/1999/XMLSchema";
        return new QName(ns,type);
    }
    
    public TypeMapping register(String encodingStyle, TypeMapping typeMapping) {
        encodingStyles.addElement(encodingStyle);
        typeMappings.addElement(typeMapping);
        return typeMapping;
    }
    
    public void registerDefault(TypeMapping typeMapping) {
        encodingStyles.insertElementAt("Default",0);
        typeMappings.insertElementAt(typeMapping,0);
    }
    
    public TypeMapping getDefaultTypeMapping() {
        if (typeMappings.size()>0) 
            return (TypeMapping)typeMappings.elementAt(0);
        return null;
    }
    
    public String[] getRegisteredEncodingStyleURIs() {
        String[] forReturn = new String[encodingStyles.size()];
        for(int i=0;i<forReturn.length;i++) 
            forReturn[i] = (String)encodingStyles.elementAt(i);
        return forReturn;
    }
    
    public TypeMapping getTypeMapping(String encodingStyleURI) {
      /*
for (int i=0; i<encodingStyles.size(); i++)
    System.out.println("encodingstyle="+encodingStyles.get(i).toString());
for (int i=0; i<typeMappings.size(); i++)
    System.out.println("typeMappings="+typeMappings.get(i).toString());
*/

        if (encodingStyles.indexOf(encodingStyleURI)!=-1) 
            return (TypeMapping)typeMappings.elementAt(encodingStyles.indexOf(encodingStyleURI));
        return null;
    }

    public TypeMapping createTypeMapping() {
        return new TypeMappingImpl();
    }
    
    public TypeMapping unregisterTypeMapping(String encodingStyleURI) {
        int index = encodingStyles.indexOf(encodingStyleURI);
        TypeMappingImpl typeMapping = (TypeMappingImpl)typeMappings.elementAt(index);
        encodingStyles.removeElementAt(index);
        typeMappings.removeElementAt(index);
        return typeMapping;
    }

    public boolean removeTypeMapping(TypeMapping typeMapping) {
        int index = typeMappings.indexOf(typeMapping);
        if ( index !=-1) {
            encodingStyles.removeElementAt(index);
            typeMappings.removeElementAt(index);
            return true;
        }
        return false;
    }
    
    public void clear() {
        encodingStyles.removeAllElements();
        typeMappings.removeAllElements();
    }

    public void addMapping(Class javaClass, QName xmlType)
    {   
	javaTypes.addElement(javaClass);
        xmlTypes.addElement(xmlType);
    }
   
    public Class getJavaClass(QName xmlType)
    {
        if (xmlTypes.indexOf(xmlType) !=-1) return (Class)javaTypes.elementAt(xmlTypes.indexOf(xmlType));
        System.out.println("XMLType : "+xmlType+ " not found in registry");
        return null; 
    }  

    public QName getXMLType(Class javaClass)
    {
	if (javaTypes.indexOf(javaClass) !=-1) return (QName)xmlTypes.elementAt(javaTypes.indexOf(javaClass));
        System.out.println("Class : "+javaClass.getName()+ " not found in registry");
	return null; 
    }  
   
}
